/* A Bison parser, made by GNU Bison 3.7.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 1

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         OCTAVE_STYPE
/* Substitute the variable and function names.  */
#define yyparse         octave_parse
#define yypush_parse    octave_push_parse
#define yypull_parse    octave_pull_parse
#define yypstate_new    octave_pstate_new
#define yypstate_clear  octave_pstate_clear
#define yypstate_delete octave_pstate_delete
#define yypstate        octave_pstate
#define yylex           octave_lex
#define yyerror         octave_error
#define yydebug         octave_debug
#define yynerrs         octave_nerrs

/* First part of user prologue.  */
#line 30 "../libinterp/parse-tree/oct-parse.yy"


#define YYDEBUG 1

#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif

#include <cassert>
#include <cstdio>
#include <cstdlib>

#include <iostream>
#include <map>
#include <sstream>

#include "Matrix.h"
#include "cmd-edit.h"
#include "cmd-hist.h"
#include "file-ops.h"
#include "file-stat.h"
#include "oct-env.h"
#include "oct-time.h"
#include "quit.h"

#include "Cell.h"
#include "anon-fcn-validator.h"
#include "builtin-defun-decls.h"
#include "defun.h"
#include "dynamic-ld.h"
#include "error.h"
#include "input.h"
#include "interpreter-private.h"
#include "interpreter.h"
#include "lex.h"
#include "load-path.h"
#include "lo-sysdep.h"
#include "oct-hist.h"
#include "oct-map.h"
#include "ov-classdef.h"
#include "ov-fcn-handle.h"
#include "ov-usr-fcn.h"
#include "ov-null-mat.h"
#include "pager.h"
#include "parse.h"
#include "pt-all.h"
#include "pt-eval.h"
#include "symtab.h"
#include "token.h"
#include "unwind-prot.h"
#include "utils.h"
#include "variables.h"

// oct-parse.h must be included after pt-all.h
#include "oct-parse.h"

extern int octave_lex (YYSTYPE *, void *);

// Forward declarations for some functions defined at the bottom of
// the file.

static void yyerror (octave::base_parser& parser, const char *s);

#define lexer (parser.get_lexer ())
#define scanner lexer.m_scanner

#if defined (HAVE_PRAGMA_GCC_DIAGNOSTIC)
   // Disable this warning for code that is generated by Bison,
   // including grammar rules.  Push the current state so we can
   // restore the warning state prior to functions we define at
   // the bottom of the file.
#  pragma GCC diagnostic push
#  pragma GCC diagnostic ignored "-Wold-style-cast"
#endif


#line 160 "libinterp/parse-tree/oct-parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED
# define YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED
/* Debug traces.  */
#ifndef OCTAVE_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define OCTAVE_DEBUG 1
#  else
#   define OCTAVE_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define OCTAVE_DEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined OCTAVE_DEBUG */
#if OCTAVE_DEBUG
extern int octave_debug;
#endif

/* Token kinds.  */
#ifndef OCTAVE_TOKENTYPE
# define OCTAVE_TOKENTYPE
  enum octave_tokentype
  {
    OCTAVE_EMPTY = -2,
    OCTAVE_EOF = 0,                /* "end of file"  */
    OCTAVE_error = 256,            /* error  */
    OCTAVE_UNDEF = 257,            /* "invalid token"  */
    ADD_EQ = 258,                  /* ADD_EQ  */
    SUB_EQ = 259,                  /* SUB_EQ  */
    MUL_EQ = 260,                  /* MUL_EQ  */
    DIV_EQ = 261,                  /* DIV_EQ  */
    LEFTDIV_EQ = 262,              /* LEFTDIV_EQ  */
    POW_EQ = 263,                  /* POW_EQ  */
    EMUL_EQ = 264,                 /* EMUL_EQ  */
    EDIV_EQ = 265,                 /* EDIV_EQ  */
    ELEFTDIV_EQ = 266,             /* ELEFTDIV_EQ  */
    EPOW_EQ = 267,                 /* EPOW_EQ  */
    AND_EQ = 268,                  /* AND_EQ  */
    OR_EQ = 269,                   /* OR_EQ  */
    EXPR_AND_AND = 270,            /* EXPR_AND_AND  */
    EXPR_OR_OR = 271,              /* EXPR_OR_OR  */
    EXPR_AND = 272,                /* EXPR_AND  */
    EXPR_OR = 273,                 /* EXPR_OR  */
    EXPR_NOT = 274,                /* EXPR_NOT  */
    EXPR_LT = 275,                 /* EXPR_LT  */
    EXPR_LE = 276,                 /* EXPR_LE  */
    EXPR_EQ = 277,                 /* EXPR_EQ  */
    EXPR_NE = 278,                 /* EXPR_NE  */
    EXPR_GE = 279,                 /* EXPR_GE  */
    EXPR_GT = 280,                 /* EXPR_GT  */
    LEFTDIV = 281,                 /* LEFTDIV  */
    EMUL = 282,                    /* EMUL  */
    EDIV = 283,                    /* EDIV  */
    ELEFTDIV = 284,                /* ELEFTDIV  */
    EPLUS = 285,                   /* EPLUS  */
    EMINUS = 286,                  /* EMINUS  */
    HERMITIAN = 287,               /* HERMITIAN  */
    TRANSPOSE = 288,               /* TRANSPOSE  */
    PLUS_PLUS = 289,               /* PLUS_PLUS  */
    MINUS_MINUS = 290,             /* MINUS_MINUS  */
    POW = 291,                     /* POW  */
    EPOW = 292,                    /* EPOW  */
    NUMBER = 293,                  /* NUMBER  */
    STRUCT_ELT = 294,              /* STRUCT_ELT  */
    NAME = 295,                    /* NAME  */
    END = 296,                     /* END  */
    DQ_STRING = 297,               /* DQ_STRING  */
    SQ_STRING = 298,               /* SQ_STRING  */
    FOR = 299,                     /* FOR  */
    PARFOR = 300,                  /* PARFOR  */
    WHILE = 301,                   /* WHILE  */
    DO = 302,                      /* DO  */
    UNTIL = 303,                   /* UNTIL  */
    SPMD = 304,                    /* SPMD  */
    IF = 305,                      /* IF  */
    ELSEIF = 306,                  /* ELSEIF  */
    ELSE = 307,                    /* ELSE  */
    SWITCH = 308,                  /* SWITCH  */
    CASE = 309,                    /* CASE  */
    OTHERWISE = 310,               /* OTHERWISE  */
    BREAK = 311,                   /* BREAK  */
    CONTINUE = 312,                /* CONTINUE  */
    FUNC_RET = 313,                /* FUNC_RET  */
    UNWIND = 314,                  /* UNWIND  */
    CLEANUP = 315,                 /* CLEANUP  */
    TRY = 316,                     /* TRY  */
    CATCH = 317,                   /* CATCH  */
    GLOBAL = 318,                  /* GLOBAL  */
    PERSISTENT = 319,              /* PERSISTENT  */
    FCN_HANDLE = 320,              /* FCN_HANDLE  */
    CLASSDEF = 321,                /* CLASSDEF  */
    PROPERTIES = 322,              /* PROPERTIES  */
    METHODS = 323,                 /* METHODS  */
    EVENTS = 324,                  /* EVENTS  */
    ENUMERATION = 325,             /* ENUMERATION  */
    METAQUERY = 326,               /* METAQUERY  */
    SUPERCLASSREF = 327,           /* SUPERCLASSREF  */
    FQ_IDENT = 328,                /* FQ_IDENT  */
    GET = 329,                     /* GET  */
    SET = 330,                     /* SET  */
    FCN = 331,                     /* FCN  */
    LEXICAL_ERROR = 332,           /* LEXICAL_ERROR  */
    END_OF_INPUT = 333,            /* END_OF_INPUT  */
    INPUT_FILE = 334,              /* INPUT_FILE  */
    UNARY = 335                    /* UNARY  */
  };
  typedef enum octave_tokentype octave_token_kind_t;
#endif
/* Token kinds.  */
#define OCTAVE_EOF 0
#define OCTAVE_error 256
#define OCTAVE_UNDEF 257
#define ADD_EQ 258
#define SUB_EQ 259
#define MUL_EQ 260
#define DIV_EQ 261
#define LEFTDIV_EQ 262
#define POW_EQ 263
#define EMUL_EQ 264
#define EDIV_EQ 265
#define ELEFTDIV_EQ 266
#define EPOW_EQ 267
#define AND_EQ 268
#define OR_EQ 269
#define EXPR_AND_AND 270
#define EXPR_OR_OR 271
#define EXPR_AND 272
#define EXPR_OR 273
#define EXPR_NOT 274
#define EXPR_LT 275
#define EXPR_LE 276
#define EXPR_EQ 277
#define EXPR_NE 278
#define EXPR_GE 279
#define EXPR_GT 280
#define LEFTDIV 281
#define EMUL 282
#define EDIV 283
#define ELEFTDIV 284
#define EPLUS 285
#define EMINUS 286
#define HERMITIAN 287
#define TRANSPOSE 288
#define PLUS_PLUS 289
#define MINUS_MINUS 290
#define POW 291
#define EPOW 292
#define NUMBER 293
#define STRUCT_ELT 294
#define NAME 295
#define END 296
#define DQ_STRING 297
#define SQ_STRING 298
#define FOR 299
#define PARFOR 300
#define WHILE 301
#define DO 302
#define UNTIL 303
#define SPMD 304
#define IF 305
#define ELSEIF 306
#define ELSE 307
#define SWITCH 308
#define CASE 309
#define OTHERWISE 310
#define BREAK 311
#define CONTINUE 312
#define FUNC_RET 313
#define UNWIND 314
#define CLEANUP 315
#define TRY 316
#define CATCH 317
#define GLOBAL 318
#define PERSISTENT 319
#define FCN_HANDLE 320
#define CLASSDEF 321
#define PROPERTIES 322
#define METHODS 323
#define EVENTS 324
#define ENUMERATION 325
#define METAQUERY 326
#define SUPERCLASSREF 327
#define FQ_IDENT 328
#define GET 329
#define SET 330
#define FCN 331
#define LEXICAL_ERROR 332
#define END_OF_INPUT 333
#define INPUT_FILE 334
#define UNARY 335

/* Value type.  */
#if ! defined OCTAVE_STYPE && ! defined OCTAVE_STYPE_IS_DECLARED
union OCTAVE_STYPE
{
#line 131 "../libinterp/parse-tree/oct-parse.yy"

  int dummy_type;

  // The type of the basic tokens returned by the lexer.
  octave::token *tok_val;

  // Comment strings that we need to deal with mid-rule.
  octave::comment_list *comment_type;

  // Types for the nonterminals we generate.
  char punct_type;
  octave::tree *tree_type;
  octave::tree_matrix *tree_matrix_type;
  octave::tree_cell *tree_cell_type;
  octave::tree_expression *tree_expression_type;
  octave::tree_constant *tree_constant_type;
  octave::tree_fcn_handle *tree_fcn_handle_type;
  octave::tree_superclass_ref *tree_superclass_ref_type;
  octave::tree_metaclass_query *tree_metaclass_query_type;
  octave::tree_function_def *tree_function_def_type;
  octave::tree_anon_fcn_handle *tree_anon_fcn_handle_type;
  octave::tree_identifier *tree_identifier_type;
  octave::tree_index_expression *tree_index_expression_type;
  octave::tree_colon_expression *tree_colon_expression_type;
  octave::tree_argument_list *tree_argument_list_type;
  octave::tree_parameter_list *tree_parameter_list_type;
  octave::tree_command *tree_command_type;
  octave::tree_if_command *tree_if_command_type;
  octave::tree_if_clause *tree_if_clause_type;
  octave::tree_if_command_list *tree_if_command_list_type;
  octave::tree_switch_command *tree_switch_command_type;
  octave::tree_switch_case *tree_switch_case_type;
  octave::tree_switch_case_list *tree_switch_case_list_type;
  octave::tree_decl_elt *tree_decl_elt_type;
  octave::tree_decl_init_list *tree_decl_init_list_type;
  octave::tree_decl_command *tree_decl_command_type;
  octave::tree_statement *tree_statement_type;
  octave::tree_statement_list *tree_statement_list_type;
  octave_user_function *octave_user_function_type;

  octave::tree_classdef *tree_classdef_type;
  octave::tree_classdef_attribute* tree_classdef_attribute_type;
  octave::tree_classdef_attribute_list* tree_classdef_attribute_list_type;
  octave::tree_classdef_superclass* tree_classdef_superclass_type;
  octave::tree_classdef_superclass_list* tree_classdef_superclass_list_type;
  octave::tree_classdef_body* tree_classdef_body_type;
  octave::tree_classdef_property* tree_classdef_property_type;
  octave::tree_classdef_property_list* tree_classdef_property_list_type;
  octave::tree_classdef_properties_block* tree_classdef_properties_block_type;
  octave::tree_classdef_methods_list* tree_classdef_methods_list_type;
  octave::tree_classdef_methods_block* tree_classdef_methods_block_type;
  octave::tree_classdef_event* tree_classdef_event_type;
  octave::tree_classdef_events_list* tree_classdef_events_list_type;
  octave::tree_classdef_events_block* tree_classdef_events_block_type;
  octave::tree_classdef_enum* tree_classdef_enum_type;
  octave::tree_classdef_enum_list* tree_classdef_enum_list_type;
  octave::tree_classdef_enum_block* tree_classdef_enum_block_type;

#line 439 "libinterp/parse-tree/oct-parse.cc"

};
typedef union OCTAVE_STYPE OCTAVE_STYPE;
# define OCTAVE_STYPE_IS_TRIVIAL 1
# define OCTAVE_STYPE_IS_DECLARED 1
#endif



#ifndef YYPUSH_MORE_DEFINED
# define YYPUSH_MORE_DEFINED
enum { YYPUSH_MORE = 4 };
#endif

typedef struct octave_pstate octave_pstate;


int octave_parse (octave::base_parser& parser);
int octave_push_parse (octave_pstate *ps,
                  int pushed_char, OCTAVE_STYPE const *pushed_val, octave::base_parser& parser);
int octave_pull_parse (octave_pstate *ps, octave::base_parser& parser);
octave_pstate *octave_pstate_new (void);
void octave_pstate_delete (octave_pstate *ps);


#endif /* !YY_OCTAVE_LIBINTERP_PARSE_TREE_OCT_PARSE_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_3_ = 3,                         /* '='  */
  YYSYMBOL_4_ = 4,                         /* ':'  */
  YYSYMBOL_5_ = 5,                         /* '-'  */
  YYSYMBOL_6_ = 6,                         /* '+'  */
  YYSYMBOL_7_ = 7,                         /* '*'  */
  YYSYMBOL_8_ = 8,                         /* '/'  */
  YYSYMBOL_9_ = 9,                         /* '('  */
  YYSYMBOL_10_ = 10,                       /* ')'  */
  YYSYMBOL_11_ = 11,                       /* '['  */
  YYSYMBOL_12_ = 12,                       /* ']'  */
  YYSYMBOL_13_ = 13,                       /* '{'  */
  YYSYMBOL_14_ = 14,                       /* '}'  */
  YYSYMBOL_15_ = 15,                       /* '.'  */
  YYSYMBOL_16_ = 16,                       /* '@'  */
  YYSYMBOL_17_ = 17,                       /* ','  */
  YYSYMBOL_18_ = 18,                       /* ';'  */
  YYSYMBOL_19_n_ = 19,                     /* '\n'  */
  YYSYMBOL_ADD_EQ = 20,                    /* ADD_EQ  */
  YYSYMBOL_SUB_EQ = 21,                    /* SUB_EQ  */
  YYSYMBOL_MUL_EQ = 22,                    /* MUL_EQ  */
  YYSYMBOL_DIV_EQ = 23,                    /* DIV_EQ  */
  YYSYMBOL_LEFTDIV_EQ = 24,                /* LEFTDIV_EQ  */
  YYSYMBOL_POW_EQ = 25,                    /* POW_EQ  */
  YYSYMBOL_EMUL_EQ = 26,                   /* EMUL_EQ  */
  YYSYMBOL_EDIV_EQ = 27,                   /* EDIV_EQ  */
  YYSYMBOL_ELEFTDIV_EQ = 28,               /* ELEFTDIV_EQ  */
  YYSYMBOL_EPOW_EQ = 29,                   /* EPOW_EQ  */
  YYSYMBOL_AND_EQ = 30,                    /* AND_EQ  */
  YYSYMBOL_OR_EQ = 31,                     /* OR_EQ  */
  YYSYMBOL_EXPR_AND_AND = 32,              /* EXPR_AND_AND  */
  YYSYMBOL_EXPR_OR_OR = 33,                /* EXPR_OR_OR  */
  YYSYMBOL_EXPR_AND = 34,                  /* EXPR_AND  */
  YYSYMBOL_EXPR_OR = 35,                   /* EXPR_OR  */
  YYSYMBOL_EXPR_NOT = 36,                  /* EXPR_NOT  */
  YYSYMBOL_EXPR_LT = 37,                   /* EXPR_LT  */
  YYSYMBOL_EXPR_LE = 38,                   /* EXPR_LE  */
  YYSYMBOL_EXPR_EQ = 39,                   /* EXPR_EQ  */
  YYSYMBOL_EXPR_NE = 40,                   /* EXPR_NE  */
  YYSYMBOL_EXPR_GE = 41,                   /* EXPR_GE  */
  YYSYMBOL_EXPR_GT = 42,                   /* EXPR_GT  */
  YYSYMBOL_LEFTDIV = 43,                   /* LEFTDIV  */
  YYSYMBOL_EMUL = 44,                      /* EMUL  */
  YYSYMBOL_EDIV = 45,                      /* EDIV  */
  YYSYMBOL_ELEFTDIV = 46,                  /* ELEFTDIV  */
  YYSYMBOL_EPLUS = 47,                     /* EPLUS  */
  YYSYMBOL_EMINUS = 48,                    /* EMINUS  */
  YYSYMBOL_HERMITIAN = 49,                 /* HERMITIAN  */
  YYSYMBOL_TRANSPOSE = 50,                 /* TRANSPOSE  */
  YYSYMBOL_PLUS_PLUS = 51,                 /* PLUS_PLUS  */
  YYSYMBOL_MINUS_MINUS = 52,               /* MINUS_MINUS  */
  YYSYMBOL_POW = 53,                       /* POW  */
  YYSYMBOL_EPOW = 54,                      /* EPOW  */
  YYSYMBOL_NUMBER = 55,                    /* NUMBER  */
  YYSYMBOL_STRUCT_ELT = 56,                /* STRUCT_ELT  */
  YYSYMBOL_NAME = 57,                      /* NAME  */
  YYSYMBOL_END = 58,                       /* END  */
  YYSYMBOL_DQ_STRING = 59,                 /* DQ_STRING  */
  YYSYMBOL_SQ_STRING = 60,                 /* SQ_STRING  */
  YYSYMBOL_FOR = 61,                       /* FOR  */
  YYSYMBOL_PARFOR = 62,                    /* PARFOR  */
  YYSYMBOL_WHILE = 63,                     /* WHILE  */
  YYSYMBOL_DO = 64,                        /* DO  */
  YYSYMBOL_UNTIL = 65,                     /* UNTIL  */
  YYSYMBOL_SPMD = 66,                      /* SPMD  */
  YYSYMBOL_IF = 67,                        /* IF  */
  YYSYMBOL_ELSEIF = 68,                    /* ELSEIF  */
  YYSYMBOL_ELSE = 69,                      /* ELSE  */
  YYSYMBOL_SWITCH = 70,                    /* SWITCH  */
  YYSYMBOL_CASE = 71,                      /* CASE  */
  YYSYMBOL_OTHERWISE = 72,                 /* OTHERWISE  */
  YYSYMBOL_BREAK = 73,                     /* BREAK  */
  YYSYMBOL_CONTINUE = 74,                  /* CONTINUE  */
  YYSYMBOL_FUNC_RET = 75,                  /* FUNC_RET  */
  YYSYMBOL_UNWIND = 76,                    /* UNWIND  */
  YYSYMBOL_CLEANUP = 77,                   /* CLEANUP  */
  YYSYMBOL_TRY = 78,                       /* TRY  */
  YYSYMBOL_CATCH = 79,                     /* CATCH  */
  YYSYMBOL_GLOBAL = 80,                    /* GLOBAL  */
  YYSYMBOL_PERSISTENT = 81,                /* PERSISTENT  */
  YYSYMBOL_FCN_HANDLE = 82,                /* FCN_HANDLE  */
  YYSYMBOL_CLASSDEF = 83,                  /* CLASSDEF  */
  YYSYMBOL_PROPERTIES = 84,                /* PROPERTIES  */
  YYSYMBOL_METHODS = 85,                   /* METHODS  */
  YYSYMBOL_EVENTS = 86,                    /* EVENTS  */
  YYSYMBOL_ENUMERATION = 87,               /* ENUMERATION  */
  YYSYMBOL_METAQUERY = 88,                 /* METAQUERY  */
  YYSYMBOL_SUPERCLASSREF = 89,             /* SUPERCLASSREF  */
  YYSYMBOL_FQ_IDENT = 90,                  /* FQ_IDENT  */
  YYSYMBOL_GET = 91,                       /* GET  */
  YYSYMBOL_SET = 92,                       /* SET  */
  YYSYMBOL_FCN = 93,                       /* FCN  */
  YYSYMBOL_LEXICAL_ERROR = 94,             /* LEXICAL_ERROR  */
  YYSYMBOL_END_OF_INPUT = 95,              /* END_OF_INPUT  */
  YYSYMBOL_INPUT_FILE = 96,                /* INPUT_FILE  */
  YYSYMBOL_UNARY = 97,                     /* UNARY  */
  YYSYMBOL_YYACCEPT = 98,                  /* $accept  */
  YYSYMBOL_input = 99,                     /* input  */
  YYSYMBOL_simple_list = 100,              /* simple_list  */
  YYSYMBOL_simple_list1 = 101,             /* simple_list1  */
  YYSYMBOL_opt_list = 102,                 /* opt_list  */
  YYSYMBOL_list = 103,                     /* list  */
  YYSYMBOL_list1 = 104,                    /* list1  */
  YYSYMBOL_opt_fcn_list = 105,             /* opt_fcn_list  */
  YYSYMBOL_fcn_list = 106,                 /* fcn_list  */
  YYSYMBOL_fcn_list1 = 107,                /* fcn_list1  */
  YYSYMBOL_statement = 108,                /* statement  */
  YYSYMBOL_word_list_cmd = 109,            /* word_list_cmd  */
  YYSYMBOL_word_list = 110,                /* word_list  */
  YYSYMBOL_identifier = 111,               /* identifier  */
  YYSYMBOL_superclass_identifier = 112,    /* superclass_identifier  */
  YYSYMBOL_meta_identifier = 113,          /* meta_identifier  */
  YYSYMBOL_string = 114,                   /* string  */
  YYSYMBOL_constant = 115,                 /* constant  */
  YYSYMBOL_matrix = 116,                   /* matrix  */
  YYSYMBOL_matrix_rows = 117,              /* matrix_rows  */
  YYSYMBOL_cell = 118,                     /* cell  */
  YYSYMBOL_cell_rows = 119,                /* cell_rows  */
  YYSYMBOL_cell_or_matrix_row = 120,       /* cell_or_matrix_row  */
  YYSYMBOL_fcn_handle = 121,               /* fcn_handle  */
  YYSYMBOL_anon_fcn_handle = 122,          /* anon_fcn_handle  */
  YYSYMBOL_primary_expr = 123,             /* primary_expr  */
  YYSYMBOL_magic_colon = 124,              /* magic_colon  */
  YYSYMBOL_magic_tilde = 125,              /* magic_tilde  */
  YYSYMBOL_arg_list = 126,                 /* arg_list  */
  YYSYMBOL_indirect_ref_op = 127,          /* indirect_ref_op  */
  YYSYMBOL_oper_expr = 128,                /* oper_expr  */
  YYSYMBOL_power_expr = 129,               /* power_expr  */
  YYSYMBOL_colon_expr = 130,               /* colon_expr  */
  YYSYMBOL_simple_expr = 131,              /* simple_expr  */
  YYSYMBOL_assign_lhs = 132,               /* assign_lhs  */
  YYSYMBOL_assign_expr = 133,              /* assign_expr  */
  YYSYMBOL_expression = 134,               /* expression  */
  YYSYMBOL_command = 135,                  /* command  */
  YYSYMBOL_declaration = 136,              /* declaration  */
  YYSYMBOL_decl1 = 137,                    /* decl1  */
  YYSYMBOL_decl_param_init = 138,          /* decl_param_init  */
  YYSYMBOL_decl2 = 139,                    /* decl2  */
  YYSYMBOL_select_command = 140,           /* select_command  */
  YYSYMBOL_if_command = 141,               /* if_command  */
  YYSYMBOL_if_cmd_list = 142,              /* if_cmd_list  */
  YYSYMBOL_if_cmd_list1 = 143,             /* if_cmd_list1  */
  YYSYMBOL_elseif_clause = 144,            /* elseif_clause  */
  YYSYMBOL_else_clause = 145,              /* else_clause  */
  YYSYMBOL_switch_command = 146,           /* switch_command  */
  YYSYMBOL_case_list = 147,                /* case_list  */
  YYSYMBOL_case_list1 = 148,               /* case_list1  */
  YYSYMBOL_switch_case = 149,              /* switch_case  */
  YYSYMBOL_default_case = 150,             /* default_case  */
  YYSYMBOL_loop_command = 151,             /* loop_command  */
  YYSYMBOL_jump_command = 152,             /* jump_command  */
  YYSYMBOL_spmd_command = 153,             /* spmd_command  */
  YYSYMBOL_except_command = 154,           /* except_command  */
  YYSYMBOL_push_fcn_symtab = 155,          /* push_fcn_symtab  */
  YYSYMBOL_param_list_beg = 156,           /* param_list_beg  */
  YYSYMBOL_param_list_end = 157,           /* param_list_end  */
  YYSYMBOL_opt_param_list = 158,           /* opt_param_list  */
  YYSYMBOL_param_list = 159,               /* param_list  */
  YYSYMBOL_param_list1 = 160,              /* param_list1  */
  YYSYMBOL_param_list2 = 161,              /* param_list2  */
  YYSYMBOL_param_list_elt = 162,           /* param_list_elt  */
  YYSYMBOL_return_list = 163,              /* return_list  */
  YYSYMBOL_return_list1 = 164,             /* return_list1  */
  YYSYMBOL_parsing_local_fcns = 165,       /* parsing_local_fcns  */
  YYSYMBOL_push_script_symtab = 166,       /* push_script_symtab  */
  YYSYMBOL_begin_file = 167,               /* begin_file  */
  YYSYMBOL_file = 168,                     /* file  */
  YYSYMBOL_function_beg = 169,             /* function_beg  */
  YYSYMBOL_fcn_name = 170,                 /* fcn_name  */
  YYSYMBOL_function_end = 171,             /* function_end  */
  YYSYMBOL_function = 172,                 /* function  */
  YYSYMBOL_classdef_beg = 173,             /* classdef_beg  */
  YYSYMBOL_classdef = 174,                 /* classdef  */
  YYSYMBOL_attr_list = 175,                /* attr_list  */
  YYSYMBOL_attr_list1 = 176,               /* attr_list1  */
  YYSYMBOL_attr = 177,                     /* attr  */
  YYSYMBOL_superclass_list = 178,          /* superclass_list  */
  YYSYMBOL_superclass_list1 = 179,         /* superclass_list1  */
  YYSYMBOL_superclass = 180,               /* superclass  */
  YYSYMBOL_class_body = 181,               /* class_body  */
  YYSYMBOL_class_body1 = 182,              /* class_body1  */
  YYSYMBOL_properties_block = 183,         /* properties_block  */
  YYSYMBOL_property_list = 184,            /* property_list  */
  YYSYMBOL_property_list1 = 185,           /* property_list1  */
  YYSYMBOL_class_property = 186,           /* class_property  */
  YYSYMBOL_methods_block = 187,            /* methods_block  */
  YYSYMBOL_method_decl1 = 188,             /* method_decl1  */
  YYSYMBOL_method_decl = 189,              /* method_decl  */
  YYSYMBOL_190_1 = 190,                    /* $@1  */
  YYSYMBOL_method = 191,                   /* method  */
  YYSYMBOL_methods_list = 192,             /* methods_list  */
  YYSYMBOL_methods_list1 = 193,            /* methods_list1  */
  YYSYMBOL_events_block = 194,             /* events_block  */
  YYSYMBOL_events_list = 195,              /* events_list  */
  YYSYMBOL_events_list1 = 196,             /* events_list1  */
  YYSYMBOL_class_event = 197,              /* class_event  */
  YYSYMBOL_enum_block = 198,               /* enum_block  */
  YYSYMBOL_enum_list = 199,                /* enum_list  */
  YYSYMBOL_enum_list1 = 200,               /* enum_list1  */
  YYSYMBOL_class_enum = 201,               /* class_enum  */
  YYSYMBOL_stmt_begin = 202,               /* stmt_begin  */
  YYSYMBOL_anon_fcn_begin = 203,           /* anon_fcn_begin  */
  YYSYMBOL_stash_comment = 204,            /* stash_comment  */
  YYSYMBOL_parse_error = 205,              /* parse_error  */
  YYSYMBOL_sep_no_nl = 206,                /* sep_no_nl  */
  YYSYMBOL_opt_sep_no_nl = 207,            /* opt_sep_no_nl  */
  YYSYMBOL_opt_nl = 208,                   /* opt_nl  */
  YYSYMBOL_nl = 209,                       /* nl  */
  YYSYMBOL_sep = 210,                      /* sep  */
  YYSYMBOL_opt_sep = 211                   /* opt_sep  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined OCTAVE_STYPE_IS_TRIVIAL && OCTAVE_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  108
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1606

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  98
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  114
/* YYNRULES -- Number of rules.  */
#define YYNRULES  291
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  534

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   335


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      19,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       9,    10,     7,     6,    17,     5,    15,     8,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,    18,
       2,     3,     2,     2,    16,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    11,     2,    12,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    13,     2,    14,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97
};

#if OCTAVE_DEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   384,   384,   393,   403,   410,   416,   420,   422,   427,
     428,   432,   436,   438,   443,   444,   448,   456,   461,   468,
     470,   472,   484,   496,   498,   509,   518,   529,   538,   540,
     544,   546,   550,   554,   556,   572,   576,   578,   599,   600,
     606,   608,   614,   620,   629,   637,   649,   662,   664,   666,
     668,   673,   675,   677,   679,   688,   697,   705,   707,   709,
     711,   718,   725,   734,   743,   745,   747,   749,   761,   773,
     785,   797,   799,   801,   803,   810,   812,   814,   816,   818,
     820,   822,   824,   826,   828,   830,   832,   834,   836,   838,
     840,   842,   846,   848,   850,   852,   864,   876,   888,   900,
     902,   909,   911,   913,   915,   917,   921,   933,   948,   950,
     952,   954,   956,   958,   960,   962,   964,   966,   968,   970,
     974,   988,   990,   992,   994,   996,   998,  1000,  1002,  1004,
    1006,  1008,  1010,  1012,  1016,  1031,  1038,  1046,  1048,  1050,
    1052,  1054,  1056,  1058,  1060,  1068,  1073,  1080,  1082,  1090,
    1095,  1097,  1110,  1112,  1120,  1130,  1132,  1139,  1147,  1154,
    1165,  1178,  1191,  1192,  1194,  1196,  1203,  1205,  1212,  1221,
    1234,  1246,  1253,  1265,  1279,  1291,  1312,  1317,  1322,  1330,
    1349,  1362,  1375,  1393,  1405,  1422,  1433,  1434,  1438,  1445,
    1454,  1455,  1472,  1474,  1483,  1485,  1493,  1502,  1521,  1541,
    1545,  1560,  1564,  1573,  1577,  1605,  1624,  1633,  1642,  1652,
    1664,  1677,  1712,  1719,  1733,  1750,  1770,  1771,  1781,  1783,
    1792,  1794,  1801,  1810,  1816,  1828,  1834,  1843,  1848,  1849,
    1857,  1859,  1861,  1863,  1865,  1872,  1879,  1886,  1896,  1914,
    1915,  1924,  1926,  1958,  1962,  1972,  1989,  1994,  2001,  2004,
    2003,  2019,  2021,  2026,  2027,  2035,  2043,  2057,  2075,  2076,
    2084,  2086,  2095,  2099,  2117,  2118,  2126,  2128,  2137,  2151,
    2158,  2166,  2169,  2175,  2179,  2185,  2191,  2197,  2206,  2207,
    2212,  2213,  2217,  2223,  2231,  2237,  2243,  2249,  2255,  2261,
    2270,  2271
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if OCTAVE_DEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "'='", "':'", "'-'",
  "'+'", "'*'", "'/'", "'('", "')'", "'['", "']'", "'{'", "'}'", "'.'",
  "'@'", "','", "';'", "'\\n'", "ADD_EQ", "SUB_EQ", "MUL_EQ", "DIV_EQ",
  "LEFTDIV_EQ", "POW_EQ", "EMUL_EQ", "EDIV_EQ", "ELEFTDIV_EQ", "EPOW_EQ",
  "AND_EQ", "OR_EQ", "EXPR_AND_AND", "EXPR_OR_OR", "EXPR_AND", "EXPR_OR",
  "EXPR_NOT", "EXPR_LT", "EXPR_LE", "EXPR_EQ", "EXPR_NE", "EXPR_GE",
  "EXPR_GT", "LEFTDIV", "EMUL", "EDIV", "ELEFTDIV", "EPLUS", "EMINUS",
  "HERMITIAN", "TRANSPOSE", "PLUS_PLUS", "MINUS_MINUS", "POW", "EPOW",
  "NUMBER", "STRUCT_ELT", "NAME", "END", "DQ_STRING", "SQ_STRING", "FOR",
  "PARFOR", "WHILE", "DO", "UNTIL", "SPMD", "IF", "ELSEIF", "ELSE",
  "SWITCH", "CASE", "OTHERWISE", "BREAK", "CONTINUE", "FUNC_RET", "UNWIND",
  "CLEANUP", "TRY", "CATCH", "GLOBAL", "PERSISTENT", "FCN_HANDLE",
  "CLASSDEF", "PROPERTIES", "METHODS", "EVENTS", "ENUMERATION",
  "METAQUERY", "SUPERCLASSREF", "FQ_IDENT", "GET", "SET", "FCN",
  "LEXICAL_ERROR", "END_OF_INPUT", "INPUT_FILE", "UNARY", "$accept",
  "input", "simple_list", "simple_list1", "opt_list", "list", "list1",
  "opt_fcn_list", "fcn_list", "fcn_list1", "statement", "word_list_cmd",
  "word_list", "identifier", "superclass_identifier", "meta_identifier",
  "string", "constant", "matrix", "matrix_rows", "cell", "cell_rows",
  "cell_or_matrix_row", "fcn_handle", "anon_fcn_handle", "primary_expr",
  "magic_colon", "magic_tilde", "arg_list", "indirect_ref_op", "oper_expr",
  "power_expr", "colon_expr", "simple_expr", "assign_lhs", "assign_expr",
  "expression", "command", "declaration", "decl1", "decl_param_init",
  "decl2", "select_command", "if_command", "if_cmd_list", "if_cmd_list1",
  "elseif_clause", "else_clause", "switch_command", "case_list",
  "case_list1", "switch_case", "default_case", "loop_command",
  "jump_command", "spmd_command", "except_command", "push_fcn_symtab",
  "param_list_beg", "param_list_end", "opt_param_list", "param_list",
  "param_list1", "param_list2", "param_list_elt", "return_list",
  "return_list1", "parsing_local_fcns", "push_script_symtab", "begin_file",
  "file", "function_beg", "fcn_name", "function_end", "function",
  "classdef_beg", "classdef", "attr_list", "attr_list1", "attr",
  "superclass_list", "superclass_list1", "superclass", "class_body",
  "class_body1", "properties_block", "property_list", "property_list1",
  "class_property", "methods_block", "method_decl1", "method_decl", "$@1",
  "method", "methods_list", "methods_list1", "events_block", "events_list",
  "events_list1", "class_event", "enum_block", "enum_list", "enum_list1",
  "class_enum", "stmt_begin", "anon_fcn_begin", "stash_comment",
  "parse_error", "sep_no_nl", "opt_sep_no_nl", "opt_nl", "nl", "sep",
  "opt_sep", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,    61,    58,    45,    43,    42,    47,    40,
      41,    91,    93,   123,   125,    46,    64,    44,    59,    10,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335
};
#endif

#define YYPACT_NINF (-399)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-292)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     664,  -399,  1328,  1328,  1268,  1080,  1080,    42,  -399,  -399,
    1328,  1328,  1328,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,    51,
      51,  -399,  -399,  -399,  -399,   121,    -7,    75,  -399,  -399,
      73,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    1440,  -399,  1564,   157,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,    55,    63,   132,  -399,  -399,
    -399,  -399,   215,  -399,  -399,   252,   252,   151,  -399,  1256,
    1328,    38,  -399,  -399,  -399,   146,  -399,    35,  -399,  -399,
      25,  -399,   252,   252,   252,  1342,  1354,  1268,   156,   156,
    1268,  1268,   156,   156,   162,    51,  -399,    51,  -399,  -399,
    -399,   837,  -399,    73,  -399,  1328,  1328,  1328,  1328,  1328,
    1094,  1161,  -399,  1328,  1328,  1328,  1328,  1328,  1328,  -399,
    -399,  -399,  -399,  1414,  1414,     9,  1328,  1328,  1328,  1328,
    1328,  1328,  1328,  1328,  1328,  1328,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  -399,
    -399,  -399,   918,   170,    -5,  -399,  -399,  -399,   194,  -399,
    1080,  1256,  -399,  1080,  -399,  -399,  -399,  -399,   203,   198,
    -399,   501,  1268,   305,   236,  1268,   239,  -399,  -399,  -399,
    -399,   245,   999,   999,  -399,   187,   -29,   156,   999,   999,
    -399,  -399,  -399,  -399,  1500,   405,   405,   252,   252,  -399,
      21,  -399,    66,   252,   252,   252,   252,   405,   405,  1414,
    1414,  1414,  1414,  1414,  -399,    33,    33,  1268,  -399,   584,
     168,   241,   351,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,   171,  -399,   156,  -399,  -399,  -399,  -399,
      16,   254,   257,   270,   281,    42,  1256,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,    74,  -399,  -399,   682,  1268,   760,
    1268,   156,  -399,  -399,  -399,   220,   229,   156,  -399,  -399,
    -399,  -399,  -399,   182,   211,   -11,  1268,  1328,  -399,  1256,
    -399,    33,    33,    33,    33,    33,  1175,  1242,  -399,  -399,
      10,   279,  -399,   756,  -399,   282,   156,  -399,  -399,   217,
      51,    51,   -20,   156,  -399,  -399,  1268,  -399,  1268,  -399,
     999,  1268,  -399,   999,   156,   156,  -399,  -399,   234,   182,
    -399,  -399,  -399,  -399,  -399,  -399,  1512,  -399,    24,  -399,
      92,  1268,  -399,  -399,  -399,   111,    51,   200,  -399,    51,
    -399,  -399,  -399,    42,   999,   284,   156,   278,   156,   240,
    -399,  -399,  1268,   999,   156,   156,  -399,  -399,  -399,   156,
     156,  -399,  -399,   297,    51,   306,    26,  -399,   156,   219,
    -399,   156,  -399,  -399,   156,   -38,   156,   999,  1268,   999,
    -399,  -399,  -399,  1268,   999,   999,   999,  -399,  -399,  -399,
     156,   111,   273,  -399,   200,   999,  -399,  -399,  -399,   999,
     258,   302,   259,   156,  -399,  -399,   260,   261,  1268,  -399,
    -399,   233,   163,   178,  -399,   -38,   266,  -399,   156,  -399,
     999,   156,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,   267,   156,  -399,  -399,  -399,  -399,   233,  -399,  -399,
    -399,   999,  -399,   999,   156,   156,   156,   156,  -399,   163,
    -399,   268,  -399,   282,   282,   282,   282,  -399,  -399,  -399,
    -399,  -399,   271,   -26,   271,   271,   269,   156,  -399,    51,
    -399,  -399,  -399,   277,   156,    22,   283,   156,  -399,    51,
     291,   156,  -399,    51,  -399,    41,  -399,   326,  -399,    65,
     143,   328,  -399,  -399,   271,  -399,  -399,   271,   342,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  1268,  1268,    51,   343,
    -399,    42,  -399,  -399
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,   273,     0,     0,     0,    38,    38,     0,   274,   275,
       0,     0,     0,    30,    25,    28,    29,   271,   271,   271,
     271,   271,   271,   271,   176,   177,   178,   271,   271,     0,
       0,    44,    27,    26,   272,     0,     0,   278,     7,    21,
      47,    53,    52,    31,    48,    50,    51,    49,   136,    64,
     108,   109,   134,     0,   135,    19,    20,   137,   138,   152,
     153,   139,   140,   141,   142,     0,     0,   280,   144,   271,
     143,     4,   279,     5,    47,    79,    78,     0,    55,    39,
      56,     0,    33,    58,    59,    40,    57,     0,    36,   184,
       0,   270,    77,    75,    76,     0,     0,     0,   290,   290,
       0,     0,   290,   290,   150,   145,   147,   146,     1,     2,
       3,   279,     6,    22,    23,     0,     0,     0,     0,     0,
       0,     0,    63,     0,     0,     0,     0,     0,     0,    71,
      72,    65,    66,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   206,
     203,   282,     9,   281,     0,   276,   277,    54,    42,    32,
      38,    41,    35,    38,   189,    56,   195,   194,     0,   191,
     192,     0,     0,   120,     0,     0,     0,   269,   284,   285,
     286,   291,     9,     9,   269,     0,   155,   290,     9,     9,
     149,   148,     8,    24,   106,    83,    82,    84,    85,    67,
       0,    69,     0,    90,    88,    89,    91,    86,    87,     0,
       0,     0,     0,     0,    92,    80,    81,     0,    73,   118,
     119,   116,   117,   110,   111,   112,   115,   113,   114,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   214,     0,    10,   290,    12,   271,   201,   283,
       0,     0,     0,   207,     0,   186,    43,    34,    60,    61,
      62,    37,   185,   188,     0,    46,    45,     0,     0,     0,
       0,   290,   287,   288,   289,     0,     0,   290,   154,   271,
     271,   158,   156,   162,     0,     0,     0,     0,    68,     0,
      70,   105,   104,   103,   101,   102,     0,     0,    93,    94,
       0,     0,   204,   291,    11,   216,   290,   196,   199,     0,
       0,     0,     0,   290,   187,   193,     0,   269,     0,   269,
       9,     0,   179,     9,   290,   290,   271,   271,     0,   164,
     166,   163,   271,   182,   271,   151,   107,    95,     0,    97,
       0,     0,    99,    74,    13,     0,     0,    14,   198,     0,
     208,   209,   207,   186,     9,     0,   290,   121,   290,     0,
     171,   157,     0,     9,   290,   290,   161,   167,   165,   290,
     290,    96,    98,     0,     0,   220,     0,   218,   290,     0,
      15,   290,    17,   200,   290,     0,   290,     9,     0,     9,
     170,   269,   160,     0,     9,     9,     9,   100,   222,   149,
     290,     0,   223,   205,    16,     9,   210,   211,   212,     9,
       0,     0,     0,   290,   269,   169,     0,     0,     0,   217,
     219,     0,   228,   290,    18,     0,     0,   172,   290,   174,
       9,   290,   180,   181,   221,   227,   225,   271,   271,   271,
     271,     0,   290,   230,   231,   232,   233,     0,   224,   213,
     173,     9,   159,     9,   290,   290,   290,   290,   215,   229,
     226,     0,   168,   216,   216,   216,   216,   234,   235,   236,
     237,   175,   239,   271,   258,   264,     0,   290,   241,     0,
     252,   251,   255,     0,   290,     0,     0,   290,   260,     0,
       0,   290,   266,     0,   238,   271,   240,   243,   245,   271,
     246,     0,   248,   257,   259,   262,   263,   265,     0,   242,
     149,   256,   247,   249,   261,   267,     0,     0,     0,     0,
     244,   246,   250,   268
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -399,  -399,  -399,  -399,  -129,  -399,  -399,  -399,  -399,  -399,
       2,  -399,  -399,     0,  -399,  -399,   -24,  -399,  -399,  -399,
    -399,  -399,    -1,  -399,  -399,  -125,  -154,   -28,   -76,  -148,
      11,  -119,  -399,   286,   -41,  -399,    70,  -399,  -399,   322,
    -398,   -80,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,    18,    19,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
      -3,    -6,  -399,  -399,    87,  -133,  -399,  -399,  -399,  -399,
    -399,  -399,    43,   -72,  -333,  -399,  -399,  -217,  -399,   -44,
    -399,  -399,   -89,  -399,  -399,   -99,  -399,  -399,  -134,   -97,
    -153,  -399,  -399,  -135,  -399,  -399,   -91,  -399,  -399,  -131,
     -90,  -399,  -399,  -137,  -187,  -399,    97,  -399,   358,   363,
    -399,  -399,  -251,   197
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    35,    36,    37,   253,   254,   255,   389,   390,   391,
     256,    39,   113,    74,    41,    42,    43,    44,    45,    81,
      46,    87,    82,    47,    48,    49,    83,    84,    85,   135,
      50,   225,    51,    52,    53,    54,    55,    56,    57,   105,
     296,   106,    58,    59,   195,   196,   291,   292,    60,   338,
     339,   340,   341,    61,    62,    63,    64,    65,    90,   273,
     323,   324,   178,   179,   180,   264,   319,   316,    66,    67,
      68,    69,   265,   418,    70,   257,   258,   356,   386,   387,
     432,   433,   446,   451,   452,   453,   486,   487,   488,   454,
     512,   491,   528,   492,   493,   494,   455,   496,   497,   498,
     456,   500,   501,   502,   281,   181,   489,    71,    72,    73,
     162,   163,   191,   192
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      40,    91,    38,   168,   313,    88,   260,   287,   224,   224,
     177,   428,   109,    75,    76,   226,   114,   268,   227,   351,
     416,    92,    93,    94,   392,   201,   174,   201,   317,   104,
     104,   298,  -253,   260,   381,  -190,   410,    14,   299,   289,
     290,   299,   306,   411,   210,   212,   307,   343,   122,   172,
     169,    89,    14,   173,   184,   186,   170,   417,   282,   283,
     284,   175,   176,   285,   286,   228,   352,  -183,   344,   294,
     295,   261,   262,    14,    77,    86,    86,   310,   310,    14,
     300,   434,    14,   299,   308,   309,   261,   262,   110,   203,
     104,    92,     8,     9,   224,   224,   224,   224,   224,  -291,
     301,   302,   303,   304,   305,   104,   382,   104,    14,   299,
     175,    40,   268,   202,    95,    96,    97,    98,    99,   100,
     101,   108,   527,  -254,   102,   103,   204,   205,   206,   207,
     208,    14,    15,    16,   213,   214,   215,   216,   217,   218,
     366,   277,   368,   269,   279,   268,  -197,   384,   159,    86,
     490,   161,    89,   310,   310,   310,   310,   310,  -183,   160,
     146,   167,    40,   171,   263,   200,   164,   187,    14,   267,
     194,   197,   271,   188,   189,   190,   490,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   259,
      86,    86,    40,    40,   177,   188,   189,   190,    40,    40,
     136,   369,   138,   139,   371,   140,   141,   142,   143,   144,
     145,   266,   457,   272,   423,   274,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   358,
     348,   350,   165,   166,   359,   395,   505,   441,   269,   278,
      86,   270,   280,    86,   402,   288,   176,   447,   448,   449,
     450,   276,    77,   336,   337,    77,   482,   483,   484,   485,
     318,   120,   282,   283,   284,   121,   312,   122,   420,   320,
     422,   269,   321,  -197,   104,   425,   426,   427,   140,   141,
     142,   143,   144,   145,   322,   331,   435,   332,   342,   353,
     436,   355,   376,  -183,   396,   398,   193,   311,   400,   198,
     199,   129,   130,   131,   132,   133,   134,   407,   346,   409,
     431,   462,   438,    40,   413,   354,   437,   439,   442,   443,
     360,   361,   362,   445,   460,   468,   481,   504,  -271,   520,
      40,   523,   471,    40,   472,   508,   270,   136,   137,   138,
     139,   513,   140,   141,   142,   143,   144,   145,   327,   516,
     329,   526,   107,   533,   315,   385,   388,   377,   378,   393,
     394,   325,   511,   459,    40,   363,   345,   430,   470,   270,
     477,   519,   478,    40,   521,   532,    86,    86,   479,   480,
     525,   183,   183,   524,   408,   138,   334,   335,   140,   141,
     142,   143,   144,   145,   293,   111,   365,    40,   367,    40,
     112,   370,     0,     0,    40,    40,    40,     0,     0,     0,
       0,   385,   118,   119,   120,    40,     0,     0,   121,    40,
     122,   383,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,     0,   374,   375,     0,     0,     0,     0,   379,
      40,   380,   401,     0,     0,     0,     0,     0,   123,   124,
     125,   126,   314,     0,   129,   130,   131,   132,   133,   134,
       0,    40,     0,    40,     0,     0,     0,     0,   421,     0,
       0,     0,     0,   424,     0,     0,     0,     0,   330,     0,
       0,     0,     0,     0,   333,     0,     0,     0,     0,   507,
       0,     0,     0,     0,     0,   510,     0,     0,   444,   515,
       0,     0,   275,   518,   522,     0,     2,     3,     0,     0,
       4,     0,     5,   357,     6,     0,     0,     7,     0,     0,
     364,     0,     0,     0,     0,   522,     0,     0,   531,     0,
       0,   372,   373,     0,     0,     0,     0,    10,     0,     0,
       0,     0,     0,     0,   464,   465,   466,   467,     0,     0,
       0,     0,    11,    12,     0,     0,    13,     0,    14,     0,
      15,    16,     0,   397,     0,   399,     0,     0,     0,     0,
       0,   403,   404,     0,     0,     0,   405,   406,     0,     0,
     495,   499,   503,    31,     0,   412,     0,     0,   414,    32,
      33,   415,     0,   419,     0,     0,   529,   530,     0,     0,
       0,     0,     0,     0,     0,     0,   495,   429,     0,     0,
       0,   499,     0,     0,   503,     0,     0,     0,   138,   139,
     440,   140,   141,   142,   143,   144,   145,     0,     0,     0,
     458,     0,     0,     0,     0,   461,     0,     0,   463,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   469,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   473,   474,   475,   476,     1,     0,     0,     0,     2,
       3,     0,     0,     4,     0,     5,     0,     6,     0,     0,
       7,     8,     9,  -278,   506,   326,     0,     0,     0,     0,
       0,   509,     0,     0,   514,     0,     0,     0,   517,     0,
      10,     0,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,     0,    11,    12,     0,     0,    13,
       0,    14,     0,    15,    16,    17,    18,    19,    20,     0,
      21,    22,     0,     0,    23,     0,     0,    24,    25,    26,
      27,     0,    28,     0,    29,    30,    31,     0,     0,     0,
       0,     0,    32,    33,     0,     0,     0,  -183,    34,  -278,
    -202,     2,     3,   328,     0,     4,     0,     5,     0,     6,
       0,     0,     7,   282,   283,   284,     0,     0,     0,     0,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    11,    12,     0,
       0,    13,     0,    14,     0,    15,    16,    17,    18,    19,
      20,     0,    21,    22,     0,     0,    23,     0,     0,    24,
      25,    26,    27,     0,    28,     0,    29,    30,    31,     0,
       0,     0,     2,     3,    32,    33,     4,     0,     5,  -183,
       6,     0,  -202,     7,   165,   166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    10,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    11,    12,
       0,     0,    13,     0,    14,     0,    15,    16,    17,    18,
      19,    20,     0,    21,    22,     0,     0,    23,     0,     0,
      24,    25,    26,    27,     0,    28,     0,    29,    30,    31,
       0,     0,     0,     2,     3,    32,    33,     4,     0,     5,
    -183,     6,     0,  -202,     7,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    10,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    11,
      12,     0,     0,    13,     0,    14,     0,    15,    16,    17,
      18,    19,    20,     0,    21,    22,     0,     0,    23,     0,
       0,    24,    25,    26,    27,     0,    28,     0,    29,    30,
      31,   252,     0,     0,     2,     3,    32,    33,     4,     0,
       5,  -183,     6,     0,  -202,     7,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      11,    12,     0,     0,    13,     0,    14,     0,    15,    16,
      17,    18,    19,    20,     0,    21,    22,     0,     0,    23,
       0,     0,    24,    25,    26,    27,     0,    28,     0,    29,
      30,    31,     0,     0,    78,     2,     3,    32,    33,     4,
       0,     5,  -183,     6,     0,  -202,     7,    79,    78,     2,
       3,     0,     0,     4,   209,     5,     0,     6,     0,     0,
       7,     0,     0,     0,     0,     0,    80,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      80,    11,    12,     0,     0,    13,     0,    14,     0,    15,
      16,     0,     0,     0,     0,    11,    12,     0,     0,    13,
       0,    14,     0,    15,    16,     0,     0,     0,     0,     0,
       0,     0,    31,     0,     0,    78,     2,     3,    32,    33,
       4,     0,     5,     0,     6,   211,    31,     7,     0,    78,
       2,     3,    32,    33,     4,   347,     5,     0,     6,     0,
       0,     7,     0,     0,     0,     0,     0,    80,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,    11,    12,     0,     0,    13,     0,    14,     0,
      15,    16,     0,     0,     0,     0,    11,    12,     0,     0,
      13,     0,    14,     0,    15,    16,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     0,    78,     2,     3,    32,
      33,     4,     0,     5,     0,     6,   349,    31,     7,     0,
      78,     2,     3,    32,    33,     4,     0,     5,     0,     6,
       0,     0,     7,     2,     3,     0,     0,     4,    80,     5,
       0,     6,     0,     0,     7,     0,     0,     0,     0,     0,
       0,     0,    80,    11,    12,     0,     0,    13,     0,    14,
       0,    15,    16,     0,    10,     0,     0,    11,    12,     0,
       0,    13,     0,    14,     0,    15,    16,     0,     0,    11,
      12,     0,     0,    13,    31,    14,     0,    15,    16,     0,
      32,    33,     0,     2,     3,     0,     0,     4,    31,     5,
       0,     6,     0,     0,    32,    33,     0,     2,     3,     0,
      31,   182,     0,     5,     0,     6,    32,    33,     0,     2,
       3,     0,     0,   185,    10,     5,     0,     6,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    10,    11,
      12,     0,     0,    13,     0,    14,     0,    15,    16,     0,
      10,     0,     0,    11,    12,     0,     0,    13,     0,    14,
       0,    15,    16,     0,     0,    11,    12,     0,     0,    13,
      31,    14,     0,    15,    16,     0,    32,    33,     0,   219,
     220,     0,     0,     4,    31,     5,     0,     6,     0,     0,
      32,    33,     0,     0,     0,     0,    31,     0,     0,     0,
       0,     0,    32,    33,   115,   116,   117,   118,   119,   120,
     221,     0,     0,   121,     0,   122,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   222,   223,     0,     0,    13,
       0,    14,     0,    15,    16,     0,     0,     0,     0,     0,
       0,     0,     0,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,     0,    31,     0,     0,     0,
       0,     0,    32,    33,   297,   116,   117,   118,   119,   120,
       0,     0,     0,   121,     0,   122,     0,   116,   117,   118,
     119,   120,     0,     0,     0,   121,     0,   122,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,  -120,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -120,  -120,  -120,  -120,  -120,  -120,
    -120,  -120,  -120,  -120,  -120,  -120,   136,   137,   138,   139,
       0,   140,   141,   142,   143,   144,   145
};

static const yytype_int16 yycheck[] =
{
       0,     7,     0,    79,   255,     6,    11,   194,   133,   134,
      90,   409,    19,     2,     3,   134,    40,   171,     9,     9,
      58,    10,    11,    12,   357,   105,     1,   107,    12,    29,
      30,    10,    58,    11,    10,    10,    10,    57,    17,    68,
      69,    17,     9,    17,   120,   121,    13,    58,    15,    14,
      12,     9,    57,    18,    95,    96,    18,    95,    17,    18,
      19,    36,    90,   192,   193,    56,    56,    93,    79,   198,
     199,    91,    92,    57,     4,     5,     6,   225,   226,    57,
      14,   414,    57,    17,    51,    52,    91,    92,    95,   113,
      90,    80,    17,    18,   219,   220,   221,   222,   223,    58,
     219,   220,   221,   222,   223,   105,    14,   107,    57,    17,
      36,   111,   266,   111,    17,    18,    19,    20,    21,    22,
      23,     0,   520,    58,    27,    28,   115,   116,   117,   118,
     119,    57,    59,    60,   123,   124,   125,   126,   127,   128,
     327,   182,   329,   171,   185,   299,     3,    36,    93,    79,
     483,    19,     9,   301,   302,   303,   304,   305,    93,    96,
       3,    10,   162,    17,   164,     3,    69,    97,    57,   170,
     100,   101,   173,    17,    18,    19,   509,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    19,
     120,   121,   192,   193,   274,    17,    18,    19,   198,   199,
      32,   330,    34,    35,   333,    37,    38,    39,    40,    41,
      42,    17,    34,    10,   401,    17,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    12,
     306,   307,    17,    18,    17,   364,   487,   424,   266,     3,
     170,   171,     3,   173,   373,    58,   274,    84,    85,    86,
      87,   181,   182,    71,    72,   185,   473,   474,   475,   476,
     260,     9,    17,    18,    19,    13,    95,    15,   397,    15,
     399,   299,    15,     3,   274,   404,   405,   406,    37,    38,
      39,    40,    41,    42,     3,    65,   415,    58,    77,    10,
     419,     9,    58,    93,    10,    17,    99,   227,    58,   102,
     103,    49,    50,    51,    52,    53,    54,    10,   297,     3,
      37,   440,    10,   313,    95,   313,    58,    58,    58,    58,
     320,   321,   322,    90,    58,    58,    58,    58,    57,     3,
     330,     3,   461,   333,   463,    58,   266,    32,    33,    34,
      35,    58,    37,    38,    39,    40,    41,    42,   278,    58,
     280,     9,    30,    10,   257,   355,   356,   339,   339,   359,
     363,   274,   495,   435,   364,   322,   296,   411,   457,   299,
     469,   505,   469,   373,   509,   528,   306,   307,   469,   469,
     517,    95,    96,   514,   384,    34,   289,   290,    37,    38,
      39,    40,    41,    42,   197,    37,   326,   397,   328,   399,
      37,   331,    -1,    -1,   404,   405,   406,    -1,    -1,    -1,
      -1,   411,     7,     8,     9,   415,    -1,    -1,    13,   419,
      15,   351,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,    -1,   336,   337,    -1,    -1,    -1,    -1,   342,
     440,   344,   372,    -1,    -1,    -1,    -1,    -1,    43,    44,
      45,    46,   255,    -1,    49,    50,    51,    52,    53,    54,
      -1,   461,    -1,   463,    -1,    -1,    -1,    -1,   398,    -1,
      -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,   281,    -1,
      -1,    -1,    -1,    -1,   287,    -1,    -1,    -1,    -1,   489,
      -1,    -1,    -1,    -1,    -1,   495,    -1,    -1,   428,   499,
      -1,    -1,     1,   503,   510,    -1,     5,     6,    -1,    -1,
       9,    -1,    11,   316,    13,    -1,    -1,    16,    -1,    -1,
     323,    -1,    -1,    -1,    -1,   531,    -1,    -1,   528,    -1,
      -1,   334,   335,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,   447,   448,   449,   450,    -1,    -1,
      -1,    -1,    51,    52,    -1,    -1,    55,    -1,    57,    -1,
      59,    60,    -1,   366,    -1,   368,    -1,    -1,    -1,    -1,
      -1,   374,   375,    -1,    -1,    -1,   379,   380,    -1,    -1,
     483,   484,   485,    82,    -1,   388,    -1,    -1,   391,    88,
      89,   394,    -1,   396,    -1,    -1,   526,   527,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   509,   410,    -1,    -1,
      -1,   514,    -1,    -1,   517,    -1,    -1,    -1,    34,    35,
     423,    37,    38,    39,    40,    41,    42,    -1,    -1,    -1,
     433,    -1,    -1,    -1,    -1,   438,    -1,    -1,   441,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   452,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   464,   465,   466,   467,     1,    -1,    -1,    -1,     5,
       6,    -1,    -1,     9,    -1,    11,    -1,    13,    -1,    -1,
      16,    17,    18,    19,   487,     3,    -1,    -1,    -1,    -1,
      -1,   494,    -1,    -1,   497,    -1,    -1,    -1,   501,    -1,
      36,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    51,    52,    -1,    -1,    55,
      -1,    57,    -1,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    -1,    -1,    70,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    -1,    -1,    -1,
      -1,    -1,    88,    89,    -1,    -1,    -1,    93,    94,    95,
      96,     5,     6,     3,    -1,     9,    -1,    11,    -1,    13,
      -1,    -1,    16,    17,    18,    19,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,
      -1,    55,    -1,    57,    -1,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    -1,    -1,    70,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    -1,
      -1,    -1,     5,     6,    88,    89,     9,    -1,    11,    93,
      13,    -1,    96,    16,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      -1,    -1,    55,    -1,    57,    -1,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    -1,    -1,    70,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      -1,    -1,    -1,     5,     6,    88,    89,     9,    -1,    11,
      93,    13,    -1,    96,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      52,    -1,    -1,    55,    -1,    57,    -1,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    -1,    -1,    70,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    -1,    -1,     5,     6,    88,    89,     9,    -1,
      11,    93,    13,    -1,    96,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    -1,    -1,    55,    -1,    57,    -1,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    -1,    -1,    70,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    -1,    -1,     4,     5,     6,    88,    89,     9,
      -1,    11,    93,    13,    -1,    96,    16,    17,     4,     5,
       6,    -1,    -1,     9,    10,    11,    -1,    13,    -1,    -1,
      16,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    51,    52,    -1,    -1,    55,    -1,    57,    -1,    59,
      60,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,    55,
      -1,    57,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    82,    -1,    -1,     4,     5,     6,    88,    89,
       9,    -1,    11,    -1,    13,    14,    82,    16,    -1,     4,
       5,     6,    88,    89,     9,    10,    11,    -1,    13,    -1,
      -1,    16,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    51,    52,    -1,    -1,    55,    -1,    57,    -1,
      59,    60,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,
      55,    -1,    57,    -1,    59,    60,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    82,    -1,    -1,     4,     5,     6,    88,
      89,     9,    -1,    11,    -1,    13,    14,    82,    16,    -1,
       4,     5,     6,    88,    89,     9,    -1,    11,    -1,    13,
      -1,    -1,    16,     5,     6,    -1,    -1,     9,    36,    11,
      -1,    13,    -1,    -1,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    51,    52,    -1,    -1,    55,    -1,    57,
      -1,    59,    60,    -1,    36,    -1,    -1,    51,    52,    -1,
      -1,    55,    -1,    57,    -1,    59,    60,    -1,    -1,    51,
      52,    -1,    -1,    55,    82,    57,    -1,    59,    60,    -1,
      88,    89,    -1,     5,     6,    -1,    -1,     9,    82,    11,
      -1,    13,    -1,    -1,    88,    89,    -1,     5,     6,    -1,
      82,     9,    -1,    11,    -1,    13,    88,    89,    -1,     5,
       6,    -1,    -1,     9,    36,    11,    -1,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    51,
      52,    -1,    -1,    55,    -1,    57,    -1,    59,    60,    -1,
      36,    -1,    -1,    51,    52,    -1,    -1,    55,    -1,    57,
      -1,    59,    60,    -1,    -1,    51,    52,    -1,    -1,    55,
      82,    57,    -1,    59,    60,    -1,    88,    89,    -1,     5,
       6,    -1,    -1,     9,    82,    11,    -1,    13,    -1,    -1,
      88,    89,    -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    88,    89,     4,     5,     6,     7,     8,     9,
      36,    -1,    -1,    13,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    52,    -1,    -1,    55,
      -1,    57,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    88,    89,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    13,    -1,    15,    -1,     5,     6,     7,
       8,     9,    -1,    -1,    -1,    13,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    38,    39,    40,    41,    42
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     5,     6,     9,    11,    13,    16,    17,    18,
      36,    51,    52,    55,    57,    59,    60,    61,    62,    63,
      64,    66,    67,    70,    73,    74,    75,    76,    78,    80,
      81,    82,    88,    89,    94,    99,   100,   101,   108,   109,
     111,   112,   113,   114,   115,   116,   118,   121,   122,   123,
     128,   130,   131,   132,   133,   134,   135,   136,   140,   141,
     146,   151,   152,   153,   154,   155,   166,   167,   168,   169,
     172,   205,   206,   207,   111,   128,   128,   134,     4,    17,
      36,   117,   120,   124,   125,   126,   134,   119,   120,     9,
     156,   159,   128,   128,   128,   204,   204,   204,   204,   204,
     204,   204,   204,   204,   111,   137,   139,   137,     0,    19,
      95,   206,   207,   110,   114,     4,     5,     6,     7,     8,
       9,    13,    15,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,   127,    32,    33,    34,    35,
      37,    38,    39,    40,    41,    42,     3,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    93,
      96,    19,   208,   209,   204,    17,    18,    10,   126,    12,
      18,    17,    14,    18,     1,    36,   125,   139,   160,   161,
     162,   203,     9,   131,   132,     9,   132,   134,    17,    18,
      19,   210,   211,   211,   134,   142,   143,   134,   211,   211,
       3,   139,   108,   114,   128,   128,   128,   128,   128,    10,
     126,    14,   126,   128,   128,   128,   128,   128,   128,     5,
       6,    36,    51,    52,   123,   129,   129,     9,    56,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,    83,   102,   103,   104,   108,   173,   174,    19,
      11,    91,    92,   111,   163,   170,    17,   120,   124,   125,
     134,   120,    10,   157,    17,     1,   134,   132,     3,   132,
       3,   202,    17,    18,    19,   102,   102,   202,    58,    68,
      69,   144,   145,   211,   102,   102,   138,     4,    10,    17,
      14,   129,   129,   129,   129,   129,     9,    13,    51,    52,
     127,   134,    95,   210,   211,   204,   165,    12,   111,   164,
      15,    15,     3,   158,   159,   162,     3,   134,     3,   134,
     211,    65,    58,   211,   204,   204,    71,    72,   147,   148,
     149,   150,    77,    58,    79,   134,   128,    10,   126,    14,
     126,     9,    56,    10,   108,     9,   175,   211,    12,    17,
     111,   111,   111,   170,   211,   134,   202,   134,   202,   102,
     134,   102,   211,   211,   204,   204,    58,   149,   150,   204,
     204,    10,    14,   134,    36,   111,   176,   177,   111,   105,
     106,   107,   172,   111,   158,   102,    10,   211,    17,   211,
      58,   134,   102,   211,   211,   211,   211,    10,   111,     3,
      10,    17,   211,    95,   211,   211,    58,    95,   171,   211,
     102,   134,   102,   202,   134,   102,   102,   102,   138,   211,
     177,    37,   178,   179,   172,   102,   102,    58,    10,    58,
     211,   202,    58,    58,   134,    90,   180,    84,    85,    86,
      87,   181,   182,   183,   187,   194,   198,    34,   211,   171,
      58,   211,   102,   211,   204,   204,   204,   204,    58,   211,
     180,   102,   102,   211,   211,   211,   211,   183,   187,   194,
     198,    58,   175,   175,   175,   175,   184,   185,   186,   204,
     172,   189,   191,   192,   193,   204,   195,   196,   197,   204,
     199,   200,   201,   204,    58,   210,   211,   111,    58,   211,
     111,   163,   188,    58,   211,   111,    58,   211,   111,   186,
       3,   191,   159,     3,   197,   201,     9,   138,   190,   134,
     134,   111,   188,    10
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    98,    99,    99,    99,   100,   100,   101,   101,   102,
     102,   103,   104,   104,   105,   105,   106,   107,   107,   108,
     108,   108,   109,   110,   110,   111,   112,   113,   114,   114,
     115,   115,   116,   117,   117,   118,   119,   119,   120,   120,
     120,   120,   120,   120,   121,   122,   122,   123,   123,   123,
     123,   123,   123,   123,   123,   124,   125,   126,   126,   126,
     126,   126,   126,   127,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   130,   130,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     132,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   134,   134,   134,   135,   135,   135,
     135,   135,   135,   135,   135,   136,   136,   137,   137,   138,
     139,   139,   140,   140,   141,   142,   142,   143,   143,   144,
     145,   146,   147,   147,   147,   147,   148,   148,   149,   150,
     151,   151,   151,   151,   151,   151,   152,   152,   152,   153,
     154,   154,   154,   155,   156,   157,   158,   158,   159,   159,
     160,   160,   161,   161,   162,   162,   163,   163,   163,   164,
     164,   165,   166,   167,   168,   168,   169,   170,   170,   170,
     171,   171,   172,   172,   173,   174,   175,   175,   176,   176,
     177,   177,   177,   178,   178,   179,   179,   180,   181,   181,
     182,   182,   182,   182,   182,   182,   182,   182,   183,   184,
     184,   185,   185,   186,   186,   187,   188,   188,   189,   190,
     189,   191,   191,   192,   192,   193,   193,   194,   195,   195,
     196,   196,   197,   198,   199,   199,   200,   200,   201,   202,
     203,   204,   205,   205,   206,   206,   206,   206,   207,   207,
     208,   208,   209,   209,   210,   210,   210,   210,   210,   210,
     211,   211
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     1,     1,     2,     1,     3,     0,
       1,     2,     1,     3,     0,     1,     2,     1,     3,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     3,     1,     3,     0,     1,
       1,     2,     2,     3,     1,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     3,     3,     1,     1,     2,     2,     3,     4,     3,
       4,     2,     2,     3,     5,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     2,     2,     3,     4,     3,     4,     3,
       5,     2,     2,     2,     2,     2,     3,     5,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     0,
       1,     4,     1,     1,     4,     1,     2,     4,     2,     7,
       4,     6,     0,     1,     1,     2,     1,     2,     7,     4,
       7,     6,     9,    10,     9,    12,     1,     1,     1,     5,
       9,     9,     5,     0,     1,     1,     0,     1,     3,     2,
       0,     1,     1,     3,     1,     1,     2,     1,     3,     1,
       3,     0,     0,     2,     4,     7,     2,     1,     3,     3,
       1,     1,     7,     9,     1,     8,     0,     4,     1,     3,
       1,     4,     2,     0,     2,     2,     3,     1,     0,     2,
       1,     1,     1,     1,     3,     3,     3,     3,     6,     0,
       2,     1,     3,     2,     5,     6,     1,     2,     2,     0,
       5,     1,     1,     0,     2,     1,     3,     6,     0,     2,
       1,     3,     2,     6,     0,     2,     1,     3,     5,     0,
       0,     0,     1,     1,     1,     1,     2,     2,     0,     1,
       0,     1,     1,     2,     1,     1,     1,     2,     2,     2,
       0,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = OCTAVE_EMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == OCTAVE_EMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (parser, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use OCTAVE_error or OCTAVE_UNDEF. */
#define YYERRCODE OCTAVE_UNDEF


/* Enable debugging if requested.  */
#if OCTAVE_DEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, parser); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, octave::base_parser& parser)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (parser);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, octave::base_parser& parser)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, parser);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, octave::base_parser& parser)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], parser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parser); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !OCTAVE_DEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !OCTAVE_DEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif
/* Parser data structure.  */
struct yypstate
  {
    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;
    /* Whether this instance has not started parsing yet.
     * If 2, it corresponds to a finished parsing.  */
    int yynew;
  };






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, octave::base_parser& parser)
{
  YYUSE (yyvaluep);
  YYUSE (parser);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_3_: /* '='  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2013 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_4_: /* ':'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2019 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_5_: /* '-'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2025 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_6_: /* '+'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2031 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_7_: /* '*'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2037 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_8_: /* '/'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2043 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_9_: /* '('  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2049 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_10_: /* ')'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2055 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_11_: /* '['  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2061 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_12_: /* ']'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2067 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_13_: /* '{'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2073 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_14_: /* '}'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2079 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_15_: /* '.'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2085 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_16_: /* '@'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2091 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_17_: /* ','  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2097 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_18_: /* ';'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2103 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_19_n_: /* '\n'  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2109 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ADD_EQ: /* ADD_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2115 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SUB_EQ: /* SUB_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2121 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_MUL_EQ: /* MUL_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2127 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_DIV_EQ: /* DIV_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2133 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_LEFTDIV_EQ: /* LEFTDIV_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2139 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_POW_EQ: /* POW_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2145 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EMUL_EQ: /* EMUL_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2151 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EDIV_EQ: /* EDIV_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2157 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ELEFTDIV_EQ: /* ELEFTDIV_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2163 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EPOW_EQ: /* EPOW_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2169 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_AND_EQ: /* AND_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2175 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_OR_EQ: /* OR_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2181 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_AND_AND: /* EXPR_AND_AND  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2187 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_OR_OR: /* EXPR_OR_OR  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2193 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_AND: /* EXPR_AND  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2199 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_OR: /* EXPR_OR  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2205 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_NOT: /* EXPR_NOT  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2211 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_LT: /* EXPR_LT  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2217 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_LE: /* EXPR_LE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2223 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_EQ: /* EXPR_EQ  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2229 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_NE: /* EXPR_NE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2235 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_GE: /* EXPR_GE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2241 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EXPR_GT: /* EXPR_GT  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2247 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_LEFTDIV: /* LEFTDIV  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2253 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EMUL: /* EMUL  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2259 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EDIV: /* EDIV  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2265 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ELEFTDIV: /* ELEFTDIV  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2271 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EPLUS: /* EPLUS  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2277 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EMINUS: /* EMINUS  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2283 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_HERMITIAN: /* HERMITIAN  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2289 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_TRANSPOSE: /* TRANSPOSE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2295 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_PLUS_PLUS: /* PLUS_PLUS  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2301 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_MINUS_MINUS: /* MINUS_MINUS  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2307 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_POW: /* POW  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2313 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EPOW: /* EPOW  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2319 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_NUMBER: /* NUMBER  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2325 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_STRUCT_ELT: /* STRUCT_ELT  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2331 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_NAME: /* NAME  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2337 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_END: /* END  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2343 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_DQ_STRING: /* DQ_STRING  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2349 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SQ_STRING: /* SQ_STRING  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2355 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FOR: /* FOR  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2361 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_PARFOR: /* PARFOR  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2367 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_WHILE: /* WHILE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2373 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_DO: /* DO  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2379 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_UNTIL: /* UNTIL  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2385 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SPMD: /* SPMD  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2391 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_IF: /* IF  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2397 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ELSEIF: /* ELSEIF  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2403 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ELSE: /* ELSE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2409 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SWITCH: /* SWITCH  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2415 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CASE: /* CASE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2421 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_OTHERWISE: /* OTHERWISE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2427 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_BREAK: /* BREAK  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2433 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CONTINUE: /* CONTINUE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2439 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FUNC_RET: /* FUNC_RET  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2445 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_UNWIND: /* UNWIND  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2451 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CLEANUP: /* CLEANUP  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2457 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_TRY: /* TRY  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2463 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CATCH: /* CATCH  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2469 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_GLOBAL: /* GLOBAL  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2475 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_PERSISTENT: /* PERSISTENT  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2481 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FCN_HANDLE: /* FCN_HANDLE  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2487 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_CLASSDEF: /* CLASSDEF  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2493 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_PROPERTIES: /* PROPERTIES  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2499 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_METHODS: /* METHODS  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2505 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_EVENTS: /* EVENTS  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2511 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_ENUMERATION: /* ENUMERATION  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2517 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_METAQUERY: /* METAQUERY  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2523 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SUPERCLASSREF: /* SUPERCLASSREF  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2529 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FQ_IDENT: /* FQ_IDENT  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2535 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_GET: /* GET  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2541 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_SET: /* SET  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2547 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_FCN: /* FCN  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2553 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_LEXICAL_ERROR: /* LEXICAL_ERROR  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2559 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_END_OF_INPUT: /* END_OF_INPUT  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2565 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_UNARY: /* UNARY  */
#line 318 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2571 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_input: /* input  */
#line 320 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_type); }
#line 2577 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_simple_list: /* simple_list  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2583 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_simple_list1: /* simple_list1  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2589 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_list: /* opt_list  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2595 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_list: /* list  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2601 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_list1: /* list1  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2607 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_fcn_list: /* opt_fcn_list  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2613 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_fcn_list: /* fcn_list  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2619 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_fcn_list1: /* fcn_list1  */
#line 345 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_list_type); }
#line 2625 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_statement: /* statement  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_type); }
#line 2631 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_word_list_cmd: /* word_list_cmd  */
#line 331 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_index_expression_type); }
#line 2637 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_word_list: /* word_list  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2643 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_identifier: /* identifier  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2649 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_superclass_identifier: /* superclass_identifier  */
#line 326 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_superclass_ref_type); }
#line 2655 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_meta_identifier: /* meta_identifier  */
#line 327 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_metaclass_query_type); }
#line 2661 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_string: /* string  */
#line 324 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2667 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_constant: /* constant  */
#line 324 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2673 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_matrix: /* matrix  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2679 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_matrix_rows: /* matrix_rows  */
#line 321 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_matrix_type); }
#line 2685 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_cell: /* cell  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2691 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_cell_rows: /* cell_rows  */
#line 322 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_cell_type); }
#line 2697 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_cell_or_matrix_row: /* cell_or_matrix_row  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2703 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_fcn_handle: /* fcn_handle  */
#line 325 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_fcn_handle_type); }
#line 2709 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_anon_fcn_handle: /* anon_fcn_handle  */
#line 329 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_anon_fcn_handle_type); }
#line 2715 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_primary_expr: /* primary_expr  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2721 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_magic_colon: /* magic_colon  */
#line 324 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_constant_type); }
#line 2727 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_magic_tilde: /* magic_tilde  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2733 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_arg_list: /* arg_list  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2739 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_oper_expr: /* oper_expr  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2745 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_power_expr: /* power_expr  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2751 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_colon_expr: /* colon_expr  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2757 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_simple_expr: /* simple_expr  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2763 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_assign_lhs: /* assign_lhs  */
#line 332 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_argument_list_type); }
#line 2769 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_assign_expr: /* assign_expr  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2775 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_expression: /* expression  */
#line 323 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_expression_type); }
#line 2781 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_command: /* command  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2787 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_declaration: /* declaration  */
#line 343 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_command_type); }
#line 2793 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_decl1: /* decl1  */
#line 342 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_init_list_type); }
#line 2799 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_decl2: /* decl2  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_elt_type); }
#line 2805 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_select_command: /* select_command  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2811 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_if_command: /* if_command  */
#line 335 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_type); }
#line 2817 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_if_cmd_list: /* if_cmd_list  */
#line 337 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_list_type); }
#line 2823 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_if_cmd_list1: /* if_cmd_list1  */
#line 337 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_command_list_type); }
#line 2829 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_elseif_clause: /* elseif_clause  */
#line 336 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_clause_type); }
#line 2835 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_else_clause: /* else_clause  */
#line 336 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_if_clause_type); }
#line 2841 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_switch_command: /* switch_command  */
#line 338 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_command_type); }
#line 2847 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_case_list: /* case_list  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_list_type); }
#line 2853 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_case_list1: /* case_list1  */
#line 340 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_list_type); }
#line 2859 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_switch_case: /* switch_case  */
#line 339 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_type); }
#line 2865 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_default_case: /* default_case  */
#line 339 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_switch_case_type); }
#line 2871 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_loop_command: /* loop_command  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2877 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_jump_command: /* jump_command  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2883 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_spmd_command: /* spmd_command  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2889 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_except_command: /* except_command  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2895 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_param_list: /* opt_param_list  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2901 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_param_list: /* param_list  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2907 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_param_list1: /* param_list1  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2913 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_param_list2: /* param_list2  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2919 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_param_list_elt: /* param_list_elt  */
#line 341 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_decl_elt_type); }
#line 2925 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_return_list: /* return_list  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2931 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_return_list1: /* return_list1  */
#line 333 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_parameter_list_type); }
#line 2937 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_file: /* file  */
#line 334 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_command_type); }
#line 2943 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_function_beg: /* function_beg  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2949 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_fcn_name: /* fcn_name  */
#line 330 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_identifier_type); }
#line 2955 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_function_end: /* function_end  */
#line 344 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_statement_type); }
#line 2961 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_function: /* function  */
#line 328 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 2967 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_classdef_beg: /* classdef_beg  */
#line 315 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 2973 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_classdef: /* classdef  */
#line 348 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_type); }
#line 2979 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_attr_list: /* attr_list  */
#line 350 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_list_type); }
#line 2985 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_attr_list1: /* attr_list1  */
#line 350 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_list_type); }
#line 2991 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_attr: /* attr  */
#line 349 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_attribute_type); }
#line 2997 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_superclass_list: /* superclass_list  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_list_type); }
#line 3003 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_superclass_list1: /* superclass_list1  */
#line 352 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_list_type); }
#line 3009 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_superclass: /* superclass  */
#line 351 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_superclass_type); }
#line 3015 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_body: /* class_body  */
#line 353 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_body_type); }
#line 3021 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_body1: /* class_body1  */
#line 353 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_body_type); }
#line 3027 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_properties_block: /* properties_block  */
#line 356 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_properties_block_type); }
#line 3033 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_property_list: /* property_list  */
#line 355 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_property_list_type); }
#line 3039 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_property_list1: /* property_list1  */
#line 355 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_property_list_type); }
#line 3045 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_property: /* class_property  */
#line 354 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_property_type); }
#line 3051 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_methods_block: /* methods_block  */
#line 358 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_methods_block_type); }
#line 3057 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_method_decl1: /* method_decl1  */
#line 346 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).octave_user_function_type); }
#line 3063 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_method_decl: /* method_decl  */
#line 328 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 3069 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_method: /* method  */
#line 328 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_function_def_type); }
#line 3075 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_methods_list: /* methods_list  */
#line 357 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_methods_list_type); }
#line 3081 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_methods_list1: /* methods_list1  */
#line 357 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_methods_list_type); }
#line 3087 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_events_block: /* events_block  */
#line 361 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_events_block_type); }
#line 3093 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_events_list: /* events_list  */
#line 360 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_events_list_type); }
#line 3099 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_events_list1: /* events_list1  */
#line 360 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_events_list_type); }
#line 3105 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_event: /* class_event  */
#line 359 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_event_type); }
#line 3111 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_enum_block: /* enum_block  */
#line 364 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_block_type); }
#line 3117 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_enum_list: /* enum_list  */
#line 363 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_list_type); }
#line 3123 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_enum_list1: /* enum_list1  */
#line 363 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_list_type); }
#line 3129 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_class_enum: /* class_enum  */
#line 362 "../libinterp/parse-tree/oct-parse.yy"
            { delete ((*yyvaluep).tree_classdef_enum_type); }
#line 3135 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_stash_comment: /* stash_comment  */
#line 317 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3141 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_sep_no_nl: /* sep_no_nl  */
#line 316 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3147 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_sep_no_nl: /* opt_sep_no_nl  */
#line 316 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3153 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_nl: /* opt_nl  */
#line 316 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3159 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_nl: /* nl  */
#line 316 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3165 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_sep: /* sep  */
#line 316 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3171 "libinterp/parse-tree/oct-parse.cc"
        break;

    case YYSYMBOL_opt_sep: /* opt_sep  */
#line 316 "../libinterp/parse-tree/oct-parse.yy"
            { }
#line 3177 "libinterp/parse-tree/oct-parse.cc"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}





int
yyparse (octave::base_parser& parser)
{
  yypstate *yyps = yypstate_new ();
  if (!yyps)
    {
      yyerror (parser, YY_("memory exhausted"));
      return 2;
    }
  int yystatus = yypull_parse (yyps, parser);
  yypstate_delete (yyps);
  return yystatus;
}

int
yypull_parse (yypstate *yyps, octave::base_parser& parser)
{
  YY_ASSERT (yyps);
  int yystatus;
  do {
    YYSTYPE yylval;
    int yychar = yylex (&yylval, scanner);
    yystatus = yypush_parse (yyps, yychar, &yylval, parser);
  } while (yystatus == YYPUSH_MORE);
  return yystatus;
}

#define octave_nerrs yyps->octave_nerrs
#define yystate yyps->yystate
#define yyerrstatus yyps->yyerrstatus
#define yyssa yyps->yyssa
#define yyss yyps->yyss
#define yyssp yyps->yyssp
#define yyvsa yyps->yyvsa
#define yyvs yyps->yyvs
#define yyvsp yyps->yyvsp
#define yystacksize yyps->yystacksize

/* Initialize the parser data structure.  */
static void
yypstate_clear (yypstate *yyps)
{
  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yyssp = yyss;
  yyvsp = yyvs;

  /* Initialize the state stack, in case yypcontext_expected_tokens is
     called before the first call to yyparse. */
  *yyssp = 0;
  yyps->yynew = 1;
}

/* Initialize the parser data structure.  */
yypstate *
yypstate_new (void)
{
  yypstate *yyps;
  yyps = YY_CAST (yypstate *, malloc (sizeof *yyps));
  if (!yyps)
    return YY_NULLPTR;
  yystacksize = YYINITDEPTH;
  yyss = yyssa;
  yyvs = yyvsa;
  yypstate_clear (yyps);
  return yyps;
}

void
yypstate_delete (yypstate *yyps)
{
  if (yyps)
    {
#ifndef yyoverflow
      /* If the stack was reallocated but the parse did not complete, then the
         stack still needs to be freed.  */
      if (yyss != yyssa)
        YYSTACK_FREE (yyss);
#endif
      free (yyps);
    }
}



/*---------------.
| yypush_parse.  |
`---------------*/

int
yypush_parse (yypstate *yyps,
              int yypushed_char, YYSTYPE const *yypushed_val, octave::base_parser& parser)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  switch (yyps->yynew)
    {
    case 2:
      yypstate_clear (yyps);
      goto case_0;

    case_0:
    case 0:
      yyn = yypact[yystate];
      goto yyread_pushed_token;
    }

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = OCTAVE_EMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == OCTAVE_EMPTY)
    {
      if (!yyps->yynew)
        {
          YYDPRINTF ((stderr, "Return for a new token:\n"));
          yyresult = YYPUSH_MORE;
          goto yypushreturn;
        }
      yyps->yynew = 0;
yyread_pushed_token:
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yypushed_char;
      if (yypushed_val)
        yylval = *yypushed_val;
    }

  if (yychar <= OCTAVE_EOF)
    {
      yychar = OCTAVE_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == OCTAVE_error)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = OCTAVE_UNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = OCTAVE_EMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* input: simple_list '\n'  */
#line 385 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_type) = nullptr;
                    std::shared_ptr<octave::tree_statement_list> tmp_lst ((yyvsp[-1].tree_statement_list_type));
                    parser.statement_list (tmp_lst);
                    YYACCEPT;
                  }
#line 3544 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 3: /* input: simple_list END_OF_INPUT  */
#line 394 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_type) = nullptr;
                    lexer.m_end_of_input = true;
                    std::shared_ptr<octave::tree_statement_list> tmp_lst ((yyvsp[-1].tree_statement_list_type));
                    parser.statement_list (tmp_lst);
                    YYACCEPT;
                  }
#line 3558 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 4: /* input: parse_error  */
#line 404 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_type) = nullptr;
                    YYABORT;
                  }
#line 3567 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 5: /* simple_list: opt_sep_no_nl  */
#line 411 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_statement_list_type) = nullptr;
                  }
#line 3577 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 6: /* simple_list: simple_list1 opt_sep_no_nl  */
#line 417 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.set_stmt_print_flag ((yyvsp[-1].tree_statement_list_type), (yyvsp[0].punct_type), false); }
#line 3583 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 7: /* simple_list1: statement  */
#line 421 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.make_statement_list ((yyvsp[0].tree_statement_type)); }
#line 3589 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 8: /* simple_list1: simple_list1 sep_no_nl statement  */
#line 423 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), (yyvsp[0].tree_statement_type), false); }
#line 3595 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 9: /* opt_list: %empty  */
#line 427 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = new octave::tree_statement_list (); }
#line 3601 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 10: /* opt_list: list  */
#line 429 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = (yyvsp[0].tree_statement_list_type); }
#line 3607 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 11: /* list: list1 opt_sep  */
#line 433 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.set_stmt_print_flag ((yyvsp[-1].tree_statement_list_type), (yyvsp[0].punct_type), true); }
#line 3613 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 12: /* list1: statement  */
#line 437 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.make_statement_list ((yyvsp[0].tree_statement_type)); }
#line 3619 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 13: /* list1: list1 sep statement  */
#line 439 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), (yyvsp[0].tree_statement_type), true); }
#line 3625 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 14: /* opt_fcn_list: %empty  */
#line 443 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = new octave::tree_statement_list (); }
#line 3631 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 15: /* opt_fcn_list: fcn_list  */
#line 445 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_list_type) = (yyvsp[0].tree_statement_list_type); }
#line 3637 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 16: /* fcn_list: fcn_list1 opt_sep  */
#line 449 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_statement_list_type) = (yyvsp[-1].tree_statement_list_type);
                  }
#line 3647 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 17: /* fcn_list1: function  */
#line 457 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave::tree_statement *stmt = parser.make_statement ((yyvsp[0].tree_function_def_type));
                    (yyval.tree_statement_list_type) = new octave::tree_statement_list (stmt);
                  }
#line 3656 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 18: /* fcn_list1: fcn_list1 opt_sep function  */
#line 462 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave::tree_statement *stmt = parser.make_statement ((yyvsp[0].tree_function_def_type));
                    (yyval.tree_statement_list_type) = parser.append_statement_list ((yyvsp[-2].tree_statement_list_type), (yyvsp[-1].punct_type), stmt, false);
                  }
#line 3665 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 19: /* statement: expression  */
#line 469 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_expression_type)); }
#line 3671 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 20: /* statement: command  */
#line 471 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_command_type)); }
#line 3677 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 21: /* statement: word_list_cmd  */
#line 473 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_statement_type) = parser.make_statement ((yyvsp[0].tree_index_expression_type)); }
#line 3683 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 22: /* word_list_cmd: identifier word_list  */
#line 485 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_index_expression_type) = parser.make_index_expression ((yyvsp[-1].tree_identifier_type), (yyvsp[0].tree_argument_list_type), '(');
                    if (! (yyval.tree_index_expression_type))
                      {
                        // make_index_expression deleted $1 and $2.
                        YYABORT;
                      }
                    (yyval.tree_index_expression_type)->mark_word_list_cmd ();
                  }
#line 3697 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 23: /* word_list: string  */
#line 497 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_constant_type)); }
#line 3703 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 24: /* word_list: word_list string  */
#line 499 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_argument_list_type)->append ((yyvsp[0].tree_constant_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3712 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 25: /* identifier: NAME  */
#line 510 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_identifier_type) = new octave::tree_identifier ((yyvsp[0].tok_val)->sym_rec (),
                                                      (yyvsp[0].tok_val)->line (),
                                                      (yyvsp[0].tok_val)->column ());
                  }
#line 3722 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 26: /* superclass_identifier: SUPERCLASSREF  */
#line 519 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    std::string meth = (yyvsp[0].tok_val)->superclass_method_name ();
                    std::string cls = (yyvsp[0].tok_val)->superclass_class_name ();

                    (yyval.tree_superclass_ref_type) = new octave::tree_superclass_ref (meth, cls,
                                                          (yyvsp[0].tok_val)->line (),
                                                          (yyvsp[0].tok_val)->column ());
                  }
#line 3735 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 27: /* meta_identifier: METAQUERY  */
#line 530 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    std::string cls = (yyvsp[0].tok_val)->text ();

                    (yyval.tree_metaclass_query_type) = new octave::tree_metaclass_query (cls, (yyvsp[0].tok_val)->line (),
                                                           (yyvsp[0].tok_val)->column ());
                  }
#line 3746 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 28: /* string: DQ_STRING  */
#line 539 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (DQ_STRING, (yyvsp[0].tok_val)); }
#line 3752 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 29: /* string: SQ_STRING  */
#line 541 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (SQ_STRING, (yyvsp[0].tok_val)); }
#line 3758 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 30: /* constant: NUMBER  */
#line 545 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = parser.make_constant (NUMBER, (yyvsp[0].tok_val)); }
#line 3764 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 31: /* constant: string  */
#line 547 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_constant_type) = (yyvsp[0].tree_constant_type); }
#line 3770 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 32: /* matrix: '[' matrix_rows ']'  */
#line 551 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.finish_matrix ((yyvsp[-1].tree_matrix_type), (yyvsp[-2].tok_val), (yyvsp[0].tok_val)); }
#line 3776 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 33: /* matrix_rows: cell_or_matrix_row  */
#line 555 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_matrix_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_matrix ((yyvsp[0].tree_argument_list_type)) : nullptr; }
#line 3782 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 34: /* matrix_rows: matrix_rows ';' cell_or_matrix_row  */
#line 557 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    if ((yyvsp[-2].tree_matrix_type))
                      {
                        if ((yyvsp[0].tree_argument_list_type))
                          (yyvsp[-2].tree_matrix_type)->append ((yyvsp[0].tree_argument_list_type));

                        (yyval.tree_matrix_type) = (yyvsp[-2].tree_matrix_type);
                      }
                    else
                      (yyval.tree_matrix_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_matrix ((yyvsp[0].tree_argument_list_type)) : nullptr;
                  }
#line 3800 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 35: /* cell: '{' cell_rows '}'  */
#line 573 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.finish_cell ((yyvsp[-1].tree_cell_type), (yyvsp[-2].tok_val), (yyvsp[0].tok_val)); }
#line 3806 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 36: /* cell_rows: cell_or_matrix_row  */
#line 577 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_cell_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_cell ((yyvsp[0].tree_argument_list_type)) : nullptr; }
#line 3812 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 37: /* cell_rows: cell_rows ';' cell_or_matrix_row  */
#line 579 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    if ((yyvsp[-2].tree_cell_type))
                      {
                        if ((yyvsp[0].tree_argument_list_type))
                          (yyvsp[-2].tree_cell_type)->append ((yyvsp[0].tree_argument_list_type));

                        (yyval.tree_cell_type) = (yyvsp[-2].tree_cell_type);
                      }
                    else
                      (yyval.tree_cell_type) = (yyvsp[0].tree_argument_list_type) ? new octave::tree_cell ((yyvsp[0].tree_argument_list_type)) : nullptr;
                  }
#line 3830 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 38: /* cell_or_matrix_row: %empty  */
#line 599 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = nullptr; }
#line 3836 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 39: /* cell_or_matrix_row: ','  */
#line 601 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = nullptr;
                  }
#line 3846 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 40: /* cell_or_matrix_row: arg_list  */
#line 607 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = (yyvsp[0].tree_argument_list_type); }
#line 3852 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 41: /* cell_or_matrix_row: arg_list ','  */
#line 609 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3862 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 42: /* cell_or_matrix_row: ',' arg_list  */
#line 615 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[0].tree_argument_list_type);
                  }
#line 3872 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 43: /* cell_or_matrix_row: ',' arg_list ','  */
#line 621 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_argument_list_type) = (yyvsp[-1].tree_argument_list_type);
                  }
#line 3883 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 44: /* fcn_handle: FCN_HANDLE  */
#line 630 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_fcn_handle_type) = parser.make_fcn_handle ((yyvsp[0].tok_val)); }
#line 3889 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 45: /* anon_fcn_handle: '@' param_list anon_fcn_begin expression  */
#line 638 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_anon_fcn_handle_type) = parser.make_anon_fcn_handle ((yyvsp[-2].tree_parameter_list_type), (yyvsp[0].tree_expression_type), (yyvsp[-3].tok_val)->beg_pos ());
                    if (! (yyval.tree_anon_fcn_handle_type))
                      {
                        // make_anon_fcn_handle deleted $2 and $4.
                        YYABORT;
                      }

                    lexer.m_parsing_anon_fcn_body = false;
                    lexer.m_nesting_level.remove ();
                  }
#line 3905 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 46: /* anon_fcn_handle: '@' param_list anon_fcn_begin error  */
#line 650 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-2].tree_parameter_list_type));

                    lexer.m_parsing_anon_fcn_body = false;

                    (yyval.tree_anon_fcn_handle_type) = nullptr;
                    parser.bison_error ("anonymous function bodies must be single expressions");
                    YYABORT;
                  }
#line 3920 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 47: /* primary_expr: identifier  */
#line 663 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_identifier_type); }
#line 3926 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 48: /* primary_expr: constant  */
#line 665 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_constant_type); }
#line 3932 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 49: /* primary_expr: fcn_handle  */
#line 667 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_fcn_handle_type); }
#line 3938 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 50: /* primary_expr: matrix  */
#line 669 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_looking_at_matrix_or_assign_lhs = false;
                    (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 3947 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 51: /* primary_expr: cell  */
#line 674 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 3953 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 52: /* primary_expr: meta_identifier  */
#line 676 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_metaclass_query_type); }
#line 3959 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 53: /* primary_expr: superclass_identifier  */
#line 678 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_superclass_ref_type); }
#line 3965 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 54: /* primary_expr: '(' expression ')'  */
#line 680 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = (yyvsp[-1].tree_expression_type)->mark_in_parens ();
                  }
#line 3976 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 55: /* magic_colon: ':'  */
#line 689 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    octave_value tmp (octave_value::magic_colon_t);
                    (yyval.tree_constant_type) = new octave::tree_constant (tmp);
                  }
#line 3987 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 56: /* magic_tilde: EXPR_NOT  */
#line 698 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_identifier_type) = new octave::tree_black_hole ();
                  }
#line 3997 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 57: /* arg_list: expression  */
#line 706 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_expression_type)); }
#line 4003 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 58: /* arg_list: magic_colon  */
#line 708 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_constant_type)); }
#line 4009 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 59: /* arg_list: magic_tilde  */
#line 710 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_argument_list_type) = new octave::tree_argument_list ((yyvsp[0].tree_identifier_type)); }
#line 4015 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 60: /* arg_list: arg_list ',' magic_colon  */
#line 712 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_constant_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 4026 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 61: /* arg_list: arg_list ',' magic_tilde  */
#line 719 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_identifier_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 4037 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 62: /* arg_list: arg_list ',' expression  */
#line 726 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_argument_list_type)->append ((yyvsp[0].tree_expression_type));
                    (yyval.tree_argument_list_type) = (yyvsp[-2].tree_argument_list_type);
                  }
#line 4048 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 63: /* indirect_ref_op: '.'  */
#line 735 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_indirect_ref = true;
                  }
#line 4059 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 64: /* oper_expr: primary_expr  */
#line 744 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4065 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 65: /* oper_expr: oper_expr PLUS_PLUS  */
#line 746 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (PLUS_PLUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4071 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 66: /* oper_expr: oper_expr MINUS_MINUS  */
#line 748 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (MINUS_MINUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4077 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 67: /* oper_expr: oper_expr '(' ')'  */
#line 750 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4093 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 68: /* oper_expr: oper_expr '(' arg_list ')'  */
#line 762 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4109 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 69: /* oper_expr: oper_expr '{' '}'  */
#line 774 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4125 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 70: /* oper_expr: oper_expr '{' arg_list '}'  */
#line 786 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4141 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 71: /* oper_expr: oper_expr HERMITIAN  */
#line 798 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (HERMITIAN, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4147 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 72: /* oper_expr: oper_expr TRANSPOSE  */
#line 800 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (TRANSPOSE, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4153 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 73: /* oper_expr: oper_expr indirect_ref_op STRUCT_ELT  */
#line 802 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-2].tree_expression_type), (yyvsp[0].tok_val)->text ()); }
#line 4159 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 74: /* oper_expr: oper_expr indirect_ref_op '(' expression ')'  */
#line 804 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_expression_type));
                  }
#line 4170 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 75: /* oper_expr: PLUS_PLUS oper_expr  */
#line 811 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (PLUS_PLUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4176 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 76: /* oper_expr: MINUS_MINUS oper_expr  */
#line 813 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (MINUS_MINUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4182 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 77: /* oper_expr: EXPR_NOT oper_expr  */
#line 815 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (EXPR_NOT, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4188 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 78: /* oper_expr: '+' oper_expr  */
#line 817 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('+', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4194 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 79: /* oper_expr: '-' oper_expr  */
#line 819 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('-', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4200 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 80: /* oper_expr: oper_expr POW power_expr  */
#line 821 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (POW, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4206 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 81: /* oper_expr: oper_expr EPOW power_expr  */
#line 823 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EPOW, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4212 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 82: /* oper_expr: oper_expr '+' oper_expr  */
#line 825 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('+', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4218 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 83: /* oper_expr: oper_expr '-' oper_expr  */
#line 827 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('-', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4224 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 84: /* oper_expr: oper_expr '*' oper_expr  */
#line 829 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('*', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4230 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 85: /* oper_expr: oper_expr '/' oper_expr  */
#line 831 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('/', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4236 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 86: /* oper_expr: oper_expr EPLUS oper_expr  */
#line 833 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('+', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4242 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 87: /* oper_expr: oper_expr EMINUS oper_expr  */
#line 835 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op ('-', (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4248 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 88: /* oper_expr: oper_expr EMUL oper_expr  */
#line 837 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EMUL, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4254 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 89: /* oper_expr: oper_expr EDIV oper_expr  */
#line 839 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4260 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 90: /* oper_expr: oper_expr LEFTDIV oper_expr  */
#line 841 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (LEFTDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4266 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 91: /* oper_expr: oper_expr ELEFTDIV oper_expr  */
#line 843 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (ELEFTDIV, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4272 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 92: /* power_expr: primary_expr  */
#line 847 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4278 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 93: /* power_expr: power_expr PLUS_PLUS  */
#line 849 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (PLUS_PLUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4284 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 94: /* power_expr: power_expr MINUS_MINUS  */
#line 851 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_postfix_op (MINUS_MINUS, (yyvsp[-1].tree_expression_type), (yyvsp[0].tok_val)); }
#line 4290 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 95: /* power_expr: power_expr '(' ')'  */
#line 853 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4306 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 96: /* power_expr: power_expr '(' arg_list ')'  */
#line 865 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '(');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4322 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 97: /* power_expr: power_expr '{' '}'  */
#line 877 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-2].tree_expression_type), nullptr, '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1.
                        YYABORT;
                      }
                  }
#line 4338 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 98: /* power_expr: power_expr '{' arg_list '}'  */
#line 889 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_index_expression ((yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_argument_list_type), '{');
                    if (! (yyval.tree_expression_type))
                      {
                        // make_index_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4354 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 99: /* power_expr: power_expr indirect_ref_op STRUCT_ELT  */
#line 901 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-2].tree_expression_type), (yyvsp[0].tok_val)->text ()); }
#line 4360 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 100: /* power_expr: power_expr indirect_ref_op '(' expression ')'  */
#line 903 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_expression_type) = parser.make_indirect_ref ((yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_expression_type));
                  }
#line 4371 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 101: /* power_expr: PLUS_PLUS power_expr  */
#line 910 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (PLUS_PLUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4377 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 102: /* power_expr: MINUS_MINUS power_expr  */
#line 912 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (MINUS_MINUS, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4383 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 103: /* power_expr: EXPR_NOT power_expr  */
#line 914 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op (EXPR_NOT, (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4389 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 104: /* power_expr: '+' power_expr  */
#line 916 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('+', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4395 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 105: /* power_expr: '-' power_expr  */
#line 918 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_prefix_op ('-', (yyvsp[0].tree_expression_type), (yyvsp[-1].tok_val)); }
#line 4401 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 106: /* colon_expr: oper_expr ':' oper_expr  */
#line 922 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_expression_type) = parser.make_colon_expression ((yyvsp[-2].tree_expression_type), (yyvsp[0].tree_expression_type));

                    if (! (yyval.tree_expression_type))
                      {
                        // finish_colon_expression deleted $1 and $3.
                        YYABORT;
                      }
                  }
#line 4417 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 107: /* colon_expr: oper_expr ':' oper_expr ':' oper_expr  */
#line 934 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_expression_type) = parser.make_colon_expression ((yyvsp[-4].tree_expression_type), (yyvsp[0].tree_expression_type), (yyvsp[-2].tree_expression_type));

                    if (! (yyval.tree_expression_type))
                      {
                        // finish_colon_expression deleted $1, $3, and $5.
                        YYABORT;
                      }
                  }
#line 4434 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 108: /* simple_expr: oper_expr  */
#line 949 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4440 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 109: /* simple_expr: colon_expr  */
#line 951 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type); }
#line 4446 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 110: /* simple_expr: simple_expr EXPR_LT simple_expr  */
#line 953 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_LT, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4452 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 111: /* simple_expr: simple_expr EXPR_LE simple_expr  */
#line 955 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_LE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4458 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 112: /* simple_expr: simple_expr EXPR_EQ simple_expr  */
#line 957 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_EQ, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4464 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 113: /* simple_expr: simple_expr EXPR_GE simple_expr  */
#line 959 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_GE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4470 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 114: /* simple_expr: simple_expr EXPR_GT simple_expr  */
#line 961 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_GT, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4476 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 115: /* simple_expr: simple_expr EXPR_NE simple_expr  */
#line 963 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_NE, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4482 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 116: /* simple_expr: simple_expr EXPR_AND simple_expr  */
#line 965 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_AND, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4488 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 117: /* simple_expr: simple_expr EXPR_OR simple_expr  */
#line 967 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_binary_op (EXPR_OR, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4494 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 118: /* simple_expr: simple_expr EXPR_AND_AND simple_expr  */
#line 969 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_boolean_op (EXPR_AND_AND, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4500 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 119: /* simple_expr: simple_expr EXPR_OR_OR simple_expr  */
#line 971 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_boolean_op (EXPR_OR_OR, (yyvsp[-2].tree_expression_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4506 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 120: /* assign_lhs: simple_expr  */
#line 975 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_argument_list_type) = parser.validate_matrix_for_assignment ((yyvsp[0].tree_expression_type));

                    if ((yyval.tree_argument_list_type))
                      { lexer.m_looking_at_matrix_or_assign_lhs = false; }
                    else
                      {
                        // validate_matrix_for_assignment deleted $1.
                        YYABORT;
                      }
                  }
#line 4522 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 121: /* assign_expr: assign_lhs '=' expression  */
#line 989 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op ('=', (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4528 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 122: /* assign_expr: assign_lhs ADD_EQ expression  */
#line 991 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (ADD_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4534 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 123: /* assign_expr: assign_lhs SUB_EQ expression  */
#line 993 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (SUB_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4540 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 124: /* assign_expr: assign_lhs MUL_EQ expression  */
#line 995 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (MUL_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4546 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 125: /* assign_expr: assign_lhs DIV_EQ expression  */
#line 997 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (DIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4552 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 126: /* assign_expr: assign_lhs LEFTDIV_EQ expression  */
#line 999 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (LEFTDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4558 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 127: /* assign_expr: assign_lhs POW_EQ expression  */
#line 1001 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (POW_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4564 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 128: /* assign_expr: assign_lhs EMUL_EQ expression  */
#line 1003 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EMUL_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4570 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 129: /* assign_expr: assign_lhs EDIV_EQ expression  */
#line 1005 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4576 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 130: /* assign_expr: assign_lhs ELEFTDIV_EQ expression  */
#line 1007 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (ELEFTDIV_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4582 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 131: /* assign_expr: assign_lhs EPOW_EQ expression  */
#line 1009 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (EPOW_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4588 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 132: /* assign_expr: assign_lhs AND_EQ expression  */
#line 1011 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (AND_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4594 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 133: /* assign_expr: assign_lhs OR_EQ expression  */
#line 1013 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = parser.make_assign_op (OR_EQ, (yyvsp[-2].tree_argument_list_type), (yyvsp[-1].tok_val), (yyvsp[0].tree_expression_type)); }
#line 4600 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 134: /* expression: simple_expr  */
#line 1017 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if ((yyvsp[0].tree_expression_type) && ((yyvsp[0].tree_expression_type)->is_matrix () || (yyvsp[0].tree_expression_type)->iscell ()))
                      {
                        if (parser.validate_array_list ((yyvsp[0].tree_expression_type)))
                          (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                        else
                          {
                            delete (yyvsp[0].tree_expression_type);
                            YYABORT;
                          }
                      }
                    else
                      (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 4619 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 135: /* expression: assign_expr  */
#line 1032 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! (yyvsp[0].tree_expression_type))
                      YYABORT;

                    (yyval.tree_expression_type) = (yyvsp[0].tree_expression_type);
                  }
#line 4630 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 136: /* expression: anon_fcn_handle  */
#line 1039 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_expression_type) = (yyvsp[0].tree_anon_fcn_handle_type); }
#line 4636 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 137: /* command: declaration  */
#line 1047 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_decl_command_type); }
#line 4642 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 138: /* command: select_command  */
#line 1049 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4648 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 139: /* command: loop_command  */
#line 1051 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4654 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 140: /* command: jump_command  */
#line 1053 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4660 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 141: /* command: spmd_command  */
#line 1055 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4666 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 142: /* command: except_command  */
#line 1057 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4672 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 143: /* command: function  */
#line 1059 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_function_def_type); }
#line 4678 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 144: /* command: file  */
#line 1061 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_command_type); }
#line 4684 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 145: /* declaration: GLOBAL decl1  */
#line 1069 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_decl_command_type) = parser.make_decl_command (GLOBAL, (yyvsp[-1].tok_val), (yyvsp[0].tree_decl_init_list_type));
                    lexer.m_looking_at_decl_list = false;
                  }
#line 4693 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 146: /* declaration: PERSISTENT decl1  */
#line 1074 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_decl_command_type) = parser.make_decl_command (PERSISTENT, (yyvsp[-1].tok_val), (yyvsp[0].tree_decl_init_list_type));
                    lexer.m_looking_at_decl_list = false;
                  }
#line 4702 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 147: /* decl1: decl2  */
#line 1081 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_init_list_type) = new octave::tree_decl_init_list ((yyvsp[0].tree_decl_elt_type)); }
#line 4708 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 148: /* decl1: decl1 decl2  */
#line 1083 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_decl_init_list_type)->append ((yyvsp[0].tree_decl_elt_type));
                    (yyval.tree_decl_init_list_type) = (yyvsp[-1].tree_decl_init_list_type);
                  }
#line 4717 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 149: /* decl_param_init: %empty  */
#line 1090 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_initializer_expression = true;
                  }
#line 4726 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 150: /* decl2: identifier  */
#line 1096 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)); }
#line 4732 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 151: /* decl2: identifier '=' decl_param_init expression  */
#line 1098 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;
                    (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type));
                  }
#line 4743 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 152: /* select_command: if_command  */
#line 1111 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_if_command_type); }
#line 4749 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 153: /* select_command: switch_command  */
#line 1113 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = (yyvsp[0].tree_switch_command_type); }
#line 4755 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 154: /* if_command: IF stash_comment if_cmd_list END  */
#line 1121 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_if_command_type) = parser.finish_if_command ((yyvsp[-3].tok_val), (yyvsp[-1].tree_if_command_list_type), (yyvsp[0].tok_val), (yyvsp[-2].comment_type))))
                      {
                        // finish_if_command deleted $3.
                        YYABORT;
                      }
                  }
#line 4767 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 155: /* if_cmd_list: if_cmd_list1  */
#line 1131 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_if_command_list_type) = (yyvsp[0].tree_if_command_list_type); }
#line 4773 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 156: /* if_cmd_list: if_cmd_list1 else_clause  */
#line 1133 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_if_command_list_type)->append ((yyvsp[0].tree_if_clause_type));
                    (yyval.tree_if_command_list_type) = (yyvsp[-1].tree_if_command_list_type);
                  }
#line 4782 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 157: /* if_cmd_list1: expression stmt_begin opt_sep opt_list  */
#line 1140 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-3].tree_expression_type)->mark_braindead_shortcircuit ();

                    (yyval.tree_if_command_list_type) = parser.start_if_command ((yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type));
                  }
#line 4794 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 158: /* if_cmd_list1: if_cmd_list1 elseif_clause  */
#line 1148 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_if_command_list_type)->append ((yyvsp[0].tree_if_clause_type));
                    (yyval.tree_if_command_list_type) = (yyvsp[-1].tree_if_command_list_type);
                  }
#line 4803 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 159: /* elseif_clause: ELSEIF stash_comment opt_sep expression stmt_begin opt_sep opt_list  */
#line 1155 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-4].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-3].tree_expression_type)->mark_braindead_shortcircuit ();

                    (yyval.tree_if_clause_type) = parser.make_elseif_clause ((yyvsp[-6].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type), (yyvsp[-5].comment_type));
                  }
#line 4816 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 160: /* else_clause: ELSE stash_comment opt_sep opt_list  */
#line 1166 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_if_clause_type) = new octave::tree_if_clause ((yyvsp[0].tree_statement_list_type), (yyvsp[-2].comment_type));
                  }
#line 4827 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 161: /* switch_command: SWITCH stash_comment expression opt_sep case_list END  */
#line 1179 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_switch_command_type) = parser.finish_switch_command ((yyvsp[-5].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[-1].tree_switch_case_list_type), (yyvsp[0].tok_val), (yyvsp[-4].comment_type))))
                      {
                        // finish_switch_command deleted $3 adn $5.
                        YYABORT;
                      }
                  }
#line 4841 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 162: /* case_list: %empty  */
#line 1191 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list (); }
#line 4847 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 163: /* case_list: default_case  */
#line 1193 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list ((yyvsp[0].tree_switch_case_type)); }
#line 4853 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 164: /* case_list: case_list1  */
#line 1195 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = (yyvsp[0].tree_switch_case_list_type); }
#line 4859 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 165: /* case_list: case_list1 default_case  */
#line 1197 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_switch_case_list_type)->append ((yyvsp[0].tree_switch_case_type));
                    (yyval.tree_switch_case_list_type) = (yyvsp[-1].tree_switch_case_list_type);
                  }
#line 4868 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 166: /* case_list1: switch_case  */
#line 1204 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_switch_case_list_type) = new octave::tree_switch_case_list ((yyvsp[0].tree_switch_case_type)); }
#line 4874 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 167: /* case_list1: case_list1 switch_case  */
#line 1206 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[-1].tree_switch_case_list_type)->append ((yyvsp[0].tree_switch_case_type));
                    (yyval.tree_switch_case_list_type) = (yyvsp[-1].tree_switch_case_list_type);
                  }
#line 4883 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 168: /* switch_case: CASE stash_comment opt_sep expression stmt_begin opt_sep opt_list  */
#line 1213 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-4].punct_type));
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_switch_case_type) = parser.make_switch_case ((yyvsp[-6].tok_val), (yyvsp[-3].tree_expression_type), (yyvsp[0].tree_statement_list_type), (yyvsp[-5].comment_type));
                  }
#line 4894 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 169: /* default_case: OTHERWISE stash_comment opt_sep opt_list  */
#line 1222 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyval.tree_switch_case_type) = new octave::tree_switch_case ((yyvsp[0].tree_statement_list_type), (yyvsp[-2].comment_type));
                  }
#line 4905 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 170: /* loop_command: WHILE stash_comment expression stmt_begin opt_sep opt_list END  */
#line 1235 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    (yyvsp[-4].tree_expression_type)->mark_braindead_shortcircuit ();

                    if (! ((yyval.tree_command_type) = parser.make_while_command ((yyvsp[-6].tok_val), (yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-5].comment_type))))
                      {
                        // make_while_command deleted $3 and $6.
                        YYABORT;
                      }
                  }
#line 4921 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 171: /* loop_command: DO stash_comment opt_sep opt_list UNTIL expression  */
#line 1247 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-3].punct_type));

                    (yyval.tree_command_type) = parser.make_do_until_command ((yyvsp[-1].tok_val), (yyvsp[-2].tree_statement_list_type), (yyvsp[0].tree_expression_type), (yyvsp[-4].comment_type));
                  }
#line 4932 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 172: /* loop_command: FOR stash_comment assign_lhs '=' expression stmt_begin opt_sep opt_list END  */
#line 1254 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (FOR, (yyvsp[-8].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type))))
                      {
                        // make_for_command deleted $3, $5, and $8.
                        YYABORT;
                      }
                  }
#line 4948 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 173: /* loop_command: FOR stash_comment '(' assign_lhs '=' expression ')' opt_sep opt_list END  */
#line 1266 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-7].tok_val));
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (FOR, (yyvsp[-9].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-8].comment_type))))
                      {
                        // make_for_command deleted $4, $6, and $9.
                        YYABORT;
                      }
                  }
#line 4966 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 174: /* loop_command: PARFOR stash_comment assign_lhs '=' expression stmt_begin opt_sep opt_list END  */
#line 1280 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (PARFOR, (yyvsp[-8].tok_val), (yyvsp[-6].tree_argument_list_type), (yyvsp[-4].tree_expression_type),
                                                         nullptr, (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type))))
                      {
                        // make_for_command deleted $3, $5, and $8.
                        YYABORT;
                      }
                  }
#line 4982 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 175: /* loop_command: PARFOR stash_comment '(' assign_lhs '=' expression ',' expression ')' opt_sep opt_list END  */
#line 1292 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-9].tok_val));
                    YYUSE ((yyvsp[-7].tok_val));
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_for_command (PARFOR, (yyvsp[-11].tok_val), (yyvsp[-8].tree_argument_list_type), (yyvsp[-6].tree_expression_type),
                                                         (yyvsp[-4].tree_expression_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-10].comment_type))))
                      {
                        // make_for_command deleted $4, $6, $8, and $11.
                        YYABORT;
                      }
                  }
#line 5001 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 176: /* jump_command: BREAK  */
#line 1313 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_command_type) = parser.make_break_command ((yyvsp[0].tok_val))))
                      YYABORT;
                  }
#line 5010 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 177: /* jump_command: CONTINUE  */
#line 1318 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.tree_command_type) = parser.make_continue_command ((yyvsp[0].tok_val))))
                      YYABORT;
                  }
#line 5019 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 178: /* jump_command: FUNC_RET  */
#line 1323 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_command_type) = parser.make_return_command ((yyvsp[0].tok_val)); }
#line 5025 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 179: /* spmd_command: SPMD stash_comment opt_sep opt_list END  */
#line 1331 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    octave::comment_list *lc = (yyvsp[-3].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_command_type) = parser.make_spmd_command ((yyvsp[-4].tok_val), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_spmd_command deleted $4, LC, and TC.
                        YYABORT;
                      }
                  }
#line 5042 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 180: /* except_command: UNWIND stash_comment opt_sep opt_list CLEANUP stash_comment opt_sep opt_list END  */
#line 1351 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-6].punct_type));
                    YYUSE ((yyvsp[-4].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_unwind_command ((yyvsp[-8].tok_val), (yyvsp[-5].tree_statement_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type), (yyvsp[-3].comment_type))))
                      {
                        // make_unwind_command deleted $4 and $8.
                        YYABORT;
                      }
                  }
#line 5058 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 181: /* except_command: TRY stash_comment opt_sep opt_list CATCH stash_comment opt_sep opt_list END  */
#line 1364 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-6].punct_type));
                    YYUSE ((yyvsp[-4].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_try_command ((yyvsp[-8].tok_val), (yyvsp[-5].tree_statement_list_type), (yyvsp[-2].punct_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tok_val), (yyvsp[-7].comment_type), (yyvsp[-3].comment_type))))
                      {
                        // make_try_command deleted $4 and $8.
                        YYABORT;
                      }
                  }
#line 5074 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 182: /* except_command: TRY stash_comment opt_sep opt_list END  */
#line 1376 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    if (! ((yyval.tree_command_type) = parser.make_try_command ((yyvsp[-4].tok_val), (yyvsp[-1].tree_statement_list_type), 0, nullptr,
                                                         (yyvsp[0].tok_val), (yyvsp[-3].comment_type), nullptr)))
                      {
                        // make_try_command deleted $4.
                        YYABORT;
                      }
                  }
#line 5089 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 183: /* push_fcn_symtab: %empty  */
#line 1393 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! parser.push_fcn_symtab ())
                      YYABORT;

                    (yyval.dummy_type) = 0;
                  }
#line 5100 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 184: /* param_list_beg: '('  */
#line 1406 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_parameter_list = true;

                    if (lexer.m_looking_at_function_handle)
                      {
                        // Will get a real name later.
                        lexer.m_symtab_context.push (octave::symbol_scope ("parser:param_lsit_beg"));
                        lexer.m_looking_at_function_handle--;
                        lexer.m_looking_at_anon_fcn_args = true;
                      }
                  }
#line 5119 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 185: /* param_list_end: ')'  */
#line 1423 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.dummy_type) = 0;
                    lexer.m_looking_at_parameter_list = false;
                    lexer.m_looking_for_object_index = false;
                  }
#line 5131 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 186: /* opt_param_list: %empty  */
#line 1433 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = nullptr; }
#line 5137 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 187: /* opt_param_list: param_list  */
#line 1435 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = (yyvsp[0].tree_parameter_list_type); }
#line 5143 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 188: /* param_list: param_list_beg param_list1 param_list_end  */
#line 1439 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if ((yyvsp[-1].tree_parameter_list_type))
                      lexer.mark_as_variables ((yyvsp[-1].tree_parameter_list_type)->variable_names ());

                    (yyval.tree_parameter_list_type) = (yyvsp[-1].tree_parameter_list_type);
                  }
#line 5154 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 189: /* param_list: param_list_beg error  */
#line 1446 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_parameter_list_type) = nullptr;
                    parser.bison_error ("invalid parameter list");
                    YYABORT;
                  }
#line 5164 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 190: /* param_list1: %empty  */
#line 1454 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (octave::tree_parameter_list::in); }
#line 5170 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 191: /* param_list1: param_list2  */
#line 1456 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyvsp[0].tree_parameter_list_type)->mark_as_formal_parameters ();

                    if (parser.validate_param_list ((yyvsp[0].tree_parameter_list_type), octave::tree_parameter_list::in))
                      {
                        lexer.mark_as_variables ((yyvsp[0].tree_parameter_list_type)->variable_names ());
                        (yyval.tree_parameter_list_type) = (yyvsp[0].tree_parameter_list_type);
                      }
                    else
                      {
                        delete (yyvsp[0].tree_parameter_list_type);
                        YYABORT;
                      }
                  }
#line 5189 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 192: /* param_list2: param_list_elt  */
#line 1473 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (octave::tree_parameter_list::in, (yyvsp[0].tree_decl_elt_type)); }
#line 5195 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 193: /* param_list2: param_list2 ',' param_list_elt  */
#line 1475 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_parameter_list_type)->append ((yyvsp[0].tree_decl_elt_type));
                    (yyval.tree_parameter_list_type) = (yyvsp[-2].tree_parameter_list_type);
                  }
#line 5206 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 194: /* param_list_elt: decl2  */
#line 1484 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = (yyvsp[0].tree_decl_elt_type); }
#line 5212 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 195: /* param_list_elt: magic_tilde  */
#line 1486 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_decl_elt_type) = new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)); }
#line 5218 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 196: /* return_list: '[' ']'  */
#line 1494 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    lexer.m_looking_at_return_list = false;

                    (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (octave::tree_parameter_list::out);
                  }
#line 5231 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 197: /* return_list: identifier  */
#line 1503 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_looking_at_return_list = false;

                    octave::tree_parameter_list *tmp
                      = new octave::tree_parameter_list (octave::tree_parameter_list::out, (yyvsp[0].tree_identifier_type));

                    // Even though this parameter list can contain only
                    // a single identifier, we still need to validate it
                    // to check for varargin or varargout.

                    if (parser.validate_param_list (tmp, octave::tree_parameter_list::out))
                      (yyval.tree_parameter_list_type) = tmp;
                    else
                      {
                        delete tmp;
                        YYABORT;
                      }
                  }
#line 5254 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 198: /* return_list: '[' return_list1 ']'  */
#line 1522 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    lexer.m_looking_at_return_list = false;

                    // Check for duplicate parameter names, varargin,
                    // or varargout.

                    if (parser.validate_param_list ((yyvsp[-1].tree_parameter_list_type), octave::tree_parameter_list::out))
                      (yyval.tree_parameter_list_type) = (yyvsp[-1].tree_parameter_list_type);
                    else
                      {
                        delete (yyvsp[-1].tree_parameter_list_type);
                        YYABORT;
                      }
                  }
#line 5276 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 199: /* return_list1: identifier  */
#line 1542 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_parameter_list_type) = new octave::tree_parameter_list (octave::tree_parameter_list::out, new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)));
                  }
#line 5284 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 200: /* return_list1: return_list1 ',' identifier  */
#line 1546 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_parameter_list_type)->append (new octave::tree_decl_elt ((yyvsp[0].tree_identifier_type)));
                    (yyval.tree_parameter_list_type) = (yyvsp[-2].tree_parameter_list_type);
                  }
#line 5295 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 201: /* parsing_local_fcns: %empty  */
#line 1560 "../libinterp/parse-tree/oct-parse.yy"
                  { parser.parsing_local_functions (true); }
#line 5301 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 202: /* push_script_symtab: %empty  */
#line 1564 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;

                    // This scope may serve as the parent scope for local
                    // functions in classdef files..
                    lexer.m_symtab_context.push (octave::symbol_scope ("parser:push_script_symtab"));
                  }
#line 5313 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 203: /* begin_file: push_script_symtab INPUT_FILE  */
#line 1574 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.dummy_type) = 0; }
#line 5319 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 204: /* file: begin_file opt_nl opt_list END_OF_INPUT  */
#line 1578 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    if (lexer.m_reading_fcn_file)
                      {
                        // Delete the dummy statement_list we created
                        // after parsing the function.  Any function
                        // definitions found in the file have already
                        // been stored in the symbol table or in
                        // base_parser::m_primary_fcn.

                        // Unused symbol table context.
                        lexer.m_symtab_context.pop ();

                        delete (yyvsp[-1].tree_statement_list_type);
                      }
                    else
                      {
                        octave::tree_statement *end_of_script
                          = parser.make_end ("endscript", true,
                                             (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());

                        parser.make_script ((yyvsp[-1].tree_statement_list_type), end_of_script);
                      }

                    (yyval.tree_command_type) = nullptr;
                  }
#line 5351 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 205: /* file: begin_file opt_nl classdef parsing_local_fcns opt_sep opt_fcn_list END_OF_INPUT  */
#line 1606 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].punct_type));
                    YYUSE ((yyvsp[-2].punct_type));
                    YYUSE ((yyvsp[0].tok_val));

                    // Unused symbol table context.
                    lexer.m_symtab_context.pop ();

                    parser.finish_classdef_file ((yyvsp[-4].tree_classdef_type), (yyvsp[-1].tree_statement_list_type));

                    (yyval.tree_command_type) = nullptr;
                  }
#line 5368 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 206: /* function_beg: push_fcn_symtab FCN  */
#line 1625 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tok_val) = (yyvsp[0].tok_val);
                    if (lexer.m_reading_classdef_file
                        || lexer.m_parsing_classdef)
                      lexer.m_maybe_classdef_get_set_method = true;
                  }
#line 5379 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 207: /* fcn_name: identifier  */
#line 1634 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_identifier_type) = parser.make_fcn_name ((yyvsp[0].tree_identifier_type));
                    if (! (yyval.tree_identifier_type))
                      {
                        // make_fcn_name deleted $1.
                        YYABORT;
                      }
                  }
#line 5392 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 208: /* fcn_name: GET '.' identifier  */
#line 1643 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[-1].tok_val));

                    lexer.m_parsed_function_name.top () = true;
                    lexer.m_maybe_classdef_get_set_method = false;
                    lexer.m_parsing_classdef_get_method = true;
                    (yyval.tree_identifier_type) = (yyvsp[0].tree_identifier_type);
                  }
#line 5406 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 209: /* fcn_name: SET '.' identifier  */
#line 1653 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[-1].tok_val));

                    lexer.m_parsed_function_name.top () = true;
                    lexer.m_maybe_classdef_get_set_method = false;
                    lexer.m_parsing_classdef_set_method = true;
                    (yyval.tree_identifier_type) = (yyvsp[0].tree_identifier_type);
                  }
#line 5420 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 210: /* function_end: END  */
#line 1665 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    parser.endfunction_found (true);

                    if (parser.end_token_ok ((yyvsp[0].tok_val), octave::token::function_end))
                      (yyval.tree_statement_type) = parser.make_end ("endfunction", false,
                                            (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());
                    else
                      {
                        parser.end_token_error ((yyvsp[0].tok_val), octave::token::function_end);
                        YYABORT;
                      }
                  }
#line 5437 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 211: /* function_end: END_OF_INPUT  */
#line 1678 "../libinterp/parse-tree/oct-parse.yy"
                  {
// A lot of tests are based on the assumption that this is OK
//                  if (lexer.m_reading_script_file)
//                    {
//                      parser.bison_error ("function body open at end of script");
//                      YYABORT;
//                    }

                    if (parser.endfunction_found ())
                      {
                        parser.bison_error ("inconsistent function endings -- "
                                 "if one function is explicitly ended, "
                                 "so must all the others");
                        YYABORT;
                      }

                    if (! (lexer.m_reading_fcn_file || lexer.m_reading_script_file
                           || lexer.input_from_eval_string ()))
                      {
                        parser.bison_error ("function body open at end of input");
                        YYABORT;
                      }

                    if (lexer.m_reading_classdef_file)
                      {
                        parser.bison_error ("classdef body open at end of input");
                        YYABORT;
                      }

                    (yyval.tree_statement_type) = parser.make_end ("endfunction", true,
                                          (yyvsp[0].tok_val)->beg_pos (), (yyvsp[0].tok_val)->end_pos ());
                  }
#line 5474 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 212: /* function: function_beg stash_comment fcn_name opt_param_list opt_sep opt_list function_end  */
#line 1714 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].punct_type));

                    (yyval.tree_function_def_type) = parser.make_function ((yyvsp[-6].tok_val), nullptr, (yyvsp[-4].tree_identifier_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tree_statement_type), (yyvsp[-5].comment_type));
                  }
#line 5484 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 213: /* function: function_beg stash_comment return_list '=' fcn_name opt_param_list opt_sep opt_list function_end  */
#line 1721 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-5].tok_val));
                    YYUSE ((yyvsp[-2].punct_type));

                    (yyval.tree_function_def_type) = parser.make_function ((yyvsp[-8].tok_val), (yyvsp[-6].tree_parameter_list_type), (yyvsp[-4].tree_identifier_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-1].tree_statement_list_type), (yyvsp[0].tree_statement_type), (yyvsp[-7].comment_type));
                  }
#line 5495 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 214: /* classdef_beg: CLASSDEF  */
#line 1734 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! lexer.m_reading_classdef_file)
                      {
                        parser.bison_error ("classdef must appear inside a file containing only a class definition");
                        YYABORT;
                      }

                    // Create invalid parent scope.
                    lexer.m_symtab_context.push (octave::symbol_scope ());
                    lexer.m_parsing_classdef = true;
                    lexer.m_parsing_classdef_decl = true;

                    (yyval.tok_val) = (yyvsp[0].tok_val);
                  }
#line 5514 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 215: /* classdef: classdef_beg stash_comment attr_list identifier opt_sep superclass_list class_body END  */
#line 1751 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-6].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    lexer.m_parsing_classdef = false;

                    if (! ((yyval.tree_classdef_type) = parser.make_classdef ((yyvsp[-7].tok_val), (yyvsp[-5].tree_classdef_attribute_list_type), (yyvsp[-4].tree_identifier_type), (yyvsp[-2].tree_classdef_superclass_list_type), (yyvsp[-1].tree_classdef_body_type), (yyvsp[0].tok_val),
                                                      lc, tc)))
                      {
                        // make_classdef deleted $3, $4, $6, $7, LC, and
                        // TC.
                        YYABORT;
                      }
                  }
#line 5535 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 216: /* attr_list: %empty  */
#line 1770 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_list_type) = nullptr; }
#line 5541 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 217: /* attr_list: '(' attr_list1 ')' opt_sep  */
#line 1772 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].tok_val));
                    YYUSE ((yyvsp[-1].tok_val));
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_attribute_list_type) = (yyvsp[-2].tree_classdef_attribute_list_type);
                  }
#line 5553 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 218: /* attr_list1: attr  */
#line 1782 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_list_type) = new octave::tree_classdef_attribute_list ((yyvsp[0].tree_classdef_attribute_type)); }
#line 5559 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 219: /* attr_list1: attr_list1 ',' attr  */
#line 1784 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_classdef_attribute_list_type)->append ((yyvsp[0].tree_classdef_attribute_type));
                    (yyval.tree_classdef_attribute_list_type) = (yyvsp[-2].tree_classdef_attribute_list_type);
                  }
#line 5570 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 220: /* attr: identifier  */
#line 1793 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[0].tree_identifier_type)); }
#line 5576 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 221: /* attr: identifier '=' decl_param_init expression  */
#line 1795 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;
                    (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type));
                  }
#line 5587 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 222: /* attr: EXPR_NOT identifier  */
#line 1802 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_classdef_attribute_type) = new octave::tree_classdef_attribute ((yyvsp[0].tree_identifier_type), false);
                  }
#line 5597 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 223: /* superclass_list: %empty  */
#line 1810 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_parsing_classdef_decl = false;
                    lexer.m_parsing_classdef_superclass = false;

                    (yyval.tree_classdef_superclass_list_type) = nullptr;
                  }
#line 5608 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 224: /* superclass_list: superclass_list1 opt_sep  */
#line 1817 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    lexer.m_parsing_classdef_decl = false;
                    lexer.m_parsing_classdef_superclass = false;

                    (yyval.tree_classdef_superclass_list_type) = (yyvsp[-1].tree_classdef_superclass_list_type);
                  }
#line 5621 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 225: /* superclass_list1: EXPR_LT superclass  */
#line 1829 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyval.tree_classdef_superclass_list_type) = new octave::tree_classdef_superclass_list ((yyvsp[0].tree_classdef_superclass_type));
                  }
#line 5631 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 226: /* superclass_list1: superclass_list1 EXPR_AND superclass  */
#line 1835 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].tok_val));

                    (yyvsp[-2].tree_classdef_superclass_list_type)->append ((yyvsp[0].tree_classdef_superclass_type));
                    (yyval.tree_classdef_superclass_list_type) = (yyvsp[-2].tree_classdef_superclass_list_type);
                  }
#line 5642 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 227: /* superclass: FQ_IDENT  */
#line 1844 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_superclass_type) = new octave::tree_classdef_superclass ((yyvsp[0].tok_val)->text ()); }
#line 5648 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 228: /* class_body: %empty  */
#line 1848 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = nullptr; }
#line 5654 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 229: /* class_body: class_body1 opt_sep  */
#line 1850 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_body_type) = (yyvsp[-1].tree_classdef_body_type);
                  }
#line 5664 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 230: /* class_body1: properties_block  */
#line 1858 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_properties_block_type)); }
#line 5670 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 231: /* class_body1: methods_block  */
#line 1860 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_methods_block_type)); }
#line 5676 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 232: /* class_body1: events_block  */
#line 1862 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_events_block_type)); }
#line 5682 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 233: /* class_body1: enum_block  */
#line 1864 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_body_type) = new octave::tree_classdef_body ((yyvsp[0].tree_classdef_enum_block_type)); }
#line 5688 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 234: /* class_body1: class_body1 opt_sep properties_block  */
#line 1866 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_properties_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5699 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 235: /* class_body1: class_body1 opt_sep methods_block  */
#line 1873 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_methods_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5710 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 236: /* class_body1: class_body1 opt_sep events_block  */
#line 1880 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_events_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5721 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 237: /* class_body1: class_body1 opt_sep enum_block  */
#line 1887 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_body_type)->append ((yyvsp[0].tree_classdef_enum_block_type));
                    (yyval.tree_classdef_body_type) = (yyvsp[-2].tree_classdef_body_type);
                  }
#line 5732 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 238: /* properties_block: PROPERTIES stash_comment opt_sep attr_list property_list END  */
#line 1897 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-4].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_classdef_properties_block_type) = parser.make_classdef_properties_block
                           ((yyvsp[-5].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), (yyvsp[-1].tree_classdef_property_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_classdef_properties_block deleted $4,
                        // $5, LC, and TC.
                        YYABORT;
                      }
                  }
#line 5751 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 239: /* property_list: %empty  */
#line 1914 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_property_list_type) = nullptr; }
#line 5757 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 240: /* property_list: property_list1 opt_sep  */
#line 1916 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_property_list_type) = (yyvsp[-1].tree_classdef_property_list_type);
                  }
#line 5767 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 241: /* property_list1: class_property  */
#line 1925 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_property_list_type) = new octave::tree_classdef_property_list ((yyvsp[0].tree_classdef_property_type)); }
#line 5773 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 242: /* property_list1: property_list1 sep class_property  */
#line 1927 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    // We don't look ahead to grab end-of-line comments.
                    // Instead, they are grabbed when we see the
                    // identifier that becomes the next element in the
                    // list.  If the element at the end of the list
                    // doesn't have a doc string, see whether the
                    // element we are adding is stroing an end-of-line
                    // comment for us to use.

                    octave::tree_classdef_property *last_elt = (yyvsp[-2].tree_classdef_property_list_type)->back ();

                    if (! last_elt->have_doc_string ())
                      {
                        octave::comment_list *cl = (yyvsp[0].tree_classdef_property_type)->comments ();

                        if (cl)
                          {
                            octave::comment_elt elt = cl->front ();

                            if (elt.is_end_of_line ())
                              last_elt->doc_string (elt.text ());
                          }
                      }

                    (yyvsp[-2].tree_classdef_property_list_type)->append ((yyvsp[0].tree_classdef_property_type));
                    (yyval.tree_classdef_property_list_type) = (yyvsp[-2].tree_classdef_property_list_type);
                  }
#line 5807 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 243: /* class_property: stash_comment identifier  */
#line 1959 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.tree_classdef_property_type) = new octave::tree_classdef_property ((yyvsp[0].tree_identifier_type), (yyvsp[-1].comment_type));
                  }
#line 5815 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 244: /* class_property: stash_comment identifier '=' decl_param_init expression  */
#line 1963 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));

                    lexer.m_looking_at_initializer_expression = false;

                    (yyval.tree_classdef_property_type) = new octave::tree_classdef_property ((yyvsp[-3].tree_identifier_type), (yyvsp[0].tree_expression_type), (yyvsp[-4].comment_type));
                  }
#line 5827 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 245: /* methods_block: METHODS stash_comment opt_sep attr_list methods_list END  */
#line 1973 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-4].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_classdef_methods_block_type) = parser.make_classdef_methods_block
                           ((yyvsp[-5].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), (yyvsp[-1].tree_classdef_methods_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_classdef_methods_block deleted $4, $5,
                        // LC, and TC.
                        YYABORT;
                      }
                  }
#line 5846 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 246: /* method_decl1: identifier  */
#line 1990 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.octave_user_function_type) = parser.start_classdef_external_method ((yyvsp[0].tree_identifier_type), nullptr)))
                      YYABORT;
                  }
#line 5855 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 247: /* method_decl1: identifier param_list  */
#line 1995 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    if (! ((yyval.octave_user_function_type) = parser.start_classdef_external_method ((yyvsp[-1].tree_identifier_type), (yyvsp[0].tree_parameter_list_type))))
                      YYABORT;
                  }
#line 5864 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 248: /* method_decl: stash_comment method_decl1  */
#line 2002 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = parser.finish_classdef_external_method ((yyvsp[0].octave_user_function_type), nullptr, (yyvsp[-1].comment_type)); }
#line 5870 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 249: /* $@1: %empty  */
#line 2004 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    lexer.m_defining_func++;
                    lexer.m_parsed_function_name.push (false);
                  }
#line 5881 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 250: /* method_decl: stash_comment return_list '=' $@1 method_decl1  */
#line 2011 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    lexer.m_defining_func--;
                    lexer.m_parsed_function_name.pop ();

                    (yyval.tree_function_def_type) = parser.finish_classdef_external_method ((yyvsp[0].octave_user_function_type), (yyvsp[-3].tree_parameter_list_type), (yyvsp[-4].comment_type));
                  }
#line 5892 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 251: /* method: method_decl  */
#line 2020 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = (yyvsp[0].tree_function_def_type); }
#line 5898 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 252: /* method: function  */
#line 2022 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_function_def_type) = (yyvsp[0].tree_function_def_type); }
#line 5904 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 253: /* methods_list: %empty  */
#line 2026 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_methods_list_type) = nullptr; }
#line 5910 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 254: /* methods_list: methods_list1 opt_sep  */
#line 2028 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_methods_list_type) = (yyvsp[-1].tree_classdef_methods_list_type);
                  }
#line 5920 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 255: /* methods_list1: method  */
#line 2036 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    octave_value fcn;
                    if ((yyvsp[0].tree_function_def_type))
                      fcn = (yyvsp[0].tree_function_def_type)->function ();
                    delete (yyvsp[0].tree_function_def_type);
                    (yyval.tree_classdef_methods_list_type) = new octave::tree_classdef_methods_list (fcn);
                  }
#line 5932 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 256: /* methods_list1: methods_list1 opt_sep method  */
#line 2044 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    octave_value fcn;
                    if ((yyvsp[0].tree_function_def_type))
                      fcn = (yyvsp[0].tree_function_def_type)->function ();
                    delete (yyvsp[0].tree_function_def_type);

                    (yyvsp[-2].tree_classdef_methods_list_type)->append (fcn);
                    (yyval.tree_classdef_methods_list_type) = (yyvsp[-2].tree_classdef_methods_list_type);
                  }
#line 5948 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 257: /* events_block: EVENTS stash_comment opt_sep attr_list events_list END  */
#line 2058 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-4].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_classdef_events_block_type) = parser.make_classdef_events_block
                           ((yyvsp[-5].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), (yyvsp[-1].tree_classdef_events_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_classdef_events_block deleted $4, $5,
                        // LC, and TC.
                        YYABORT;
                      }
                  }
#line 5967 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 258: /* events_list: %empty  */
#line 2075 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_events_list_type) = nullptr; }
#line 5973 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 259: /* events_list: events_list1 opt_sep  */
#line 2077 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_events_list_type) = (yyvsp[-1].tree_classdef_events_list_type);
                  }
#line 5983 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 260: /* events_list1: class_event  */
#line 2085 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_events_list_type) = new octave::tree_classdef_events_list ((yyvsp[0].tree_classdef_event_type)); }
#line 5989 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 261: /* events_list1: events_list1 opt_sep class_event  */
#line 2087 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_events_list_type)->append ((yyvsp[0].tree_classdef_event_type));
                    (yyval.tree_classdef_events_list_type) = (yyvsp[-2].tree_classdef_events_list_type);
                  }
#line 6000 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 262: /* class_event: stash_comment identifier  */
#line 2096 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_event_type) = new octave::tree_classdef_event ((yyvsp[0].tree_identifier_type), (yyvsp[-1].comment_type)); }
#line 6006 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 263: /* enum_block: ENUMERATION stash_comment opt_sep attr_list enum_list END  */
#line 2100 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-3].punct_type));

                    octave::comment_list *lc = (yyvsp[-4].comment_type);
                    octave::comment_list *tc = lexer.get_comment ();

                    if (! ((yyval.tree_classdef_enum_block_type) = parser.make_classdef_enum_block
                           ((yyvsp[-5].tok_val), (yyvsp[-2].tree_classdef_attribute_list_type), (yyvsp[-1].tree_classdef_enum_list_type), (yyvsp[0].tok_val), lc, tc)))
                      {
                        // make_classdef_enum_block deleted $4, $5, LC,
                        // and TC.
                        YYABORT;
                      }
                  }
#line 6025 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 264: /* enum_list: %empty  */
#line 2117 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_enum_list_type) = nullptr; }
#line 6031 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 265: /* enum_list: enum_list1 opt_sep  */
#line 2119 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].punct_type));

                    (yyval.tree_classdef_enum_list_type) = (yyvsp[-1].tree_classdef_enum_list_type);
                  }
#line 6041 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 266: /* enum_list1: class_enum  */
#line 2127 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.tree_classdef_enum_list_type) = new octave::tree_classdef_enum_list ((yyvsp[0].tree_classdef_enum_type)); }
#line 6047 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 267: /* enum_list1: enum_list1 opt_sep class_enum  */
#line 2129 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-1].punct_type));

                    (yyvsp[-2].tree_classdef_enum_list_type)->append ((yyvsp[0].tree_classdef_enum_type));
                    (yyval.tree_classdef_enum_list_type) = (yyvsp[-2].tree_classdef_enum_list_type);
                  }
#line 6058 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 268: /* class_enum: stash_comment identifier '(' expression ')'  */
#line 2138 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[-2].tok_val));
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.tree_classdef_enum_type) = new octave::tree_classdef_enum ((yyvsp[-3].tree_identifier_type), (yyvsp[-1].tree_expression_type), (yyvsp[-4].comment_type));
                  }
#line 6069 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 269: /* stmt_begin: %empty  */
#line 2151 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_at_beginning_of_statement = true;
                  }
#line 6078 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 270: /* anon_fcn_begin: %empty  */
#line 2158 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    lexer.m_at_beginning_of_statement = true;
                    lexer.m_parsing_anon_fcn_body = true;
                  }
#line 6088 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 271: /* stash_comment: %empty  */
#line 2166 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.comment_type) = lexer.get_comment (); }
#line 6094 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 272: /* parse_error: LEXICAL_ERROR  */
#line 2170 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    (yyval.dummy_type) = 0;
                    std::string msg = (yyvsp[0].tok_val)->text ();
                    parser.bison_error (msg.c_str ());
                  }
#line 6104 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 273: /* parse_error: error  */
#line 2176 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.dummy_type) = 0; }
#line 6110 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 274: /* sep_no_nl: ','  */
#line 2180 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ',';
                  }
#line 6120 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 275: /* sep_no_nl: ';'  */
#line 2186 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ';';
                  }
#line 6130 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 276: /* sep_no_nl: sep_no_nl ','  */
#line 2192 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6140 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 277: /* sep_no_nl: sep_no_nl ';'  */
#line 2198 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6150 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 278: /* opt_sep_no_nl: %empty  */
#line 2206 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 6156 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 279: /* opt_sep_no_nl: sep_no_nl  */
#line 2208 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 6162 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 280: /* opt_nl: %empty  */
#line 2212 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 6168 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 281: /* opt_nl: nl  */
#line 2214 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 6174 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 282: /* nl: '\n'  */
#line 2218 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = '\n';
                  }
#line 6184 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 283: /* nl: nl '\n'  */
#line 2224 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6194 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 284: /* sep: ','  */
#line 2232 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ',';
                  }
#line 6204 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 285: /* sep: ';'  */
#line 2238 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = ';';
                  }
#line 6214 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 286: /* sep: '\n'  */
#line 2244 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = '\n';
                  }
#line 6224 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 287: /* sep: sep ','  */
#line 2250 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6234 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 288: /* sep: sep ';'  */
#line 2256 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6244 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 289: /* sep: sep '\n'  */
#line 2262 "../libinterp/parse-tree/oct-parse.yy"
                  {
                    YYUSE ((yyvsp[0].tok_val));

                    (yyval.punct_type) = (yyvsp[-1].punct_type);
                  }
#line 6254 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 290: /* opt_sep: %empty  */
#line 2270 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = 0; }
#line 6260 "libinterp/parse-tree/oct-parse.cc"
    break;

  case 291: /* opt_sep: sep  */
#line 2272 "../libinterp/parse-tree/oct-parse.yy"
                  { (yyval.punct_type) = (yyvsp[0].punct_type); }
#line 6266 "libinterp/parse-tree/oct-parse.cc"
    break;


#line 6270 "libinterp/parse-tree/oct-parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == OCTAVE_EMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (parser, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= OCTAVE_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == OCTAVE_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parser);
          yychar = OCTAVE_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, parser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (parser, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != OCTAVE_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parser);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, parser);
      YYPOPSTACK (1);
    }
  yyps->yynew = 2;
  goto yypushreturn;


/*-------------------------.
| yypushreturn -- return.  |
`-------------------------*/
yypushreturn:

  return yyresult;
}
#undef octave_nerrs
#undef yystate
#undef yyerrstatus
#undef yyssa
#undef yyss
#undef yyssp
#undef yyvsa
#undef yyvs
#undef yyvsp
#undef yystacksize
#line 2275 "../libinterp/parse-tree/oct-parse.yy"


#if defined (HAVE_PRAGMA_GCC_DIAGNOSTIC)
   // Restore prevailing warning state for remainder of the file.
#  pragma GCC diagnostic pop
#endif

// Generic error messages.

#undef lexer
#undef scanner

static void
yyerror (octave::base_parser& parser, const char *s)
{
  parser.bison_error (s);
}

namespace octave
{
  size_t
  base_parser::parent_scope_info::size (void) const
  {
    return m_info.size ();
  }

  void
  base_parser::parent_scope_info::push (const value_type& elt)
  {
    m_info.push_back (elt);
  }

  void
  base_parser::parent_scope_info::push (const symbol_scope& scope)
  {
    push (value_type (scope, ""));
  }

  void
  base_parser::parent_scope_info::pop (void)
  {
    m_info.pop_back ();
  }

  bool
  base_parser::parent_scope_info::name_ok (const std::string& name)
  {
    // Name can't be the same as any parent function or any other
    // function we've already seen.  We could maintain a complex
    // tree structure of names, or we can just store the set of
    // full names of all the functions, which must be unique.

    std::string full_name;

    for (size_t i = 0; i < size()-1; i++)
      {
        const value_type& elt = m_info[i];

        if (name == elt.second)
          return false;

        full_name += elt.second + ">";
      }

    full_name += name;

    if (m_all_names.find (full_name) != m_all_names.end ())
      return false;

    m_all_names.insert (full_name);

    return true;
  }

  bool
  base_parser::parent_scope_info::name_current_scope (const std::string& name)
  {
    if (! name_ok (name))
      return false;

    if (size () > 0)
      m_info.back().second = name;

    return true;
  }

  symbol_scope
  base_parser::parent_scope_info::parent_scope (void) const
  {
    return size () > 1 ? m_info[size()-2].first : symbol_scope ();
  }

  std::string
  base_parser::parent_scope_info::parent_name (void) const
  {
    return m_info[size()-2].second;
  }

  void base_parser::parent_scope_info::clear (void)
  {
    m_info.clear ();
    m_all_names.clear ();
  }

  base_parser::base_parser (base_lexer& lxr)
    : m_endfunction_found (false), m_autoloading (false),
      m_fcn_file_from_relative_lookup (false),
      m_parsing_subfunctions (false), m_parsing_local_functions (false),
      m_max_fcn_depth (-1), m_curr_fcn_depth (-1), m_primary_fcn_scope (),
      m_curr_class_name (), m_curr_package_name (), m_function_scopes (),
      m_primary_fcn (), m_subfunction_names (), m_classdef_object (),
      m_stmt_list (), m_lexer (lxr), m_parser_state (yypstate_new ())
  { }

  base_parser::~base_parser (void)
  {
    delete &m_lexer;

    // FIXME: Deleting the internal Bison parser state structure does
    // not clean up any partial parse trees in the event of an interrupt or
    // error.  It's not clear how to safely do that with the C language
    // parser that Bison generates.  The C++ language parser that Bison
    // generates would do it for us automatically whenever an exception
    // is thrown while parsing input, but there is currently no C++
    // interface for a push parser.

    yypstate_delete (static_cast<yypstate *> (m_parser_state));
  }

  void
  base_parser::reset (void)
  {
    m_endfunction_found = false;
    m_autoloading = false;
    m_fcn_file_from_relative_lookup = false;
    m_parsing_subfunctions = false;
    m_parsing_local_functions = false;
    m_max_fcn_depth = -1;
    m_curr_fcn_depth = -1;
    m_primary_fcn_scope = symbol_scope ();
    m_curr_class_name = "";
    m_curr_package_name = "";
    m_function_scopes.clear ();
    m_primary_fcn = octave_value ();
    m_subfunction_names.clear ();
    m_classdef_object.reset ();
    m_stmt_list.reset ();

    m_lexer.reset ();

    yypstate_delete (static_cast<yypstate *> (m_parser_state));
    m_parser_state = yypstate_new ();
  }

  // Error messages for mismatched end tokens.

  static std::string
  end_token_as_string (token::end_tok_type ettype)
  {
    std::string retval = "<unknown>";

    switch (ettype)
      {
      case token::simple_end:
        retval = "end";
        break;

      case token::classdef_end:
        retval = "endclassdef";
        break;

      case token::enumeration_end:
        retval = "endenumeration";
        break;

      case token::events_end:
        retval = "endevents";
        break;

      case token::for_end:
        retval = "endfor";
        break;

      case token::function_end:
        retval = "endfunction";
        break;

      case token::if_end:
        retval = "endif";
        break;

      case token::methods_end:
        retval = "endmethods";
        break;

      case token::parfor_end:
        retval = "endparfor";
        break;

      case token::properties_end:
        retval = "endproperties";
        break;

      case token::spmd_end:
        retval = "endspmd";
        break;

      case token::switch_end:
        retval = "endswitch";
        break;

      case token::try_catch_end:
        retval = "end_try_catch";
        break;

      case token::unwind_protect_end:
        retval = "end_unwind_protect";
        break;

      case token::while_end:
        retval = "endwhile";
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  void
  base_parser::statement_list (std::shared_ptr<tree_statement_list>& lst)
  {
    if (m_stmt_list)
      {
        // Append additional code to existing statement list.

        while (! lst->empty ())
          {
            m_stmt_list->push_back (lst->front ());
            lst->pop_front ();
          }
      }
    else
      m_stmt_list = lst;
  }

  void
  base_parser::end_token_error (token *tok, token::end_tok_type expected)
  {
    std::string msg = ("'" + end_token_as_string (expected)
                       + "' command matched by '"
                       + end_token_as_string (tok->ettype ()) + "'");

    bison_error (msg, tok->beg_pos ());
  }

  // Check to see that end tokens are properly matched.

  bool
  base_parser::end_token_ok (token *tok, token::end_tok_type expected)
  {
    token::end_tok_type ettype = tok->ettype ();

    return ettype == expected || ettype == token::simple_end;
  }

  bool
  base_parser::push_fcn_symtab (void)
  {
    m_curr_fcn_depth++;

    if (m_max_fcn_depth < m_curr_fcn_depth)
      m_max_fcn_depth = m_curr_fcn_depth;

    // Will get a real name later.
    m_lexer.m_symtab_context.push (octave::symbol_scope ("parser:push_fcn_symtab"));
    m_function_scopes.push (m_lexer.m_symtab_context.curr_scope ());

    if (! m_lexer.m_reading_script_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
        {
          m_primary_fcn_scope = m_lexer.m_symtab_context.curr_scope ();
          m_primary_fcn_scope.mark_primary_fcn_scope ();
        }

    if (m_lexer.m_reading_script_file && m_curr_fcn_depth > 0)
      {
        bison_error ("nested functions not implemented in this context");

        return false;
      }

    return true;
  }

  // Make a constant.

  tree_constant *
  base_parser::make_constant (int op, token *tok_val)
  {
    int l = tok_val->line ();
    int c = tok_val->column ();

    tree_constant *retval = nullptr;

    switch (op)
      {
      case NUMBER:
        {
          retval = new tree_constant (tok_val->number (), l, c);
          retval->stash_original_text (tok_val->text_rep ());
        }
        break;

      case DQ_STRING:
      case SQ_STRING:
        {
          std::string txt = tok_val->text ();

          char delim = op == DQ_STRING ? '"' : '\'';
          octave_value tmp (txt, delim);

          if (txt.empty ())
            {
              if (op == DQ_STRING)
                tmp = octave_null_str::instance;
              else
                tmp = octave_null_sq_str::instance;
            }

          retval = new tree_constant (tmp, l, c);

          if (op == DQ_STRING)
            txt = undo_string_escapes (txt);

          // FIXME: maybe this should also be handled by
          // tok_val->text_rep () for character strings?
          retval->stash_original_text (delim + txt + delim);
        }
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  // Make a function handle.

  tree_fcn_handle *
  base_parser::make_fcn_handle (token *tok_val)
  {
    int l = tok_val->line ();
    int c = tok_val->column ();

    tree_fcn_handle *retval = new tree_fcn_handle (tok_val->text (), l, c);

    return retval;
  }

  // Make an anonymous function handle.

  tree_anon_fcn_handle *
  base_parser::make_anon_fcn_handle (tree_parameter_list *param_list,
                                     tree_expression *expr,
                                     const filepos& at_pos)
  {
    // FIXME: We need to examine EXPR and issue an error if any
    // sub-expression contains an assignment, compound assignment,
    // increment, or decrement operator.

    anon_fcn_validator validator (param_list, expr);

    if (! validator.ok ())
      {
        delete param_list;
        delete expr;

        bison_error (validator.message (), validator.line (),
                     validator.column ());

        return nullptr;
      }

    symbol_scope fcn_scope = m_lexer.m_symtab_context.curr_scope ();
    symbol_scope parent_scope = m_lexer.m_symtab_context.parent_scope ();

    m_lexer.m_symtab_context.pop ();

    expr->set_print_flag (false);

    fcn_scope.mark_static ();

    int at_line = at_pos.line ();
    int at_column = at_pos.column ();

    tree_anon_fcn_handle *retval
      = new tree_anon_fcn_handle (param_list, expr, fcn_scope,
                                  parent_scope, at_line, at_column);

    std::ostringstream buf;

    tree_print_code tpc (buf);

    retval->accept (tpc);

    std::string file = m_lexer.m_fcn_file_full_name;
    if (! file.empty ())
      buf << ": file: " << file;
    else if (m_lexer.input_from_terminal ())
      buf << ": *terminal input*";
    else if (m_lexer.input_from_eval_string ())
      buf << ": *eval string*";
    buf << ": line: " << at_line << " column: " << at_column;

    std::string scope_name = buf.str ();

    fcn_scope.cache_name (scope_name);

    // FIXME: Stash the filename.  This does not work and produces
    // errors when executed.
    //retval->stash_file_name (m_lexer.m_fcn_file_name);

    return retval;
  }

  // Build a colon expression.

  tree_expression *
  base_parser::make_colon_expression (tree_expression *base,
                                      tree_expression *limit,
                                      tree_expression *incr)
  {
    tree_expression *retval = nullptr;

    if (! base || ! limit)
      {
        delete base;
        delete limit;
        delete incr;

        return retval;
      }

    int l = base->line ();
    int c = base->column ();

    tree_colon_expression *expr
      = new tree_colon_expression (base, limit, incr, l, c);

    retval = expr;

    if (base->is_constant () && limit->is_constant ()
        && (! incr || incr->is_constant ()))
      {
        interpreter& interp = __get_interpreter__ ("finish_colon_expression");

        try
          {
            // If the evaluation generates a warning message, restore
            // the previous value of last_warning_message and skip the
            // conversion to a constant value.

            unwind_protect frame;

            error_system& es = interp.get_error_system ();

            frame.add_method (es, &error_system::set_last_warning_message,
                              es.last_warning_message (""));

            frame.add_method (es, &error_system::set_discard_warning_messages,
                              es.discard_warning_messages (true));

            tree_evaluator& tw = interp.get_evaluator ();

            octave_value tmp = expr->evaluate (tw);

            std::string msg = es.last_warning_message ();

            if (msg.empty ())
              {
                tree_constant *tc_retval
                  = new tree_constant (tmp, expr->line (), expr->column ());

                std::ostringstream buf;

                tree_print_code tpc (buf);

                expr->accept (tpc);

                tc_retval->stash_original_text (buf.str ());

                delete expr;

                retval = tc_retval;
              }
          }
        catch (const execution_exception&)
          {
            interp.recover_from_exception ();
          }
      }

    return retval;
  }

  // Build a binary expression.

  tree_expression *
  base_parser::make_binary_op (int op, tree_expression *op1,
                               token *tok_val, tree_expression *op2)
  {
    octave_value::binary_op t = octave_value::unknown_binary_op;

    switch (op)
      {
      case POW:
        t = octave_value::op_pow;
        break;

      case EPOW:
        t = octave_value::op_el_pow;
        break;

      case '+':
        t = octave_value::op_add;
        break;

      case '-':
        t = octave_value::op_sub;
        break;

      case '*':
        t = octave_value::op_mul;
        break;

      case '/':
        t = octave_value::op_div;
        break;

      case EMUL:
        t = octave_value::op_el_mul;
        break;

      case EDIV:
        t = octave_value::op_el_div;
        break;

      case LEFTDIV:
        t = octave_value::op_ldiv;
        break;

      case ELEFTDIV:
        t = octave_value::op_el_ldiv;
        break;

      case EXPR_LT:
        t = octave_value::op_lt;
        break;

      case EXPR_LE:
        t = octave_value::op_le;
        break;

      case EXPR_EQ:
        t = octave_value::op_eq;
        break;

      case EXPR_GE:
        t = octave_value::op_ge;
        break;

      case EXPR_GT:
        t = octave_value::op_gt;
        break;

      case EXPR_NE:
        t = octave_value::op_ne;
        break;

      case EXPR_AND:
        t = octave_value::op_el_and;
        break;

      case EXPR_OR:
        t = octave_value::op_el_or;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return maybe_compound_binary_expression (op1, op2, l, c, t);
  }

  // Build a boolean expression.

  tree_expression *
  base_parser::make_boolean_op (int op, tree_expression *op1,
                                token *tok_val, tree_expression *op2)
  {
    tree_boolean_expression::type t;

    switch (op)
      {
      case EXPR_AND_AND:
        t = tree_boolean_expression::bool_and;
        break;

      case EXPR_OR_OR:
        t = tree_boolean_expression::bool_or;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_boolean_expression (op1, op2, l, c, t);
  }

  // Build a prefix expression.

  tree_expression *
  base_parser::make_prefix_op (int op, tree_expression *op1, token *tok_val)
  {
    octave_value::unary_op t = octave_value::unknown_unary_op;

    switch (op)
      {
      case EXPR_NOT:
        t = octave_value::op_not;
        break;

      case '+':
        t = octave_value::op_uplus;
        break;

      case '-':
        t = octave_value::op_uminus;
        break;

      case PLUS_PLUS:
        t = octave_value::op_incr;
        break;

      case MINUS_MINUS:
        t = octave_value::op_decr;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_prefix_expression (op1, l, c, t);
  }

  // Build a postfix expression.

  tree_expression *
  base_parser::make_postfix_op (int op, tree_expression *op1, token *tok_val)
  {
    octave_value::unary_op t = octave_value::unknown_unary_op;

    switch (op)
      {
      case HERMITIAN:
        t = octave_value::op_hermitian;
        break;

      case TRANSPOSE:
        t = octave_value::op_transpose;
        break;

      case PLUS_PLUS:
        t = octave_value::op_incr;
        break;

      case MINUS_MINUS:
        t = octave_value::op_decr;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = tok_val->line ();
    int c = tok_val->column ();

    return new tree_postfix_expression (op1, l, c, t);
  }

  // Build an unwind-protect command.

  tree_command *
  base_parser::make_unwind_command (token *unwind_tok,
                                    tree_statement_list *body,
                                    tree_statement_list *cleanup_stmts,
                                    token *end_tok,
                                    comment_list *lc,
                                    comment_list *mc)
  {
    tree_command *retval = nullptr;

    if (end_token_ok (end_tok, token::unwind_protect_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = unwind_tok->line ();
        int c = unwind_tok->column ();

        retval = new tree_unwind_protect_command (body, cleanup_stmts,
                                                  lc, mc, tc, l, c);
      }
    else
      {
        delete body;
        delete cleanup_stmts;

        end_token_error (end_tok, token::unwind_protect_end);
      }

    return retval;
  }

  // Build a try-catch command.

  tree_command *
  base_parser::make_try_command (token *try_tok,
                                 tree_statement_list *body,
                                 char catch_sep,
                                 tree_statement_list *cleanup_stmts,
                                 token *end_tok,
                                 comment_list *lc,
                                 comment_list *mc)
  {
    tree_command *retval = nullptr;

    if (end_token_ok (end_tok, token::try_catch_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = try_tok->line ();
        int c = try_tok->column ();

        tree_identifier *id = nullptr;

        if (! catch_sep && cleanup_stmts && ! cleanup_stmts->empty ())
          {
            tree_statement *stmt = cleanup_stmts->front ();

            if (stmt)
              {
                tree_expression *expr = stmt->expression ();

                if (expr && expr->is_identifier ())
                  {
                    id = dynamic_cast<tree_identifier *> (expr);

                    cleanup_stmts->pop_front ();

                    stmt->set_expression (nullptr);
                    delete stmt;
                  }
              }
          }

        retval = new tree_try_catch_command (body, cleanup_stmts, id,
                                             lc, mc, tc, l, c);
      }
    else
      {
        delete body;
        delete cleanup_stmts;

        end_token_error (end_tok, token::try_catch_end);
      }

    return retval;
  }

  // Build a while command.

  tree_command *
  base_parser::make_while_command (token *while_tok,
                                   tree_expression *expr,
                                   tree_statement_list *body,
                                   token *end_tok,
                                   comment_list *lc)
  {
    tree_command *retval = nullptr;

    maybe_warn_assign_as_truth_value (expr);

    if (end_token_ok (end_tok, token::while_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        m_lexer.m_looping--;

        int l = while_tok->line ();
        int c = while_tok->column ();

        retval = new tree_while_command (expr, body, lc, tc, l, c);
      }
    else
      {
        delete expr;
        delete body;

        end_token_error (end_tok, token::while_end);
      }

    return retval;
  }

  // Build a do-until command.

  tree_command *
  base_parser::make_do_until_command (token *until_tok,
                                      tree_statement_list *body,
                                      tree_expression *expr,
                                      comment_list *lc)
  {
    maybe_warn_assign_as_truth_value (expr);

    comment_list *tc = m_lexer.m_comment_buf.get_comment ();

    m_lexer.m_looping--;

    int l = until_tok->line ();
    int c = until_tok->column ();

    return new tree_do_until_command (expr, body, lc, tc, l, c);
  }

  // Build a for command.

  tree_command *
  base_parser::make_for_command (int tok_id, token *for_tok,
                                 tree_argument_list *lhs,
                                 tree_expression *expr,
                                 tree_expression *maxproc,
                                 tree_statement_list *body,
                                 token *end_tok,
                                 comment_list *lc)
  {
    tree_command *retval = nullptr;

    bool parfor = tok_id == PARFOR;

    if (end_token_ok (end_tok, parfor ? token::parfor_end : token::for_end))
      {
        expr->mark_as_for_cmd_expr ();

        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        m_lexer.m_looping--;

        int l = for_tok->line ();
        int c = for_tok->column ();

        if (lhs->length () == 1)
          {
            tree_expression *tmp = lhs->remove_front ();

            retval = new tree_simple_for_command (parfor, tmp, expr, maxproc,
                                                  body, lc, tc, l, c);

            delete lhs;
          }
        else
          {
            if (parfor)
              {
                delete lhs;
                delete expr;
                delete maxproc;
                delete body;

                bison_error ("invalid syntax for parfor statement");
              }
            else
              retval = new tree_complex_for_command (lhs, expr, body,
                                                     lc, tc, l, c);
          }
      }
    else
      {
        delete lhs;
        delete expr;
        delete maxproc;
        delete body;

        end_token_error (end_tok, parfor ? token::parfor_end : token::for_end);
      }

    return retval;
  }

  // Build a break command.

  tree_command *
  base_parser::make_break_command (token *break_tok)
  {
    int l = break_tok->line ();
    int c = break_tok->column ();

    if (! m_lexer.m_looping)
      {
        bison_error ("break must appear within a loop");
        return nullptr;
      }
    else
      return new tree_break_command (l, c);
  }

  // Build a continue command.

  tree_command *
  base_parser::make_continue_command (token *continue_tok)
  {
    int l = continue_tok->line ();
    int c = continue_tok->column ();

    if (! m_lexer.m_looping)
      {
        bison_error ("continue must appear within a loop");
        return nullptr;
      }
    else
      return new tree_continue_command (l, c);
  }

  // Build a return command.

  tree_command *
  base_parser::make_return_command (token *return_tok)
  {
    int l = return_tok->line ();
    int c = return_tok->column ();

    return new tree_return_command (l, c);
  }

  // Build an spmd command.

  tree_spmd_command *
  base_parser::make_spmd_command (token *spmd_tok, tree_statement_list *body,
                                  token *end_tok, comment_list *lc,
                                  comment_list *tc)
  {
    tree_spmd_command *retval = nullptr;

    if (end_token_ok (end_tok, token::spmd_end))
      {
        int l = spmd_tok->line ();
        int c = spmd_tok->column ();

        retval = new tree_spmd_command (body, lc, tc, l, c);
      }
    else
      {
        delete body;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::spmd_end);
      }

    return retval;
  }

  // Start an if command.

  tree_if_command_list *
  base_parser::start_if_command (tree_expression *expr,
                                 tree_statement_list *list)
  {
    maybe_warn_assign_as_truth_value (expr);

    tree_if_clause *t = new tree_if_clause (expr, list);

    return new tree_if_command_list (t);
  }

  // Finish an if command.

  tree_if_command *
  base_parser::finish_if_command (token *if_tok,
                                  tree_if_command_list *list,
                                  token *end_tok,
                                  comment_list *lc)
  {
    tree_if_command *retval = nullptr;

    if (end_token_ok (end_tok, token::if_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = if_tok->line ();
        int c = if_tok->column ();

        if (list && ! list->empty ())
          {
            tree_if_clause *elt = list->front ();

            if (elt)
              {
                elt->line (l);
                elt->column (c);
              }
          }

        retval = new tree_if_command (list, lc, tc, l, c);
      }
    else
      {
        delete list;

        end_token_error (end_tok, token::if_end);
      }

    return retval;
  }

  // Build an elseif clause.

  tree_if_clause *
  base_parser::make_elseif_clause (token *elseif_tok,
                                   tree_expression *expr,
                                   tree_statement_list *list,
                                   comment_list *lc)
  {
    maybe_warn_assign_as_truth_value (expr);

    int l = elseif_tok->line ();
    int c = elseif_tok->column ();

    return new tree_if_clause (expr, list, lc, l, c);
  }

  // Finish a switch command.

  tree_switch_command *
  base_parser::finish_switch_command (token *switch_tok,
                                      tree_expression *expr,
                                      tree_switch_case_list *list,
                                      token *end_tok,
                                      comment_list *lc)
  {
    tree_switch_command *retval = nullptr;

    if (end_token_ok (end_tok, token::switch_end))
      {
        comment_list *tc = m_lexer.m_comment_buf.get_comment ();

        int l = switch_tok->line ();
        int c = switch_tok->column ();

        if (list && ! list->empty ())
          {
            tree_switch_case *elt = list->front ();

            if (elt)
              {
                elt->line (l);
                elt->column (c);
              }
          }

        retval = new tree_switch_command (expr, list, lc, tc, l, c);
      }
    else
      {
        delete expr;
        delete list;

        end_token_error (end_tok, token::switch_end);
      }

    return retval;
  }

  // Build a switch case.

  tree_switch_case *
  base_parser::make_switch_case (token *case_tok,
                                 tree_expression *expr,
                                 tree_statement_list *list,
                                 comment_list *lc)
  {
    maybe_warn_variable_switch_label (expr);

    int l = case_tok->line ();
    int c = case_tok->column ();

    return new tree_switch_case (expr, list, lc, l, c);
  }

  // Build an assignment to a variable.

  tree_expression *
  base_parser::make_assign_op (int op, tree_argument_list *lhs,
                               token *eq_tok, tree_expression *rhs)
  {
    octave_value::assign_op t = octave_value::unknown_assign_op;

    switch (op)
      {
      case '=':
        t = octave_value::op_asn_eq;
        break;

      case ADD_EQ:
        t = octave_value::op_add_eq;
        break;

      case SUB_EQ:
        t = octave_value::op_sub_eq;
        break;

      case MUL_EQ:
        t = octave_value::op_mul_eq;
        break;

      case DIV_EQ:
        t = octave_value::op_div_eq;
        break;

      case LEFTDIV_EQ:
        t = octave_value::op_ldiv_eq;
        break;

      case POW_EQ:
        t = octave_value::op_pow_eq;
        break;

      case EMUL_EQ:
        t = octave_value::op_el_mul_eq;
        break;

      case EDIV_EQ:
        t = octave_value::op_el_div_eq;
        break;

      case ELEFTDIV_EQ:
        t = octave_value::op_el_ldiv_eq;
        break;

      case EPOW_EQ:
        t = octave_value::op_el_pow_eq;
        break;

      case AND_EQ:
        t = octave_value::op_el_and_eq;
        break;

      case OR_EQ:
        t = octave_value::op_el_or_eq;
        break;

      default:
        panic_impossible ();
        break;
      }

    int l = eq_tok->line ();
    int c = eq_tok->column ();

    if (! lhs->is_simple_assign_lhs () && t != octave_value::op_asn_eq)
      {
        // Multiple assignments like [x,y] OP= rhs are only valid for
        // '=', not '+=', etc.

        delete lhs;
        delete rhs;

        bison_error ("computed multiple assignment not allowed",
                     eq_tok->beg_pos ());

        return nullptr;
      }

    if (lhs->is_simple_assign_lhs ())
      {
        // We are looking at a simple assignment statement like x = rhs;

        tree_expression *tmp = lhs->remove_front ();

        if ((tmp->is_identifier () || tmp->is_index_expression ())
            && iskeyword (tmp->name ()))
          {
            std::string kw = tmp->name ();

            delete tmp;
            delete lhs;
            delete rhs;

            bison_error ("invalid assignment to keyword \"" + kw + "\"",
                         eq_tok->beg_pos ());

            return nullptr;
          }

        delete lhs;

        return new tree_simple_assignment (tmp, rhs, false, l, c, t);
      }
    else
      {
        std::list<std::string> names = lhs->variable_names ();

        for (const auto& kw : names)
          {
            if (iskeyword (kw))
              {
                delete lhs;
                delete rhs;

                bison_error ("invalid assignment to keyword \"" + kw + "\"",
                             eq_tok->beg_pos ());

                return nullptr;
              }
          }

        return new tree_multi_assignment (lhs, rhs, false, l, c);
      }
  }

  // Define a script.

  void
  base_parser::make_script (tree_statement_list *cmds,
                            tree_statement *end_script)
  {
    if (! cmds)
      cmds = new tree_statement_list ();

    cmds->append (end_script);

    symbol_scope script_scope = m_lexer.m_symtab_context.curr_scope ();

    script_scope.cache_name (m_lexer.m_fcn_file_full_name);
    script_scope.cache_fcn_file_name (m_lexer.m_fcn_file_full_name);
    script_scope.cache_dir_name (m_lexer.m_dir_name);

    octave_user_script *script
      = new octave_user_script (m_lexer.m_fcn_file_full_name,
                                m_lexer.m_fcn_file_name, script_scope,
                                cmds, m_lexer.m_help_text);

    m_lexer.m_symtab_context.pop ();
    m_lexer.m_help_text = "";

    sys::time now;

    script->stash_fcn_file_time (now);
    script->stash_dir_name (m_lexer.m_dir_name);

    m_primary_fcn = octave_value (script);
  }

  tree_identifier *
  base_parser::make_fcn_name (tree_identifier *id)
  {
    std::string id_name = id->name ();

    // Make classdef local functions unique from classdef methods.

    if (m_parsing_local_functions && m_curr_fcn_depth == 0)
      id_name = m_lexer.m_fcn_file_name + ">" + id_name;

    if (! m_function_scopes.name_current_scope (id_name))
      {
        bison_error ("duplicate subfunction or nested function name",
                     id->line (), id->column ());

        delete id;
        return nullptr;
      }

    octave::symbol_scope curr_scope = m_lexer.m_symtab_context.curr_scope ();
    curr_scope.cache_name (id_name);

    m_lexer.m_parsed_function_name.top () = true;
    m_lexer.m_maybe_classdef_get_set_method = false;

    return id;
  }

  // Define a function.

  // FIXME: combining start_function, finish_function, and
  // recover_from_parsing_function should be possible, but it makes
  // for a large mess.  Maybe this could be a bit better organized?

  tree_function_def *
  base_parser::make_function (token *fcn_tok,
                              tree_parameter_list *ret_list,
                              tree_identifier *id,
                              tree_parameter_list *param_list,
                              tree_statement_list *body,
                              tree_statement *end_fcn_stmt,
                              comment_list *lc)
  {
    int l = fcn_tok->line ();
    int c = fcn_tok->column ();

    octave_user_function *tmp_fcn
      = start_function (id, param_list, body, end_fcn_stmt);

    tree_function_def *retval = finish_function (ret_list, tmp_fcn, lc, l, c);

    recover_from_parsing_function ();

    return retval;
  }

  // Begin defining a function.

  octave_user_function *
  base_parser::start_function (tree_identifier *id,
                               tree_parameter_list *param_list,
                               tree_statement_list *body,
                               tree_statement *end_fcn_stmt)
  {
    // We'll fill in the return list later.

    std::string id_name = id->name ();

    delete id;

    if (m_lexer.m_parsing_classdef_get_method)
      id_name.insert (0, "get.");
    else if (m_lexer.m_parsing_classdef_set_method)
      id_name.insert (0, "set.");

    m_lexer.m_parsing_classdef_get_method = false;
    m_lexer.m_parsing_classdef_set_method = false;

    if (! body)
      body = new tree_statement_list ();

    body->append (end_fcn_stmt);

    octave_user_function *fcn
      = new octave_user_function (m_lexer.m_symtab_context.curr_scope (),
                                  param_list, nullptr, body);

    comment_list *tc = m_lexer.m_comment_buf.get_comment ();

    fcn->stash_trailing_comment (tc);
    fcn->stash_fcn_end_location (end_fcn_stmt->line (),
                                 end_fcn_stmt->column ());

    // If input is coming from a file, issue a warning if the name of
    // the file does not match the name of the function stated in the
    // file.  Matlab doesn't provide a diagnostic (it ignores the stated
    // name).
    if (! m_autoloading && m_lexer.m_reading_fcn_file
        && m_curr_fcn_depth == 0 && ! m_parsing_subfunctions)
      {
        // FIXME: should m_lexer.m_fcn_file_name already be
        // preprocessed when we get here?  It seems to only be a
        // problem with relative filenames.

        std::string nm = m_lexer.m_fcn_file_name;

        size_t pos = nm.find_last_of (sys::file_ops::dir_sep_chars ());

        if (pos != std::string::npos)
          nm = m_lexer.m_fcn_file_name.substr (pos+1);

        if (nm != id_name)
          {
            warning_with_id
              ("Octave:function-name-clash",
               "function name '%s' does not agree with function filename '%s'",
               id_name.c_str (), m_lexer.m_fcn_file_full_name.c_str ());

            id_name = nm;
          }
      }

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_classdef_file || m_autoloading)
      {
        sys::time now;

        fcn->stash_fcn_file_name (m_lexer.m_fcn_file_full_name);
        fcn->stash_fcn_file_time (now);
        fcn->stash_dir_name (m_lexer.m_dir_name);
        fcn->stash_package_name (m_lexer.m_package_name);
        fcn->mark_as_system_fcn_file ();

        if (m_fcn_file_from_relative_lookup)
          fcn->mark_relative ();

        if (m_lexer.m_parsing_class_method)
          {
            if (m_lexer.m_parsing_classdef)
              {
                if (m_curr_class_name == id_name)
                  fcn->mark_as_classdef_constructor ();
                else
                  fcn->mark_as_classdef_method ();
              }
            else
              {
                if (m_curr_class_name == id_name)
                  fcn->mark_as_legacy_constructor ();
                else
                  fcn->mark_as_legacy_method ();
              }

            fcn->stash_dispatch_class (m_curr_class_name);
          }

        std::string nm = fcn->fcn_file_name ();

        sys::file_stat fs (nm);

        if (fs && fs.is_newer (now))
          warning_with_id ("Octave:future-time-stamp",
                           "time stamp for '%s' is in the future", nm.c_str ());
      }
    else if (! m_lexer.input_from_tmp_history_file ()
             && ! m_lexer.m_force_script
             && m_lexer.m_reading_script_file
             && m_lexer.m_fcn_file_name == id_name)
      {
        warning ("function '%s' defined within script file '%s'",
                 id_name.c_str (), m_lexer.m_fcn_file_full_name.c_str ());
      }

    fcn->stash_function_name (id_name);

    // Record help text for functions other than nested functions.
    // We cannot currently record help for nested functions (bug #46008)
    // because the doc_string of the outermost function is read first,
    // whereas this function is called for the innermost function first.
    // We could have a stack of help_text in lexer.
    if (! m_lexer.m_help_text.empty () && m_curr_fcn_depth == 0)
      {
        fcn->document (m_lexer.m_help_text);

        m_lexer.m_help_text = "";
      }

    if (m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
      m_primary_fcn = octave_value (fcn);

    return fcn;
  }

  tree_statement *
  base_parser::make_end (const std::string& type, bool eof,
                         const filepos& beg_pos, const filepos& /*end_pos*/)
  {
    int l = beg_pos.line ();
    int c = beg_pos.column ();

    return make_statement (new tree_no_op_command (type, eof, l, c));
  }

  tree_function_def *
  base_parser::finish_function (tree_parameter_list *ret_list,
                                octave_user_function *fcn,
                                comment_list *lc,
                                int l, int c)
  {
    tree_function_def *retval = nullptr;

    if (! ret_list)
      ret_list = new tree_parameter_list (tree_parameter_list::out);

    ret_list->mark_as_formal_parameters ();

    if (fcn)
      {
        std::string fcn_nm = fcn->name ();
        std::string file = fcn->fcn_file_name ();

        std::string tmp = fcn_nm;
        if (! file.empty ())
          tmp += ": " + file;

        symbol_scope fcn_scope = fcn->scope ();
        fcn_scope.cache_name (tmp);
        fcn_scope.cache_fcn_name (fcn_nm);
        fcn_scope.cache_fcn_file_name (file);
        fcn_scope.cache_dir_name (m_lexer.m_dir_name);

        if (lc)
          fcn->stash_leading_comment (lc);

        fcn->define_ret_list (ret_list);

        if (m_curr_fcn_depth > 0 || m_parsing_subfunctions)
          {
            fcn->stash_fcn_location (l, c);
            fcn->stash_parent_fcn_name (m_lexer.m_fcn_file_name);

            octave_value ov_fcn (fcn);

            if (m_endfunction_found && m_function_scopes.size () > 1)
              {
                fcn->mark_as_nested_function ();
                fcn_scope.set_nesting_depth (m_curr_fcn_depth);

                symbol_scope pscope = m_function_scopes.parent_scope ();
                fcn_scope.set_parent (pscope);
                fcn_scope.set_primary_parent (m_primary_fcn_scope);
                pscope.install_nestfunction (fcn_nm, ov_fcn, fcn_scope);

                // For nested functions, the list of parent functions is
                // set in symbol_scope::update_nest.
              }
            else
              {
                fcn->mark_as_subfunction ();
                m_subfunction_names.push_back (fcn_nm);
                fcn_scope.set_parent (m_primary_fcn_scope);
                if (m_parsing_subfunctions)
                  fcn_scope.set_primary_parent (m_primary_fcn_scope);
                m_primary_fcn_scope.install_subfunction (fcn_nm, ov_fcn);

                // Prepend name of primary fucntion to list of parent
                // functions (if any) for subfunction.

                std::list<std::string> plst
                  = fcn_scope.parent_fcn_names ();
                plst.push_front (m_primary_fcn_scope.fcn_name ());
                fcn_scope.cache_parent_fcn_names (plst);
              }
          }

        if (m_curr_fcn_depth == 0)
          fcn_scope.update_nest ();

        if (! m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0)
          {
            // We are either reading a script file or defining a function
            // at the command line, so this definition creates a
            // tree_function object that is placed in the parse tree.
            // Otherwise, it is just inserted in the symbol table,
            // either as a subfunction or nested function (see above),
            // or as the primary function for the file, via
            // m_primary_fcn (see also load_fcn_from_file,,
            // parse_fcn_file, and
            // fcn_info::fcn_info_rep::find_user_function).

            if (m_lexer.m_buffer_function_text)
              {
                fcn->cache_function_text (m_lexer.m_function_text,
                                          fcn->time_parsed ());
                m_lexer.m_buffer_function_text = false;
              }

            retval = new tree_function_def (fcn);
          }
      }

    return retval;
  }

  void
  base_parser::recover_from_parsing_function (void)
  {
    m_lexer.m_symtab_context.pop ();

    if (m_lexer.m_reading_fcn_file && m_curr_fcn_depth == 0
        && ! m_parsing_subfunctions)
      m_parsing_subfunctions = true;

    m_curr_fcn_depth--;
    m_function_scopes.pop ();

    m_lexer.m_defining_func--;
    m_lexer.m_parsed_function_name.pop ();
    m_lexer.m_looking_at_return_list = false;
    m_lexer.m_looking_at_parameter_list = false;
  }

  // A CLASSDEF block defines a class that has a constructor and other
  // methods, but it is not an executable command.  Parsing the block
  // makes some changes in the symbol table (inserting the constructor
  // and methods, and adding to the list of known objects) and creates
  // a parse tree containing meta information about the class.

  // LC contains comments appearing before the classdef keyword.
  // TC contains comments appearing between the classdef elements
  // and the final end token for the classdef block.

  tree_classdef *
  base_parser::make_classdef (token *tok_val,
                              tree_classdef_attribute_list *a,
                              tree_identifier *id,
                              tree_classdef_superclass_list *sc,
                              tree_classdef_body *body, token *end_tok,
                              comment_list *lc, comment_list *tc)
  {
    tree_classdef *retval = nullptr;

    m_lexer.m_symtab_context.pop ();

    std::string cls_name = id->name ();

    std::string nm = m_lexer.m_fcn_file_name;

    size_t pos = nm.find_last_of (sys::file_ops::dir_sep_chars ());

    if (pos != std::string::npos)
      nm = m_lexer.m_fcn_file_name.substr (pos+1);

    if (nm != cls_name)
      {
        int l = id->line ();
        int c = id->column ();

        delete a;
        delete id;
        delete sc;
        delete body;
        delete lc;
        delete tc;

        bison_error ("invalid classdef definition, the class name must match the filename", l, c);

      }
    else
      {
        if (end_token_ok (end_tok, token::classdef_end))
          {
            int l = tok_val->line ();
            int c = tok_val->column ();

            if (! body)
              body = new tree_classdef_body ();

            retval = new tree_classdef (m_lexer.m_symtab_context.curr_scope (),
                                        a, id, sc, body, lc, tc,
                                        m_curr_package_name, l, c);
          }
        else
          {
            delete a;
            delete id;
            delete sc;
            delete body;
            delete lc;
            delete tc;

            end_token_error (end_tok, token::switch_end);
          }
      }

    return retval;
  }

  // LC contains comments appearing before the properties keyword.
  // If this properties block appears first in the list of classdef
  // elements, this comment list will be used for the help text for the
  // classdef block.

  // TC contains comments appearing between the list of properties
  // and the final end token for the properties block and may be used to
  // find the doc string for the final property in the list.

  tree_classdef_properties_block *
  base_parser::make_classdef_properties_block (token *tok_val,
                                               tree_classdef_attribute_list *a,
                                               tree_classdef_property_list *plist,
                                               token *end_tok,
                                               comment_list *lc,
                                               comment_list *tc)
  {
    tree_classdef_properties_block *retval = nullptr;

    if (end_token_ok (end_tok, token::properties_end))
      {
        int l = tok_val->line ();
        int c = tok_val->column ();

        if (plist)
          {
            // If the element at the end of the list doesn't have a doc
            // string, see whether the first element of TC is an
            // end-of-line comment for us to use.

            if (tc)
              {
                tree_classdef_property *last_elt = plist->back ();

                if (! last_elt->have_doc_string ())
                  {
                    comment_elt first_comment_elt = tc->front ();

                    if (first_comment_elt.is_end_of_line ())
                      {
                        std::string eol_comment = first_comment_elt.text ();

                        last_elt->doc_string (eol_comment);
                      }
                  }
              }
          }
        else
          plist = new tree_classdef_property_list ();

        retval = new tree_classdef_properties_block (a, plist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete plist;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::properties_end);
      }

    return retval;
  }

  // LC contains comments appearing before the methods keyword.
  // If this methods block appears first in the list of classdef
  // elements, this comment list will be used for the help text for the
  // classdef block.

  tree_classdef_methods_block *
  base_parser::make_classdef_methods_block (token *tok_val,
                                            tree_classdef_attribute_list *a,
                                            tree_classdef_methods_list *mlist,
                                            token *end_tok, comment_list *lc,
                                            comment_list *tc)
  {
    tree_classdef_methods_block *retval = nullptr;

    if (end_token_ok (end_tok, token::methods_end))
      {
        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! mlist)
          mlist = new tree_classdef_methods_list ();

        retval = new tree_classdef_methods_block (a, mlist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete mlist;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::methods_end);
      }

    return retval;
  }

  // LC contains comments appearing before the events keyword.
  // If this events block appears first in the list of classdef
  // elements, this comment list will be used for the help text for the
  // classdef block.

  // TC contains comments appearing between the list of events and
  // the final end token for the events block and may be used to find
  // the doc string for the final event in the list.

  tree_classdef_events_block *
  base_parser::make_classdef_events_block (token *tok_val,
                                           tree_classdef_attribute_list *a,
                                           tree_classdef_events_list *elist,
                                           token *end_tok,
                                           comment_list *lc,
                                           comment_list *tc)
  {
    tree_classdef_events_block *retval = nullptr;

    if (end_token_ok (end_tok, token::events_end))
      {
        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! elist)
          elist = new tree_classdef_events_list ();

        retval = new tree_classdef_events_block (a, elist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete elist;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::events_end);
      }

    return retval;
  }

  // LC contains comments appearing before the enumeration keyword.
  // If this enumeration block appears first in the list of classdef
  // elements, this comment list will be used for the help text for the
  // classdef block.

  // TC contains comments appearing between the list of
  // enumerations and the final end token for the enumeration block and
  // may be used to find the doc string for the final enumeration in the
  // list.

  tree_classdef_enum_block *
  base_parser::make_classdef_enum_block (token *tok_val,
                                         tree_classdef_attribute_list *a,
                                         tree_classdef_enum_list *elist,
                                         token *end_tok,
                                         comment_list *lc,
                                         comment_list *tc)
  {
    tree_classdef_enum_block *retval = nullptr;

    if (end_token_ok (end_tok, token::enumeration_end))
      {
        int l = tok_val->line ();
        int c = tok_val->column ();

        if (! elist)
          elist = new tree_classdef_enum_list ();

        retval = new tree_classdef_enum_block (a, elist, lc, tc, l, c);
      }
    else
      {
        delete a;
        delete elist;
        delete lc;
        delete tc;

        end_token_error (end_tok, token::enumeration_end);
      }

    return retval;
  }

  octave_user_function*
  base_parser::start_classdef_external_method (tree_identifier *id,
                                               tree_parameter_list *pl)
  {
    octave_user_function* retval = nullptr;

    // External methods are only allowed within @-folders. In this case,
    // m_curr_class_name will be non-empty.

    if (! m_curr_class_name.empty ())
      {

        std::string mname = id->name ();

        // Methods that cannot be declared outside the classdef file:
        // - methods with '.' character (e.g. property accessors)
        // - class constructor
        // - 'delete'

        if (mname.find_first_of (".") == std::string::npos
            && mname != "delete"
            && mname != m_curr_class_name)
          {
            // Create a dummy function that is used until the real method
            // is loaded.

            retval = new octave_user_function (symbol_scope (), pl);

            retval->stash_function_name (mname);

            int l = id->line ();
            int c = id->column ();

            retval->stash_fcn_location (l, c);
          }
        else
          bison_error ("invalid external method declaration, an external "
                       "method cannot be the class constructor, 'delete' "
                       "or have a dot (.) character in its name");
      }
    else
      bison_error ("external methods are only allowed in @-folders");

    if (! retval)
      delete id;

    return retval;
  }

  tree_function_def *
  base_parser::finish_classdef_external_method (octave_user_function *fcn,
                                                tree_parameter_list *ret_list,
                                                comment_list *cl)
  {
    if (! ret_list)
      ret_list = new tree_parameter_list (tree_parameter_list::out);

    fcn->define_ret_list (ret_list);

    if (cl)
      fcn->stash_leading_comment (cl);

    int l = fcn->beginning_line ();
    int c = fcn->beginning_column ();

    return new tree_function_def (fcn, l, c);
  }

  void
  base_parser::finish_classdef_file (tree_classdef *cls,
                                     tree_statement_list *local_fcns)
  {
    if (m_lexer.m_reading_classdef_file)
      m_classdef_object = std::shared_ptr<tree_classdef> (cls);

    if (local_fcns)
      {
        symbol_table& symtab
          = __get_symbol_table__ ("base_parser::finish_classdef_file");

        for (tree_statement *elt : *local_fcns)
          {
            tree_command *cmd = elt->command ();

            tree_function_def *fcn_def
              = dynamic_cast<tree_function_def *> (cmd);

            octave_value ov_fcn = fcn_def->function ();
            octave_function *fcn = ov_fcn.function_value ();
            std::string nm = fcn->name ();
            std::string file = fcn->fcn_file_name ();

            symtab.install_local_function (nm, ov_fcn, file);
          }

        delete local_fcns;
      }
  }

  // Make an index expression.

  tree_index_expression *
  base_parser::make_index_expression (tree_expression *expr,
                                      tree_argument_list *args,
                                      char type)
  {
    tree_index_expression *retval = nullptr;

    if (args && args->has_magic_tilde ())
      {
        delete expr;
        delete args;

        bison_error ("invalid use of empty argument (~) in index expression");
      }
    else
      {
        int l = expr->line ();
        int c = expr->column ();

        if (! expr->is_postfix_indexed ())
          expr->set_postfix_index (type);

        if (expr->is_index_expression ())
          {
            tree_index_expression *tmp
              = dynamic_cast<tree_index_expression *> (expr);

            tmp->append (args, type);

            retval = tmp;
          }
        else
          retval = new tree_index_expression (expr, args, l, c, type);
      }

    return retval;
  }

  // Make an indirect reference expression.

  tree_index_expression *
  base_parser::make_indirect_ref (tree_expression *expr,
                                  const std::string& elt)
  {
    tree_index_expression *retval = nullptr;

    int l = expr->line ();
    int c = expr->column ();

    if (! expr->is_postfix_indexed ())
      expr->set_postfix_index ('.');

    if (expr->is_index_expression ())
      {
        tree_index_expression *tmp
          = dynamic_cast<tree_index_expression *> (expr);

        tmp->append (elt);

        retval = tmp;
      }
    else
      retval = new tree_index_expression (expr, elt, l, c);

    m_lexer.m_looking_at_indirect_ref = false;

    return retval;
  }

  // Make an indirect reference expression with dynamic field name.

  tree_index_expression *
  base_parser::make_indirect_ref (tree_expression *expr,
                                  tree_expression *elt)
  {
    tree_index_expression *retval = nullptr;

    int l = expr->line ();
    int c = expr->column ();

    if (! expr->is_postfix_indexed ())
      expr->set_postfix_index ('.');

    if (expr->is_index_expression ())
      {
        tree_index_expression *tmp
          = dynamic_cast<tree_index_expression *> (expr);

        tmp->append (elt);

        retval = tmp;
      }
    else
      retval = new tree_index_expression (expr, elt, l, c);

    m_lexer.m_looking_at_indirect_ref = false;

    return retval;
  }

  // Make a declaration command.

  tree_decl_command *
  base_parser::make_decl_command (int tok, token *tok_val,
                                  tree_decl_init_list *lst)
  {
    tree_decl_command *retval = nullptr;

    int l = tok_val->line ();
    int c = tok_val->column ();

    if (lst)
      m_lexer.mark_as_variables (lst->variable_names ());

    switch (tok)
      {
      case GLOBAL:
        {
          retval = new tree_decl_command ("global", lst, l, c);
          retval->mark_global ();
        }
        break;

      case PERSISTENT:
        if (m_curr_fcn_depth >= 0)
          {
            retval = new tree_decl_command ("persistent", lst, l, c);
            retval->mark_persistent ();
          }
        else
          {
            if (m_lexer.m_reading_script_file)
              warning ("ignoring persistent declaration near line %d of file '%s'",
                       l, m_lexer.m_fcn_file_full_name.c_str ());
            else
              warning ("ignoring persistent declaration near line %d", l);
          }
        break;

      default:
        panic_impossible ();
        break;
      }

    return retval;
  }

  bool
  base_parser::validate_param_list (tree_parameter_list *lst,
                                    tree_parameter_list::in_or_out type)
  {
    std::set<std::string> dict;

    for (tree_decl_elt *elt : *lst)
      {
        tree_identifier *id = elt->ident ();

        if (id)
          {
            std::string name = id->name ();

            if (id->is_black_hole ())
              {
                if (type != tree_parameter_list::in)
                  {
                    bison_error ("invalid use of ~ in output list");
                    return false;
                  }
              }
            else if (dict.find (name) != dict.end ())
              {
                bison_error ("'" + name
                             + "' appears more than once in parameter list");
                return false;
              }
            else
              dict.insert (name);
          }
      }

    std::string va_type = (type == tree_parameter_list::in
                           ? "varargin" : "varargout");

    size_t len = lst->length ();

    if (len > 0)
      {
        tree_decl_elt *elt = lst->back ();

        tree_identifier *id = elt->ident ();

        if (id && id->name () == va_type)
          {
            if (len == 1)
              lst->mark_varargs_only ();
            else
              lst->mark_varargs ();

            tree_parameter_list::iterator p = lst->end ();
            --p;
            delete *p;
            lst->erase (p);
          }
      }

    return true;
  }

  bool
  base_parser::validate_array_list (tree_expression *e)
  {
    bool retval = true;

    tree_array_list *al = dynamic_cast<tree_array_list *> (e);

    for (tree_argument_list* row : *al)
      {
        if (row && row->has_magic_tilde ())
          {
            retval = false;

            if (e->is_matrix ())
              bison_error ("invalid use of tilde (~) in matrix expression");
            else
              bison_error ("invalid use of tilde (~) in cell expression");

            break;
          }
      }

    return retval;
  }

  tree_argument_list *
  base_parser::validate_matrix_for_assignment (tree_expression *e)
  {
    tree_argument_list *retval = nullptr;

    if (e->is_constant ())
      {
        tree_evaluator& tw
          = __get_evaluator__ ("validate_matrix_for_assignment");

        octave_value ov = e->evaluate (tw);

        delete e;

        if (ov.isempty ())
          bison_error ("invalid empty left hand side of assignment");
        else
          bison_error ("invalid constant left hand side of assignment");
      }
    else
      {
        bool is_simple_assign = true;

        tree_argument_list *tmp = nullptr;

        if (e->is_matrix ())
          {
            tree_matrix *mat = dynamic_cast<tree_matrix *> (e);

            if (mat && mat->size () == 1)
              {
                tmp = mat->front ();
                mat->pop_front ();
                delete e;
                is_simple_assign = false;
              }
          }
        else
          tmp = new tree_argument_list (e);

        if (tmp && tmp->is_valid_lvalue_list ())
          {
            m_lexer.mark_as_variables (tmp->variable_names ());
            retval = tmp;
          }
        else
          {
            delete tmp;

            bison_error ("invalid left hand side of assignment");
          }

        if (retval && is_simple_assign)
          retval->mark_as_simple_assign_lhs ();
      }

    return retval;
  }

  // Finish building an array_list.

  tree_expression *
  base_parser::finish_array_list (tree_array_list *array_list,
                                  token */*open_delim*/, token *close_delim)
  {
    tree_expression *retval = array_list;

    array_list->set_location (close_delim->line (), close_delim->column ());

    if (array_list->all_elements_are_constant ())
      {
        interpreter& interp = __get_interpreter__ ("finish_array_list");

        try
          {
            // If the evaluation generates a warning message, restore
            // the previous value of last_warning_message and skip the
            // conversion to a constant value.

            unwind_protect frame;

            error_system& es = interp.get_error_system ();

            frame.add_method (es, &error_system::set_last_warning_message,
                              es.last_warning_message (""));

            frame.add_method (es, &error_system::set_discard_warning_messages,
                              es.discard_warning_messages (true));

            tree_evaluator& tw = interp.get_evaluator ();

            octave_value tmp = array_list->evaluate (tw);

            std::string msg = es.last_warning_message ();

            if (msg.empty ())
              {
                tree_constant *tc_retval
                  = new tree_constant (tmp, close_delim->line (),
                                       close_delim->column ());

                std::ostringstream buf;

                tree_print_code tpc (buf);

                array_list->accept (tpc);

                tc_retval->stash_original_text (buf.str ());

                delete array_list;

                retval = tc_retval;
              }
          }
        catch (const execution_exception&)
          {
            interp.recover_from_exception ();
          }
      }

    return retval;
  }

  // Finish building a matrix list.

  tree_expression *
  base_parser::finish_matrix (tree_matrix *m, token *open_delim,
                              token *close_delim)
  {
    return (m
            ? finish_array_list (m, open_delim, close_delim)
            : new tree_constant (octave_null_matrix::instance,
                                 close_delim->line (), close_delim->column ()));
  }

  // Finish building a cell list.

  tree_expression *
  base_parser::finish_cell (tree_cell *c, token *open_delim,
                            token *close_delim)
  {
    return (c
            ? finish_array_list (c, open_delim, close_delim)
            : new tree_constant (octave_value (Cell ()),
                                 close_delim->line (), close_delim->column ()));
  }

  tree_statement_list *
  base_parser::set_stmt_print_flag (tree_statement_list *list,
                                    char sep, bool warn_missing_semi)
  {
    tree_statement *tmp = list->back ();

    switch (sep)
      {
      case ';':
        tmp->set_print_flag (false);
        break;

      case 0:
      case ',':
      case '\n':
        tmp->set_print_flag (true);
        if (warn_missing_semi)
          maybe_warn_missing_semi (list);
        break;

      default:
        warning ("unrecognized separator type!");
        break;
      }

    // Even if a statement is null, we add it to the list then remove it
    // here so that the print flag is applied to the correct statement.

    if (tmp->is_null_statement ())
      {
        list->pop_back ();
        delete tmp;
      }

    return list;
  }

  // Finish building a statement.
  template <typename T>
  tree_statement *
  base_parser::make_statement (T *arg)
  {
    comment_list *comment = m_lexer.get_comment ();

    return new tree_statement (arg, comment);
  }

  tree_statement_list *
  base_parser::make_statement_list (tree_statement *stmt)
  {
    return new tree_statement_list (stmt);
  }

  tree_statement_list *
  base_parser::append_statement_list (tree_statement_list *list,
                                      char sep, tree_statement *stmt,
                                      bool warn_missing_semi)
  {
    set_stmt_print_flag (list, sep, warn_missing_semi);

    list->append (stmt);

    return list;
  }

  void
  base_parser::disallow_command_syntax (void)
  {
    m_lexer.m_allow_command_syntax = false;
  }

  // FIXME: this function partially duplicates do_dbtype in debug.cc.
  static std::string
  get_file_line (const std::string& name, int line)
  {
    // NAME should be an absolute file name and the file should exist.

    std::ifstream fs = sys::ifstream (name.c_str (), std::ios::in);

    std::string text;

    if (fs)
      {
        int i = 1;

        do
          {
            if (! std::getline (fs, text))
              {
                text = "";
                break;
              }
          }
        while (i++ < line);
      }

    return text;
  }

  void
  base_parser::bison_error (const std::string& str)
  {
    bison_error (str, m_lexer.m_filepos);
  }

  void
  base_parser::bison_error (const std::string& str, const filepos& pos)
  {
    bison_error (str, pos.line (), pos.column ());
  }

  void
  base_parser::bison_error (const std::string& str, int err_line, int err_col)
  {
    std::ostringstream output_buf;

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_script_file
        || m_lexer.m_reading_classdef_file)
      output_buf << "parse error near line " << err_line
                 << " of file " << m_lexer.m_fcn_file_full_name;
    else
      output_buf << "parse error:";

    if (str != "parse error")
      output_buf << "\n\n  " << str;

    output_buf << "\n\n";

    std::string curr_line;

    if (m_lexer.m_reading_fcn_file || m_lexer.m_reading_script_file
        || m_lexer.m_reading_classdef_file)
      curr_line = get_file_line (m_lexer.m_fcn_file_full_name, err_line);
    else
      curr_line = m_lexer.m_current_input_line;

    // Adjust the error column for display because it is 1-based in the
    // lexer for easier reporting.
    err_col--;

    if (! curr_line.empty ())
      {
        // FIXME: we could do better if we just cached lines from the
        // input file in a list.  See also functions for managing input
        // buffers in lex.ll.

        size_t len = curr_line.length ();

        if (curr_line[len-1] == '\n')
          curr_line.resize (len-1);

        // Print the line, maybe with a pointer near the error token.

        output_buf << ">>> " << curr_line << "\n";

        if (err_col == 0)
          err_col = len;

        for (int i = 0; i < err_col + 3; i++)
          output_buf << " ";

        output_buf << "^";
      }

    output_buf << "\n";

    m_parse_error_msg = output_buf.str ();
  }

  int
  parser::run (void)
  {
    int status = -1;

    yypstate *pstate = static_cast<yypstate *> (m_parser_state);

    try
      {
        status = octave_pull_parse (pstate, *this);
      }
    catch (const execution_exception&)
      {
        // FIXME: In previous versions, we emitted a parse error here
        // but that is not always correct because the error could have
        // happened inside a GUI callback functions executing in the
        // readline event_hook loop.  Maybe we need a separate exception
        // class for parse errors?

        throw;
      }
    catch (const exit_exception&)
      {
        throw;
      }
    catch (const interrupt_exception&)
      {
        throw;
      }
    catch (...)
      {
        std::string file = m_lexer.m_fcn_file_full_name;

        if (file.empty ())
          error ("unexpected exception while parsing input");
        else
          error ("unexpected exception while parsing %s", file.c_str ());
      }

    if (status != 0)
      parse_error ("%s", m_parse_error_msg.c_str ());

    return status;
  }

  // Parse input from INPUT.  Pass TRUE for EOF if the end of INPUT should
  // finish the parse.

  int
  push_parser::run (const std::string& input, bool eof)
  {
    int status = -1;

    dynamic_cast<push_lexer&> (m_lexer).append_input (input, eof);

    do
      {
        YYSTYPE lval;

        int token = octave_lex (&lval, m_lexer.m_scanner);

        if (token < 0)
          {
            // TOKEN == -2 means that the lexer recognized a comment
            // and we should be at the end of the buffer but not the
            // end of the file so we should return 0 to indicate
            // "complete input" instead of -1 to request more input.

            status = (token == -2 ? 0 : -1);

            if (! eof && m_lexer.at_end_of_buffer ())
              return status;

            break;
          }

        yypstate *pstate = static_cast<yypstate *> (m_parser_state);

        try
          {
            status = octave_push_parse (pstate, token, &lval, *this);
          }
        catch (execution_exception& e)
          {
            std::string file = m_lexer.m_fcn_file_full_name;

            if (file.empty ())
              error (e, "parse error");
            else
              error (e, "parse error in %s", file.c_str ());
          }
        catch (const exit_exception&)
          {
            throw;
          }
        catch (interrupt_exception &)
          {
            throw;
          }
        catch (...)
          {
            std::string file = m_lexer.m_fcn_file_full_name;

            if (file.empty ())
              error ("unexpected exception while parsing input");
            else
              error ("unexpected exception while parsing %s", file.c_str ());
          }
      }
    while (status == YYPUSH_MORE || ! m_lexer.at_end_of_buffer ());

    if (status != 0)
      parse_error ("%s", m_parse_error_msg.c_str ());

    return status;
  }

  int
  push_parser::run (void)
  {
    if (! m_reader)
      error ("push_parser::run requires valid input_reader");

    int exit_status = 0;

    input_system&  input_sys = m_interpreter.get_input_system ();

    std::string prompt
      = command_editor::decode_prompt_string (input_sys.PS1 ());

    do
      {
        // Reset status each time through the read loop so that
        // it won't be set to -1 and cause us to exit the outer
        // loop early if there is an exception while reading
        // input or parsing.

        exit_status = 0;

        bool eof = false;
        std::string input_line = m_reader->get_input (prompt, eof);

        if (eof)
          {
            exit_status = EOF;
            break;
          }

        exit_status = run (input_line, false);

        prompt = command_editor::decode_prompt_string (input_sys.PS2 ());
      }
    while (exit_status < 0);

    return exit_status;
  }

  octave_value
  parse_fcn_file (interpreter& interp, const std::string& full_file,
                  const std::string& file, const std::string& dir_name,
                  const std::string& dispatch_type,
                  const std::string& package_name, bool require_file,
                  bool force_script, bool autoload, bool relative_lookup)
  {
    octave_value retval;

    FILE *ffile = nullptr;

    if (! full_file.empty ())
    {
      // Check that m-file is not overly large which can segfault interpreter.
      const int max_file_size = 512 * 1024 * 1024;  // 512 MB
      sys::file_stat fs (full_file);

      if (fs && fs.size () > max_file_size)
        {
          error ("file '%s' is too large, > 512 MB", full_file.c_str ());

          return octave_value ();
        }

      ffile = sys::fopen (full_file, "rb");
    }

    if (! ffile)
      {
        if (require_file)
          error ("no such file, '%s'", full_file.c_str ());

        return octave_value ();
      }

    unwind_action act ([ffile] (void)
                       {
                         fclose (ffile);
                       });

    parser parser (ffile, interp);

    parser.m_curr_class_name = dispatch_type;
    parser.m_curr_package_name = package_name;
    parser.m_autoloading = autoload;
    parser.m_fcn_file_from_relative_lookup = relative_lookup;

    parser.m_lexer.m_force_script = force_script;
    parser.m_lexer.prep_for_file ();
    parser.m_lexer.m_parsing_class_method = ! dispatch_type.empty ();

    parser.m_lexer.m_fcn_file_name = file;
    parser.m_lexer.m_fcn_file_full_name = full_file;
    parser.m_lexer.m_dir_name = dir_name;
    parser.m_lexer.m_package_name = package_name;

    int err = parser.run ();

    if (err)
      error ("parse error while reading file %s", full_file.c_str ());

    octave_value ov_fcn = parser.m_primary_fcn;

    if (parser.m_lexer.m_reading_classdef_file
        && parser.classdef_object ())
      {
        // Convert parse tree for classdef object to
        // meta.class info (and stash it in the symbol
        // table?).  Return pointer to constructor?

        if (ov_fcn.is_defined ())
          panic_impossible ();

        bool is_at_folder = ! dispatch_type.empty ();

        std::shared_ptr<tree_classdef> cdef_obj
          = parser.classdef_object();

        return cdef_obj->make_meta_class (interp, is_at_folder);
      }
    else if (ov_fcn.is_defined ())
      {
        octave_function *fcn = ov_fcn.function_value ();

        fcn->maybe_relocate_end ();

        if (parser.m_parsing_subfunctions)
          {
            if (! parser.m_endfunction_found)
              parser.m_subfunction_names.reverse ();

            fcn->stash_subfunction_names (parser.m_subfunction_names);
          }

        return ov_fcn;
      }

    return octave_value ();
  }

  // Maybe print a warning if an assignment expression is used as the
  // test in a logical expression.

  void
  base_parser::maybe_warn_assign_as_truth_value (tree_expression *expr)
  {
    if (expr->is_assignment_expression ()
        && expr->paren_count () < 2)
      {
        if (m_lexer.m_fcn_file_full_name.empty ())
          warning_with_id
            ("Octave:assign-as-truth-value",
             "suggest parenthesis around assignment used as truth value");
        else
          warning_with_id
            ("Octave:assign-as-truth-value",
             "suggest parenthesis around assignment used as truth value near line %d, column %d in file '%s'",
             expr->line (), expr->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  // Maybe print a warning about switch labels that aren't constants.

  void
  base_parser::maybe_warn_variable_switch_label (tree_expression *expr)
  {
    if (! expr->is_constant ())
      {
        if (m_lexer.m_fcn_file_full_name.empty ())
          warning_with_id ("Octave:variable-switch-label",
                           "variable switch label");
        else
          warning_with_id
            ("Octave:variable-switch-label",
             "variable switch label near line %d, column %d in file '%s'",
             expr->line (), expr->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  void
  base_parser::maybe_warn_missing_semi (tree_statement_list *t)
  {
    if (m_curr_fcn_depth >= 0)
      {
        tree_statement *tmp = t->back ();

        if (tmp->is_expression ())
          warning_with_id
            ("Octave:missing-semicolon",
             "missing semicolon near line %d, column %d in file '%s'",
             tmp->line (), tmp->column (), m_lexer.m_fcn_file_full_name.c_str ());
      }
  }

  std::string
  get_help_from_file (const std::string& nm, bool& symbol_found,
                      std::string& full_file)
  {
    std::string retval;

    full_file = fcn_file_in_path (nm);

    std::string file = full_file;

    size_t file_len = file.length ();

    if ((file_len > 4 && file.substr (file_len-4) == ".oct")
        || (file_len > 4 && file.substr (file_len-4) == ".mex")
        || (file_len > 2 && file.substr (file_len-2) == ".m"))
      {
        file = sys::env::base_pathname (file);
        file = file.substr (0, file.find_last_of ('.'));

        size_t pos = file.find_last_of (sys::file_ops::dir_sep_str ());
        if (pos != std::string::npos)
          file = file.substr (pos+1);
      }

    if (! file.empty ())
      {
        interpreter& interp = __get_interpreter__ ("get_help_from_file");

        symbol_found = true;

        octave_value ov_fcn
          = parse_fcn_file (interp, full_file, file, "", "", "", true,
                            false, false, false);

        if (ov_fcn.is_defined ())
          {
            octave_function *fcn = ov_fcn.function_value ();

            if (fcn)
              retval = fcn->doc_string ();
          }
      }

    return retval;
  }

  std::string
  get_help_from_file (const std::string& nm, bool& symbol_found)
  {
    std::string file;
    return get_help_from_file (nm, symbol_found, file);
  }

  octave_value
  load_fcn_from_file (const std::string& file_name,
                      const std::string& dir_name,
                      const std::string& dispatch_type,
                      const std::string& package_name,
                      const std::string& fcn_name, bool autoload)
  {
    octave_value retval;

    unwind_protect frame;

    std::string nm = file_name;

    size_t nm_len = nm.length ();

    std::string file;

    bool relative_lookup = false;

    file = nm;

    if ((nm_len > 4 && nm.substr (nm_len-4) == ".oct")
        || (nm_len > 4 && nm.substr (nm_len-4) == ".mex")
        || (nm_len > 2 && nm.substr (nm_len-2) == ".m"))
      {
        nm = sys::env::base_pathname (file);
        nm = nm.substr (0, nm.find_last_of ('.'));

        size_t pos = nm.find_last_of (sys::file_ops::dir_sep_str ());
        if (pos != std::string::npos)
          nm = nm.substr (pos+1);
      }

    relative_lookup = ! sys::env::absolute_pathname (file);

    file = sys::env::make_absolute (file);

    int len = file.length ();

    interpreter& interp = __get_interpreter__ ("load_fcn_from_file");

    dynamic_loader& dyn_loader = interp.get_dynamic_loader ();

    if (len > 4 && file.substr (len-4, len-1) == ".oct")
      {
        if (autoload && ! fcn_name.empty ())
          nm = fcn_name;

        octave_function *tmpfcn
          = dyn_loader.load_oct (nm, file, relative_lookup);

        if (tmpfcn)
          {
            tmpfcn->stash_package_name (package_name);
            retval = octave_value (tmpfcn);
          }
      }
    else if (len > 4 && file.substr (len-4, len-1) == ".mex")
      {
        // Temporarily load m-file version of mex-file, if it exists,
        // to get the help-string to use.

        std::string doc_string;

        octave_value ov_fcn
          = parse_fcn_file (interp, file.substr (0, len - 2), nm, dir_name,
                            dispatch_type, package_name, false,
                            autoload, autoload, relative_lookup);

        if (ov_fcn.is_defined ())
          {
            octave_function *tmpfcn = ov_fcn.function_value ();

            if (tmpfcn)
              doc_string = tmpfcn->doc_string ();
          }

        octave_function *tmpfcn
          = dyn_loader.load_mex (nm, file, relative_lookup);

        if (tmpfcn)
          {
            tmpfcn->document (doc_string);
            tmpfcn->stash_package_name (package_name);

            retval = octave_value (tmpfcn);
          }
      }
    else if (len > 2)
      {
        retval = parse_fcn_file (interp, file, nm, dir_name,
                                 dispatch_type, package_name, true,
                                 autoload, autoload, relative_lookup);
      }

    return retval;
  }
}

DEFMETHOD (autoload, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {@var{autoload_map} =} autoload ()
@deftypefnx {} {} autoload (@var{function}, @var{file})
@deftypefnx {} {} autoload (@dots{}, "remove")
Define @var{function} to autoload from @var{file}.

The second argument, @var{file}, should be an absolute filename or a file
name in the same directory as the function or script from which the autoload
command was run.  @var{file} @emph{should not} depend on the Octave load
path.

Normally, calls to @code{autoload} appear in PKG_ADD script files that are
evaluated when a directory is added to Octave's load path.  To avoid having
to hardcode directory names in @var{file}, if @var{file} is in the same
directory as the PKG_ADD script then

@example
autoload ("foo", "bar.oct");
@end example

@noindent
will load the function @code{foo} from the file @code{bar.oct}.  The above
usage when @code{bar.oct} is not in the same directory, or usages such as

@example
autoload ("foo", file_in_loadpath ("bar.oct"))
@end example

@noindent
are strongly discouraged, as their behavior may be unpredictable.

With no arguments, return a structure containing the current autoload map.

If a third argument @qcode{"remove"} is given, the function is cleared and
not loaded anymore during the current Octave session.

@seealso{PKG_ADD}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin == 1 || nargin > 3)
    print_usage ();

  octave::tree_evaluator& tw = interp.get_evaluator ();

  if (nargin == 0)
    return octave_value (tw.get_autoload_map ());
  else
    {
      string_vector argv = args.make_argv ("autoload");

      if (nargin == 2)
        tw.add_autoload (argv[1], argv[2]);
      else if (nargin == 3)
        {
          if (argv[3] != "remove")
            error_with_id ("Octave:invalid-input-arg",
                           "autoload: third argument can only be 'remove'");

          tw.remove_autoload (argv[1], argv[2]);
        }
    }

  return octave_value_list ();
}

DEFMETHOD (mfilename, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} mfilename ()
@deftypefnx {} {} mfilename ("fullpath")
@deftypefnx {} {} mfilename ("fullpathext")
Return the name of the currently executing file.

The base name of the currently executing script or function is returned without
any extension.  If called from outside an m-file, such as the command line,
return the empty string.

Given the argument @qcode{"fullpath"}, include the directory part of the
filename, but not the extension.

Given the argument @qcode{"fullpathext"}, include the directory part of
the filename and the extension.
@seealso{inputname, dbstack}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin > 1)
    print_usage ();

  std::string opt;

  if (nargin == 1)
    opt = args(0).xstring_value ("mfilename: option argument must be a string");

  return octave_value (interp.mfilename (opt));
}

namespace octave
{
  // Execute the contents of a script file.  For compatibility with
  // Matlab, also execute a function file by calling the function it
  // defines with no arguments and nargout = 0.

  void
  source_file (const std::string& file_name, const std::string& context,
               bool verbose, bool require_file)
  {
    interpreter& interp = __get_interpreter__ ("source_file");

    interp.source_file (file_name, context, verbose, require_file);
  }
}

DEFMETHOD (source, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} source (@var{file})
@deftypefnx {} {} source (@var{file}, @var{context})
Parse and execute the contents of @var{file}.

Without specifying @var{context}, this is equivalent to executing commands
from a script file, but without requiring the file to be named
@file{@var{file}.m} or to be on the execution path.

Instead of the current context, the script may be executed in either the
context of the function that called the present function
(@qcode{"caller"}), or the top-level context (@qcode{"base"}).
@seealso{run}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  std::string file_name
    = args(0).xstring_value ("source: FILE must be a string");

  std::string context;
  if (nargin == 2)
    context = args(1).xstring_value ("source: CONTEXT must be a string");

  interp.source_file (file_name, context);

  return octave_value_list ();
}

namespace octave
{
  //! Evaluate an Octave function (built-in or interpreted) and return
  //! the list of result values.
  //!
  //! @param name The name of the function to call.
  //! @param args The arguments to the function.
  //! @param nargout The number of output arguments expected.
  //! @return A list of output values.  The length of the list is not
  //!         necessarily the same as @c nargout.

  octave_value_list
  feval (const char *name, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (name, args, nargout);
  }

  octave_value_list
  feval (const std::string& name, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (name, args, nargout);
  }

  octave_value_list
  feval (octave_function *fcn, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (fcn, args, nargout);
  }

  octave_value_list
  feval (const octave_value& val, const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (val, args, nargout);
  }

  octave_value_list
  feval (const octave_value_list& args, int nargout)
  {
    interpreter& interp = __get_interpreter__ ("feval");

    return interp.feval (args, nargout);
  }
}

DEFMETHOD (feval, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn {} {} feval (@var{name}, @dots{})
Evaluate the function named @var{name}.

Any arguments after the first are passed as inputs to the named function.
For example,

@example
@group
feval ("acos", -1)
     @result{} 3.1416
@end group
@end example

@noindent
calls the function @code{acos} with the argument @samp{-1}.

The function @code{feval} can also be used with function handles of any sort
(@pxref{Function Handles}).  Historically, @code{feval} was the only way to
call user-supplied functions in strings, but function handles are now
preferred due to the cleaner syntax they offer.  For example,

@example
@group
@var{f} = @@exp;
feval (@var{f}, 1)
    @result{} 2.7183
@var{f} (1)
    @result{} 2.7183
@end group
@end example

@noindent
are equivalent ways to call the function referred to by @var{f}.  If it
cannot be predicted beforehand whether @var{f} is a function handle,
function name in a string, or inline function then @code{feval} can be used
instead.
@end deftypefn */)
{
  if (args.length () == 0)
    print_usage ();

  return interp.feval (args, nargout);
}

DEFMETHOD (builtin, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn {} {[@dots{}] =} builtin (@var{f}, @dots{})
Call the base function @var{f} even if @var{f} is overloaded to another
function for the given type signature.

This is normally useful when doing object-oriented programming and there is
a requirement to call one of Octave's base functions rather than the
overloaded one of a new class.

A trivial example which redefines the @code{sin} function to be the
@code{cos} function shows how @code{builtin} works.

@example
@group
sin (0)
  @result{} 0
function y = sin (x), y = cos (x); endfunction
sin (0)
  @result{} 1
builtin ("sin", 0)
  @result{} 0
@end group
@end example
@end deftypefn */)
{
  octave_value_list retval;

  if (args.length () == 0)
    print_usage ();

  const std::string name (args(0).xstring_value ("builtin: function name (F) must be a string"));

  octave::symbol_table& symtab = interp.get_symbol_table ();

  octave_value fcn = symtab.builtin_find (name);

  if (fcn.is_defined ())
    retval = interp.feval (fcn.function_value (), args.splice (0, 1), nargout);
  else
    error ("builtin: lookup for symbol '%s' failed", name.c_str ());

  return retval;
}

namespace octave
{
  void
  cleanup_statement_list (tree_statement_list **lst)
  {
    if (*lst)
      {
        delete *lst;
        *lst = nullptr;
      }
  }
}

DEFMETHOD (eval, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} eval (@var{try})
@deftypefnx {} {} eval (@var{try}, @var{catch})
Parse the string @var{try} and evaluate it as if it were an Octave
program.

If execution fails, evaluate the optional string @var{catch}.

The string @var{try} is evaluated in the current context, so any results
remain available after @code{eval} returns.

The following example creates the variable @var{A} with the approximate
value of 3.1416 in the current workspace.

@example
eval ("A = acos(-1);");
@end example

If an error occurs during the evaluation of @var{try} then the @var{catch}
string is evaluated, as the following example shows:

@example
@group
eval ('error ("This is a bad example");',
      'printf ("This error occurred:\n%s\n", lasterr ());');
     @print{} This error occurred:
        This is a bad example
@end group
@end example

Programming Note: if you are only using @code{eval} as an error-capturing
mechanism, rather than for the execution of arbitrary code strings,
Consider using try/catch blocks or unwind_protect/unwind_protect_cleanup
blocks instead.  These techniques have higher performance and don't
introduce the security considerations that the evaluation of arbitrary code
does.
@seealso{evalin, evalc, assignin, feval}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  if (! args(0).is_string () || args(0).rows () > 1 || args(0).ndims () != 2)
    error ("eval: TRY must be a string");

  std::string try_code = args(0).string_value ();

  if (nargin == 1)
    return interp.eval (try_code, nargout);
  else
    {
      if (! args(1).is_string () || args(1).rows () > 1
          || args(1).ndims () != 2)
        error ("eval: CATCH must be a string");

      std::string catch_code = args(1).string_value ();

      return interp.eval (try_code, catch_code, nargout);
    }
}

/*

%!shared x
%! x = 1;

%!assert (eval ("x"), 1)
%!assert (eval ("x;"))
%!assert (eval ("x;"), 1)

%!test
%! y = eval ("x");
%! assert (y, 1);

%!test
%! y = eval ("x;");
%! assert (y, 1);

%!test
%! eval ("x = 1;");
%! assert (x,1);

%!test
%! eval ("flipud = 2;");
%! assert (flipud, 2);

%!function y = __f ()
%!  eval ("flipud = 2;");
%!  y = flipud;
%!endfunction
%!assert (__f(), 2)

%!test <*35645>
%! [a,] = gcd (1,2);
%! [a,b,] = gcd (1, 2);

## Can't assign to a keyword
%!error eval ("switch = 13;")

%!shared str
%! str = "disp ('hello');";
%! str(:,:,2) = str(:,:,1);

%!error <TRY must be a string> eval (1)
%!error <TRY must be a string> eval (['a';'b'])
%!error <TRY must be a string> eval (str)

%!error <CATCH must be a string> eval (str(:,:,1), 1)
%!error <CATCH must be a string> eval (str(:,:,1), ['a';'b'])
%!error <CATCH must be a string> eval (str(:,:,1), str)

*/

DEFMETHOD (assignin, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn {} {} assignin (@var{context}, @var{varname}, @var{value})
Assign @var{value} to @var{varname} in context @var{context}, which
may be either @qcode{"base"} or @qcode{"caller"}.
@seealso{evalin}
@end deftypefn */)
{
  if (args.length () != 3)
    print_usage ();

  std::string context
    = args(0).xstring_value ("assignin: CONTEXT must be a string");

  std::string varname
    = args(1).xstring_value ("assignin: VARNAME must be a string");

  interp.assignin (context, varname, args(2));

  return octave_value_list ();
}

/*

%!error assignin ("base", "switch", "13")

*/

DEFMETHOD (evalin, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {} evalin (@var{context}, @var{try})
@deftypefnx {} {} evalin (@var{context}, @var{try}, @var{catch})
Like @code{eval}, except that the expressions are evaluated in the context
@var{context}, which may be either @qcode{"caller"} or @qcode{"base"}.
@seealso{eval, assignin}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin < 2 || nargin > 3)
    print_usage ();

  std::string context
    = args(0).xstring_value ("evalin: CONTEXT must be a string");

  std::string try_code
    = args(1).xstring_value ("evalin: TRY must be a string");

  if (nargin == 3)
    {
      std::string catch_code
        = args(2).xstring_value ("evalin: CATCH must be a string");

      return interp.evalin (context, try_code, catch_code, nargout);
    }

  return interp.evalin (context, try_code, nargout);
}

DEFMETHOD (evalc, interp, args, nargout,
           doc: /* -*- texinfo -*-
@deftypefn  {} {@var{s} =} evalc (@var{try})
@deftypefnx {} {@var{s} =} evalc (@var{try}, @var{catch})
Parse and evaluate the string @var{try} as if it were an Octave program,
while capturing the output into the return variable @var{s}.

If execution fails, evaluate the optional string @var{catch}.

This function behaves like @code{eval}, but any output or warning messages
which would normally be written to the console are captured and returned in
the string @var{s}.

The @code{diary} is disabled during the execution of this function.  When
@code{system} is used, any output produced by external programs is
@emph{not} captured, unless their output is captured by the @code{system}
function itself.

@example
@group
s = evalc ("t = 42"), t
  @result{} s = t =  42

  @result{} t =  42
@end group
@end example
@seealso{eval, diary}
@end deftypefn */)
{
  int nargin = args.length ();

  if (nargin == 0 || nargin > 2)
    print_usage ();

  // Flush pending output and redirect stdout/stderr to capturing
  // buffer.

  octave_stdout.flush ();
  std::cerr.flush ();

  std::stringbuf buffer;

  std::streambuf *old_out_buf = octave_stdout.rdbuf (&buffer);
  std::streambuf *old_err_buf = std::cerr.rdbuf (&buffer);

  // Restore previous output buffers no matter how control exits this
  // function.  There's no need to flush here.  That has already
  // happened for the normal execution path.  If an error happens during
  // the eval, then the message is stored in the exception object and we
  // will display it later, after the buffers have been restored.

  octave::unwind_action act ([old_out_buf, old_err_buf] (void)
                             {
                               octave_stdout.rdbuf (old_out_buf);
                               std::cerr.rdbuf (old_err_buf);
                             });

  // Call standard eval function.

  int eval_nargout = std::max (0, nargout - 1);

  octave_value_list retval = Feval (interp, args, eval_nargout);

  // Make sure we capture all pending output.

  octave_stdout.flush ();
  std::cerr.flush ();

  retval.prepend (buffer.str ());

  return retval;
}

/*

%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   str = evalc ("1");
%!   assert (str, "ans = 1\n");
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!assert (evalc ("1;"), "")

%!test
%! [s, y] = evalc ("1");
%! assert (s, "");
%! assert (y, 1);

%!test
%! [s, y] = evalc ("1;");
%! assert (s, "");
%! assert (y, 1);

%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   str = evalc ("y = 2");
%!   assert (str, "y = 2\n");
%!   assert (y, 2);
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!test
%! assert (evalc ("y = 3;"), "");
%! assert (y, 3);

%!test
%! [s, a, b] = evalc ("deal (1, 2)");
%! assert (s, "");
%! assert (a, 1);
%! assert (b, 2);

%!function [a, b] = __f_evalc ()
%!  printf ("foo");
%!  fprintf (stdout, "bar ");
%!  disp (pi);
%!  a = 1;
%!  b = 2;
%!endfunction
%!test
%! [old_fmt, old_spacing] = format ();
%! unwind_protect
%!   format short;
%!   [s, a, b] = evalc ("__f_evalc ()");
%!   assert (s, "foobar 3.1416\n");
%!   assert (a, 1);
%!   assert (b, 2);
%! unwind_protect_cleanup
%!   format (old_fmt);
%!   format (old_spacing);
%! end_unwind_protect

%!error <foo> (evalc ("error ('foo')"))
%!error <bar> (evalc ("error ('foo')", "error ('bar')"))

%!test
%! warning ("off", "quiet", "local");
%! str = evalc ("warning ('foo')");
%! assert (str(1:13), "warning: foo\n");

%!test
%! warning ("off", "quiet", "local");
%! str = evalc ("error ('foo')", "warning ('bar')");
%! assert (str(1:13), "warning: bar\n");

%!error evalc ("switch = 13;")

*/

DEFUN (__parser_debug_flag__, args, nargout,
       doc: /* -*- texinfo -*-
@deftypefn  {} {@var{val} =} __parser_debug_flag__ ()
@deftypefnx {} {@var{old_val} =} __parser_debug_flag__ (@var{new_val})
Query or set the internal flag that determines whether Octave's parser
prints debug information as it processes an expression.
@seealso{__lexer_debug_flag__}
@end deftypefn */)
{
  octave_value retval;

  bool debug_flag = octave_debug;

  retval = set_internal_variable (debug_flag, args, nargout,
                                  "__parser_debug_flag__");

  octave_debug = debug_flag;

  return retval;
}

DEFMETHOD (__parse_file__, interp, args, ,
           doc: /* -*- texinfo -*-
@deftypefn {} {} __parse_file__ (@var{file}, @var{verbose})
Undocumented internal function.
@end deftypefn */)
{
  octave_value retval;

  int nargin = args.length ();

  if (nargin < 1 || nargin > 2)
    print_usage ();

  std::string file = args(0).xstring_value ("__parse_file__: expecting filename as argument");

  std::string full_file
      = octave::sys::file_ops::tilde_expand (file);

  full_file = octave::sys::env::make_absolute (full_file);

  std::string dir_name;

  size_t file_len = file.length ();

  if ((file_len > 4 && file.substr (file_len-4) == ".oct")
      || (file_len > 4 && file.substr (file_len-4) == ".mex")
      || (file_len > 2 && file.substr (file_len-2) == ".m"))
    {
      file = octave::sys::env::base_pathname (file);
      file = file.substr (0, file.find_last_of ('.'));

      size_t pos = file.find_last_of (octave::sys::file_ops::dir_sep_str ());
      if (pos != std::string::npos)
        {
          dir_name = file.substr (0, pos);
          file = file.substr (pos+1);
        }
    }

  if (nargin == 2)
    octave_stdout << "parsing " << full_file << std::endl;

  octave_value ov_fcn
    = parse_fcn_file (interp, full_file, file, dir_name, "", "", true,
                      false, false, false);

  return retval;
}
